(***************************************************************************)
(**                             UNIT BOXCMD.PAS                           **)
(***************************************************************************)
(**  Oft benutzte Mailbox-Befehle, die deshalb nicht als Overlay          **)
(**  deklariert werden sollten.                                           **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXCMD;


INTERFACE

PROCEDURE Usage(ch: BYTE; S: STRING);
PROCEDURE List(ch: BYTE; S: STRING; Weiter: BOOLEAN);
PROCEDURE DIR(ch: BYTE; S: STRING);
PROCEDURE READ_CMD(ch: BYTE; S: STRING);
PROCEDURE NEXT_CMD(ch: BYTE; S: STRING);
PROCEDURE Erase_CMD(ch: BYTE; S: STRING);
PROCEDURE Box_QUIT(ch: BYTE);
PROCEDURE Box_BYE(ch: BYTE; ShutDown: BOOLEAN);
PROCEDURE Kopf_CMD(ch: BYTE; S: STRING);
PROCEDURE CHECK_CMD(ch: BYTE; S: STRING; Weiter: BOOLEAN);


IMPLEMENTATION

USES
     BOXHUSER,IADVAR,BOXUTIL,TOOLBOX,BOXVARS,DOS,MCUTLIB2,BOXMAIN;


{U-Befehl (eigentlich Usage)}
PROCEDURE Usage(ch: BYTE; S: STRING);
VAR b: BYTE;
    hlp,hlp1: STRING;
    Da, OK: BOOLEAN;
    U: R_UserFile;
    DT: DateTime;
    i: WORD;
    SetInfo: BYTE;
    AktTime: LONGINT;
BEGIN

  AktTime := CurrIxTime;

  IF S[LENGTH(S)]=#13 THEN S := COPY(S,1,LENGTH(S)-1);
  S := Gross(S);

  IF POS(' ',S)=0 THEN S := ''
                  ELSE S := COPY(S,POS(' ',S)+1,255);

  {Kein Parameter - aktuelle User der Mailbox anzeigen}
  IF S = '' THEN BEGIN
    PutData(ch,#13+'User:'+#13+'      Login    Idle'+#13);
    FOR b := 0 TO 255 DO BEGIN
      IF KS[b] <> NIL THEN BEGIN
        IF (KS[b]^.status >= 50) AND (KS[b]^.status <= 100) THEN BEGIN
          STR(b,hlp);
          IF b<10 THEN hlp := '0' + hlp;
          if b<100 THEN hlp := '0' + hlp;
          hlp1 := CutSSID(KS[b]^.Call);
          FOR i := 0 TO 5 DO IF LENGTH(Hlp1) = i THEN Hlp1 := Hlp1 + ' ';
          IF KS[ch]^.Status=50 THEN
          BEGIN
            WITH KS[b]^.BoxData^ DO
               PutData(ch,' ('+hlp+') '+MkTStr(AktTime-LoginTime)+' '+MkTStr(AktTime-LastSendTime)+'  '+hlp1+'    ');
          END ELSE
            WITH KS[b]^ DO
               PutData(ch,' ('+hlp+') '+MkTStr(AktTime-Create)+' '+MkTStr(AktTime-IdleSince)+' '+hlp1+'    ');
          CASE KS[b]^.status OF
            50: CASE KS[b]^.BoxData^.status OF
                     0: IF KS[b]^.TxW > 0 THEN PutData(ch,'read')
                                          ELSE PutData(ch,'idle');
                  1..3: PutData(ch,'send');
                     4: PutData(ch,'set_options');
                END;
            51: PutData(ch,'S&F (DB)');
            52: PutData(ch,'S&F (FBB)');
            60: PutData(ch,'S&F LinkSetup');
          END;
          PutData(ch,#13);
        END;
      END;
    END;
    PutData(ch,#13);
    Exit;
  END;

  Da := GetUser(OK,U,S);
  IF NOT Da THEN BEGIN
    PutData(ch,#13+CutSSID(S)+': '+SysText(ch,17)+#13#13);
    Exit;
  END;

  {Fileformat von USER.BOX ist falsch (alt oder sonstiges)}
  IF NOT OK THEN BEGIN
    PutData(ch,#13+SysText(ch,16)+#13#13);
    Exit;
  END;

  PutData(ch,#13+SysText(ch,18)+' '+CutSSID(S)+':'+#13);
  PutData(ch,SysText(ch,19)+' '+U.MYBBS+Hierachie(U.MYBBS)+#13);     {MYBBS}
  PutData(ch,SysText(ch,20)+' '+U.Name+#13);       {Name}

  {Letztes QUIT}
  UnpackTime(U.LastQuit,DT);
  STR(DT.Day,hlp);
  STR(DT.Month,hlp1);
  IF DT.Day < 10 THEN hlp := '0' + Hlp;
  IF DT.Month < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + '.' + hlp1 + '.';
  STR(DT.Year,hlp1);
  hlp := Hlp + hlp1 + ' ';
  STR(DT.Hour,hlp1);
  IF DT.Hour < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1 + ':';
  STR(DT.Min,hlp1);
  IF DT.Min < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1;
  PutData(ch,SysText(ch,21)+' '+hlp+#13);

  {Lastlogin}
  UnpackTime(U.LastLogin,DT);
  STR(DT.Day,hlp);
  STR(DT.Month,hlp1);
  IF DT.Day < 10 THEN hlp := '0' + Hlp;
  IF DT.Month < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + '.' + hlp1 + '.';
  STR(DT.Year,hlp1);
  hlp := Hlp + hlp1 + ' ';
  STR(DT.Hour,hlp1);
  IF DT.Hour < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1 + ':';
  STR(DT.Min,hlp1);
  IF DT.Min < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1;
  PutData(ch,SysText(ch,22)+' '+hlp+#13);

  {Zeile mit der Anzahl gesendeter, empfangener etc mails}
  hlp := SysText(ch,28) + ' ';
  STR(U.Anz_Logins,hlp1);
  hlp := hlp + hlp1 + ', '+SysText(ch,29) + ' ';
  STR(U.Anz_Rec,hlp1);
  hlp := hlp + hlp1 + ', '+SysText(ch,30) + ' ';
  STR(U.Anz_Read,hlp1);
  hlp := hlp + hlp1 + ', '+SysText(ch,31) + ' ';
  STR(U.Anz_Send,hlp1);
  hlp := hlp + hlp1;
  PutData(ch,hlp+#13#13);

END;


{Inhalt von ein Rubriken listen}
PROCEDURE List(ch: BYTE; S: STRING; Weiter: BOOLEAN);
VAR Start,Stop: WORD;
    Rubrik: STRING[8];
    Roger,Neu,IsZahl,OK: BOOLEAN;
    i,anz: WORD;
    VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
    RXDate,LastQuit: LONGINT;
    DT: DateTime;
    Lock: BYTE;
    Hlp: STRING;
    ShowDel: BOOLEAN;
    AnzSent: WORD;
BEGIN
  IF NOT Weiter THEN BEGIN
    {Evtl. RETURN abschneiden}
    IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
    IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

    IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                      ELSE S := '';
    S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));

    {Check nach dem Parameter -D (Deleted Mails anzeigen)}
    ShowDel := FALSE;
    IF LENGTH(S)>0 THEN BEGIN
      IF POS(' ',S) > 0 THEN Hlp := COPY(S,1,POS(' ',S)-1)
                        ELSE Hlp := S;
      IF Hlp='-D' THEN BEGIN
        ShowDel := TRUE;
        IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                          ELSE S := '';
      END;
    END;


    IF LENGTH(S) = 0 THEN BEGIN
      Start := 1;
      Stop := 65535;
      Rubrik := KS[ch]^.BoxData^.Rubrik;
      Neu := TRUE;
    END
    ELSE BEGIN
      IF POS(' ',S) > 0 THEN BEGIN        {Leerzeichen vorhanden -> es kommt
                                           noch was (Zahlen)}
        Rubrik := COPY(S,1,POS(' ',S)-1);
        S := COPY(S,POS(' ',S)+1,255);

        {Leerzeichen aus dem String 'raus}
        FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

        IF POS('-',S) > 0 THEN BEGIN
          Neu := FALSE;
          VAL(COPY(S,1,POS('-',S)-1),Start,i);
          IF i <> 0 THEN Start := 1;
          VAL(COPY(S,POS('-',S)+1,255),Stop,i);
          IF i <> 0 THEN Stop := 65535;
        END
        ELSE BEGIN
          Neu := FALSE;
          VAL(S,Start,i);
          Stop := Start;
        END;
      END
      ELSE BEGIN
        IsZahl := TRUE;
        FOR i := 1 TO LENGTH(S) DO BEGIN
          IF NOT (S[i] IN ['0'..'9','-']) THEN IsZahl := FALSE;
        END;

        IF IsZahl THEN BEGIN
          Rubrik := KS[ch]^.BoxData^.Rubrik;
          {Leerzeichen aus dem String 'raus}
          FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

          IF POS('-',S) > 0 THEN BEGIN
            Neu := FALSE;
            VAL(COPY(S,1,POS('-',S)-1),Start,i);
            IF i <> 0 THEN Start := 1;
            VAL(COPY(S,POS('-',S)+1,255),Stop,i);
            IF i <> 0 THEN Stop := 65535;
          END
          ELSE BEGIN
            Neu := FALSE;
            VAL(S,Start,i);
            Stop := Start;
          END;
        END
        ELSE BEGIN
          Rubrik := S;
          Neu := TRUE;
          Start := 1;
          Stop := 65535;
        END;
      END;
    END;


    Rubrik := Gross(Rubrik);
    IF (LENGTH(Rubrik)=1) AND NOT (KS[ch]^.Lev>10) THEN BEGIN
      PutData(ch,'Keine Mails vorhanden fr Rubrik '+Rubrik+'.'+#13#13);
      Exit;
    END;


    Lock := GetReadLockInfo(Rubrik);
    IF is_friend(rubrik,CutSSid(KS[ch]^.Call)) THEN
      lock:=0;
    KS[ch]^.BoxData^.Rubrik := Rubrik;
(*    IF (Lock=2) AND NOT (KS[ch]^.Lev>10) AND (Gross(Rubrik)<>CutSSID(KS[ch]^.Call)) THEN BEGIN
{      PutData(ch,'Keine Mails vorhanden fr Rubrik '+Rubrik+'.'+#13#13);}
      PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+'.'+#13#13);
      Exit;
    END;

 *)
    {LastQuit-Datum und Zeit holen und nach Unixzeit convertieren}
    Lastquit := GetLastQuit(OK,CutSSID(KS[ch]^.Call));
    IF NOT OK THEN LastQuit := 0;
    UnpackTime(LastQuit,DT);
    WITH DT DO LastQuit := calc_ixtime(day,month,year-1900,hour,min,sec);

    new(KS[ch]^.BoxData^.ListAusgabe);
    WITH KS[ch]^.BoxData^ DO BEGIN
      ListAusgabe^.Start := Start;
      ListAusgabe^.Stop := Stop;
      ListAusgabe^.Aktuell := Start;
      ListAusgabe^.Rubrik := Rubrik;
      ListAusgabe^.Flags := 0;
      ListAusgabe^.Anz := 0;
      ListAusgabe^.Lock := Lock;
      IF Neu THEN ListAusgabe^.Flags := ListAusgabe^.Flags OR LST_NEU;
      IF ShowDel THEN ListAusgabe^.Flags := ListAusgabe^.Flags OR LST_DEL;
    END;
    KS[ch]^.status := 81;
  END;


  ASSIGN(VerFile,BoxPath+'index'+path_sep+klein(KS[ch]^.BoxData^.ListAusgabe^.Rubrik)+'.idx');
  {$I-}
  RESET(VerFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    dispose(KS[ch]^.BoxData^.ListAusgabe);
    KS[ch]^.BoxData^.ListAusgabe := NIL;
    KS[ch]^.status := 50;
    Exit;
  END;


  WITH KS[ch]^.BoxData^ DO BEGIN
    AnzSent := 0;       {In dieser Session wurde noch nix gesendet}

    i := ListAusgabe^.Aktuell - 1;
    WHILE (i < ListAusgabe^.Stop) DO BEGIN
      i := i + 1;
      SEEK(VerFile,i-1);

      IF EOF(VerFile) THEN BEGIN
        IF ListAusgabe^.anz>0 THEN BEGIN
          PutData(ch,#13);
          CLOSE(VerFile);
          dispose(KS[ch]^.BoxData^.ListAusgabe);
          KS[ch]^.BoxData^.ListAusgabe := NIL;
          KS[ch]^.status := 50;
          Exit;
        END;
        ListAusgabe^.OK := FALSE;
        i := FILESIZE(VerFile)-1;
        SEEK(Verfile,0);
        WHILE NOT ListAusgabe^.OK AND NOT EOF(VerFile) AND (i>-1) DO BEGIN
          SEEK(VerFile,i);
          IF NOT EOF(VerFile) THEN BEGIN
            READ(VerFile,Ver);

            {Kontrolle, ob Zeile angezeigt wird}
            Roger := FALSE;
            IF KS[ch]^.Lev>10 THEN Roger := TRUE;
            IF ListAusgabe^.Lock=0 THEN Roger := TRUE;
            IF NOT Rufz(ListAusgabe^.Rubrik) THEN Roger := TRUE
            ELSE BEGIN
              {Usermail - ReadLock beachten}
              {Der Absender darfs lesen, iad mai 96}
              IF Ver.Absender=cutSSID(KS[ch]^.Call) THEN Roger:=TRUE
              ELSE
              IF ListAusgabe^.Rubrik=CutSSID(KS[ch]^.Call) THEN Roger := TRUE
                                                           ELSE IF (ListAusgabe^.Lock=1) AND (Ver.Flags AND VERWALT_READ>0)
                                                                THEN Roger := TRUE;
            END;
            {Del-Flag. Flags: Siehe BOXVARS.PAS}
            IF (Ver.Flags AND VERWALT_DEL>0) AND (ListAusgabe^.Flags AND LST_DEL=0) THEN Roger := FALSE;

            IF Roger THEN BEGIN
              ListAusgabe^.OK := TRUE;
              PutData(ch,#13+SysText(ch,40)+#13);
              IF Ver.FileName[1]='U' THEN PutData(ch,#13+'User-File: '+ListAusgabe^.Rubrik+#13+SysText(ch,39)+#13#13)
                                     ELSE PutData(ch,#13+'Info-File: '+ListAusgabe^.Rubrik+#13+SysText(ch,39)+#13#13);
              PutData(ch,Verwalt2ListLine(Ver,FILEPOS(VerFile))+#13#13);
            END;
          END;
          i := i - 1;
          SEEK(VerFile,i);
        END;
        IF NOT ListAusgabe^.OK THEN PutData(ch,#13+SysText(ch,37)+' '+Rubrik+#13#13);
        CLOSE(VerFile);
        dispose(KS[ch]^.BoxData^.ListAusgabe);
        KS[ch]^.BoxData^.ListAusgabe := NIL;
        KS[ch]^.status := 50;
        Exit;
      END;

      {File ist noch nicht zuende}
      READ(VerFile,Ver);


      {Kontrolle, ob Zeile angezeigt wird}
      Roger := FALSE;
      IF KS[ch]^.Lev>10 THEN Roger := TRUE;
      IF ListAusgabe^.Lock=0 THEN Roger := TRUE;
      IF NOT Rufz(ListAusgabe^.Rubrik) THEN Roger := TRUE
      ELSE BEGIN
        {Usermail - ReadLock beachten}
        IF ListAusgabe^.Rubrik=CutSSID(KS[ch]^.Call) THEN Roger := TRUE
                                                     ELSE IF (ListAusgabe^.Lock=1) AND (Ver.Flags AND VERWALT_READ>0) THEN
                                                          Roger := TRUE;
      END;
      {Gelscht-Flag. Flags: Siehe BOXVARS.PAS}
      IF (Ver.Flags AND VERWALT_DEL>0) AND (ListAusgabe^.Flags AND LST_DEL=0) THEN Roger := FALSE;

      UnpackTime(Ver.RX_Datum,DT);
      WITH DT DO RXDate := calc_ixtime(day,month,year-1900,hour,min,sec);

      {Mail zum Hold markiert?}
      IF Ver.Flags AND VERWALT_HOLD>0 THEN
          IF (KS[ch]^.Lev<10) AND (Ver.Absender<>CutSSID(KS[ch]^.Call)) THEN Roger := FALSE;


      IF Roger AND ((ListAusgabe^.Flags AND LST_NEU=0) OR (LastQuit<RXDate))THEN BEGIN
        IF ListAusgabe^.anz=0 THEN BEGIN
          IF Ver.FileName[1]='U' THEN PutData(ch,#13+'User-File: '+ListAusgabe^.Rubrik+#13+SysText(ch,39)+#13#13)
                                 ELSE PutData(ch,#13+'Info-File: '+ListAusgabe^.Rubrik+#13+SysText(ch,39)+#13#13);
        END;
        inc(ListAusgabe^.anz);
        Hlp := Verwalt2ListLine(Ver,FILEPOS(VerFile))+#13;
        PutData(ch,Hlp);
        inc(AnzSent,Byte(Hlp[0]));
        inc(ListAusgabe^.Aktuell);

        IF AnzSent>LST_MAXBLOCK THEN
        BEGIN
          CLOSE(VerFile);
          Exit;
        END;
      END;
    END;
  END;
  PutData(ch,#13);
  CLOSE(VerFile);
  dispose(KS[ch]^.BoxData^.ListAusgabe);
  KS[ch]^.BoxData^.ListAusgabe := NIL;
  KS[ch]^.status := 50;
END;



PROCEDURE DIR(ch: BYTE; S: STRING);
VAR User,Info: BOOLEAN;
    Hlp: STRING[80];
    Rub: STRING[8];
    b,i: BYTE;
    anzline: BYTE;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';


  IF AnzRub = 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,41)+#13#13);
    Exit;
  END;

  {Standardeinstellungen}
  User := FALSE;                {User-Rubriken nicht anzeigen}
  Info := TRUE;                 {Info-Rubriken anzeigen}

  IF S <> '' THEN BEGIN
    S := Gross(LTRIM(RTRIM(S)));
    CASE S[1] OF
      'U': BEGIN
             User := TRUE;
             Info := FALSE;
           END;
      'I': BEGIN
             User := FALSE;
             Info := TRUE;
           END;
      'A': BEGIN
             User := TRUE;
             Info := TRUE;
           END;
    END;
  END;
  S := '';

  anzline := 0;
  Hlp := '';
  PutData(ch,#13);
  IF Info AND NOT User THEN PutData(ch,'Info-Files:'+#13);
  IF NOT Info AND User THEN PutData(ch,'User-Files:'+#13);
  IF Info AND User THEN PutData(ch,'Info/User-Files:'+#13);
  FOR b := 1 TO AnzRub DO BEGIN
    IF ((DirInfo[b]^.Art = 'U') AND User) OR ((DirInfo[b]^.Art = 'I') AND Info) THEN BEGIN
      IF (LENGTH(DirInfo[b]^.Rubrik)>1) OR (KS[ch]^.Lev > 10) THEN BEGIN
        anzline := anzline + 1;
        STR(DirInfo[b]^.Mails,S);
        FOR i := 0 TO 3 DO IF LENGTH(S)=i THEN S := '.' + S;
        Rub := DirInfo[b]^.Rubrik;
        FOR i := 0 TO 7 DO IF LENGTH(Rub)=i THEN Rub := Rub + '.';
        Hlp := Hlp + '  ' + Rub + S;
        IF anzline = 5 THEN BEGIN
          PutData(ch,Hlp+#13);
          Hlp := '';
          anzline := 0;
        END;
      END;
    END;
  END;
  IF anzline>0 THEN PutData(ch,Hlp+#13);
  PutData(ch,#13);
END;


PROCEDURE READ_CMD(ch: BYTE; S: STRING);
TYPE T_Arr250 = ARRAY[1..250] OF CHAR;
VAR Rubrik: STRING[8];
    Hlp,Last: STRING;
    anzhead,anz,i,k,Start,Stop: WORD;
    BIN,OK,Kompr,JustKompr,IsZahl: BOOLEAN;
    VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
    LEN: LONGINT;
    f: Text;
    Alter: BYTE;
    Lock: BYTE;

    tmp,BoxRead: pBoxRead;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';


  GetSetInfos(Gross(CutSSID(KS[ch]^.Call)),Alter);
  Kompr := Alter AND SET_R_Kurz>0;
  IF POS('+',S)>0 THEN BEGIN
    Kompr := FALSE;
    DELETE(S,POS('+',S),1);
    S := LTRIM(RTRIM(S));
  END;
  IF Kompr THEN Alter := Alter AND $FF-SET_R_Vollst;

  JustKompr := Kompr;


  IF LENGTH(S) = 0 THEN BEGIN
    PutData(ch,'Syntax:'+#13+'READ [<Rubrik>] <Nr>[-<Nr>]'+#13#13);
    Exit;
  END
  ELSE BEGIN
    IF POS(' ',S) > 0 THEN BEGIN        {Leerzeichen vorhanden -> es kommt
                                         noch was (Zahlen)}
      Rubrik := COPY(S,1,POS(' ',S)-1);
      S := COPY(S,POS(' ',S)+1,255);

      {Leerzeichen aus dem String 'raus}
      FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

      IF POS('-',S) > 0 THEN BEGIN
        VAL(COPY(S,1,POS('-',S)-1),Start,i);
        IF i <> 0 THEN Start := 1;
        VAL(COPY(S,POS('-',S)+1,255),Stop,i);
        IF i <> 0 THEN Stop := 65535;
      END
      ELSE BEGIN
        VAL(S,Start,i);
        Stop := Start;
      END;
    END
    ELSE BEGIN
      IsZahl := TRUE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        IF NOT (S[i] IN ['0'..'9','-']) THEN IsZahl := FALSE;
      END;

      IF IsZahl THEN BEGIN
        Rubrik := KS[ch]^.BoxData^.Rubrik;
        {Leerzeichen aus dem String 'raus}
        FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

        IF POS('-',S) > 0 THEN BEGIN
          VAL(COPY(S,1,POS('-',S)-1),Start,i);
          IF i <> 0 THEN Start := 1;
          VAL(COPY(S,POS('-',S)+1,255),Stop,i);
          IF i <> 0 THEN Stop := 65535;
        END
        ELSE BEGIN
          VAL(S,Start,i);
          Stop := Start;
        END;
      END
      ELSE BEGIN
        PutData(ch,'Syntax:'+#13+'READ [<Rubrik>] <Nr>[-<Nr>]'+#13#13);
        Exit;
      END;
    END;
  END;

  Rubrik := Gross(Rubrik);

  Lock := GetReadLockInfo(Rubrik);
  IF is_friend(rubrik,CutSSid(KS[ch]^.Call)) THEN
      lock:=0;

(*  IF (Lock=2) AND NOT (KS[ch]^.Lev>10) AND (Gross(Rubrik)<>CutSSID(KS[ch]^.Call))THEN BEGIN
{    PutData(ch,'Keine Mails vorhanden fr Rubrik '+Rubrik+'.'+#13#13);}
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+'.'+#13#13);
    Exit;
  END;
*)

  IF (LENGTH(Rubrik)=1) AND NOT (KS[ch]^.Lev>10) THEN BEGIN
{    PutData(ch,'Keine Mails vorhanden fr Rubrik '+Rubrik+'.'+#13#13);}
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+'.'+#13#13);
    Exit;
  END;


  KS[ch]^.BoxData^.Rubrik := Rubrik;

  ASSIGN(VerFile,BoxPath+'index'+path_sep+klein(Rubrik)+'.idx');
  {$I-}
  RESET(VerFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    Exit;
  END;
  IF FILESIZE(VerFile) = 0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    CLOSE(VerFile);
    Exit;
  END;

  i := Start - 1;
  anz := 0;
  WHILE i < Stop DO BEGIN
    SEEK(VerFile,i);
    IF EOF(VerFile) THEN BEGIN
      IF anz=0 THEN BEGIN
        STR(i+1,S);
        PutData(ch,SysText(ch,42)+' '+S+' '+SysText(ch,43)+#13);
      END;
      PutData(ch,#13);
      CLOSE(VerFile);
      Exit;
    END;
    READ(VerFile,Ver);

    OK := FALSE;
    IF KS[ch]^.Lev>10 THEN OK := TRUE;
    IF Lock=0 THEN OK := TRUE;
    IF Gross(Rubrik)=CutSSID(KS[ch]^.Call) THEN OK := TRUE;
    IF (Lock=1) AND (Ver.Flags AND VERWALT_READ>0) THEN OK := TRUE;
    IF (Ver.Absender=CutSSID(KS[ch]^.Call)) THEN OK:=TRUE;
    IF Ver.Flags AND VERWALT_DEL>0 THEN OK := FALSE;

    IF Ver.Flags AND VERWALT_HOLD>0 THEN
         IF (KS[ch]^.Lev<10) AND (Ver.Absender<>CutSSID(KS[ch]^.Call)) THEN OK := FALSE;


    IF OK THEN BEGIN
      LEN := 0;
      {Read-Flag auf 1 setzen (Flags: Siehe BOXVARS.PAS)}
      IF CutSSID(KS[ch]^.Call)=Rubrik THEN Ver.Flags := Ver.Flags OR VERWALT_READ;
      SEEK(VerFile,FILEPOS(VerFile)-1);
      WRITE(VerFile,Ver);

      WITH KS[ch]^.BoxData^ DO BEGIN
        tmp := FirstBoxRead;
        inc(anz);
        IF tmp=NIL THEN BEGIN
          {Erster Eintrag in die Send-Queue}
          new(FirstBoxRead);
          FirstBoxRead^.Next := NIL;
          FirstBoxRead^.IdxInfo := Ver;
          FirstBoxRead^.Started := FALSE;
          FirstBoxRead^.Set_Info := Alter;
        END
        ELSE BEGIN
          {In der Send-Queue existieren schon Eintrge}
          WHILE tmp^.Next <> NIL DO tmp := tmp^.Next;
          new(BoxRead);
          tmp^.Next := BoxRead;
          BoxRead^.Next := NIL;
          BoxRead^.IdxInfo := Ver;
          BoxRead^.Started := FALSE;
          BoxRead^.Set_Info := Alter;
        END;
      END;
      KS[ch]^.BoxData^.M_Nr:=I+1;
    END
    ELSE BEGIN
      IF Ver.Flags AND VERWALT_DEL>0 THEN BEGIN
        STR(i+1,S);
        PutData(ch,#13+S+' '+SysText(62,ch)+#13);
      END;
    END;

    i := i + 1;
    Kompr := JustKompr;
  END;

  IF anz=0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13);
  END;

  CLOSE(VerFile);
  IF anz=0 THEN PutData(ch,#13);
END;


{Lscht ALLE Eintrge mit der angegebenen BID aus SFLISTE. Sollte deshalb
 nicht bei S&F sondern nur beim ERASE-Befehl angegeben werden!}
PROCEDURE DelSFFileEntry(BID: str12);
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
BEGIN
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult = 0 THEN BEGIN
    WHILE NOT EOF(SFFile) DO BEGIN
      READ(SFFile,SF);
      IF (BID = SF.BID) THEN BEGIN
        SEEK(SFFile,FILEPOS(SFFile)-1);
        SF.Flags := SF.Flags OR SFLISTE_DEL;
        WRITE(SFFile,SF);
      END;
    END;
    CLOSE(SFFile);
  END;
END;



PROCEDURE Erase_CMD(ch: BYTE; S: STRING);
VAR Start,Stop: WORD;
    Rubrik: STRING[8];
    CanDel,Found,IsZahl,OK: BOOLEAN;
    Rub,i,k,anz: WORD;
    VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  IF LENGTH(S) = 0 THEN BEGIN
    PutData(ch,#13+'Syntax:'+#13+'ERASE [<Area>] [<Nr>][-][<Nr>]'+#13#13);
    Exit;
  END
  ELSE BEGIN
    IF POS(' ',S) > 0 THEN BEGIN        {Leerzeichen vorhanden -> es kommt
                                         noch was (Zahlen)}
      Rubrik := COPY(S,1,POS(' ',S)-1);
      S := COPY(S,POS(' ',S)+1,255);

      {Leerzeichen aus dem String 'raus}
      FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

      IF POS('-',S) > 0 THEN BEGIN
        VAL(COPY(S,1,POS('-',S)-1),Start,i);
        IF i <> 0 THEN Start := 1;
        VAL(COPY(S,POS('-',S)+1,255),Stop,i);
        IF i <> 0 THEN Stop := 65535;
      END
      ELSE BEGIN
        VAL(S,Start,i);
        Stop := Start;
      END;
    END
    ELSE BEGIN
      IsZahl := TRUE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        IF NOT (S[i] IN ['0'..'9','-']) THEN IsZahl := FALSE;
      END;

      IF IsZahl THEN BEGIN
        Rubrik := KS[ch]^.BoxData^.Rubrik;
        {Leerzeichen aus dem String 'raus}
        FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

        IF POS('-',S) > 0 THEN BEGIN
          VAL(COPY(S,1,POS('-',S)-1),Start,i);
          IF i <> 0 THEN Start := 1;
          VAL(COPY(S,POS('-',S)+1,255),Stop,i);
          IF i <> 0 THEN Stop := 65535;
        END
        ELSE BEGIN
          VAL(S,Start,i);
          Stop := Start;
        END;
      END
      ELSE BEGIN
        PutData(ch,#13+SysText(ch,72)+#13#13);
        Exit;
      END;
    END;
  END;
  Rubrik := Gross(Rubrik);
  KS[ch]^.BoxData^.Rubrik := Rubrik;

  ASSIGN(VerFile,BoxPath+'index'+path_sep+klein(Rubrik)+'.idx');
  {$I-}
  RESET(VerFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    Exit;
  END;
  IF FILESIZE(VerFile) = 0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    CLOSE(VerFile);
    Exit;
  END;


  Found := FALSE;
  FOR i := 1 TO AnzRub DO BEGIN
    IF Rubrik = DirInfo[i]^.Rubrik THEN BEGIN
      Found := TRUE;
      Rub := i;
    END;
  END;

  i := Start-1;
  anz := 0;
  PutData(ch,#13);
  WHILE i < Stop DO BEGIN
    SEEK(VerFile,i);
    IF EOF(VerFile) THEN BEGIN
      STR(anz,S);
      IF anz = 1 THEN PutData(ch,SysText(ch,53)+#13)
                 ELSE PutData(ch,S+' '+SysText(ch,54)+#13);
      CLOSE(VerFile);
      PutData(ch,#13);
      Exit;
    END;
    READ(VerFile,Ver);


    {Darf ich berhaupt das File lschen?}
    CanDel := FALSE;
    IF Ver.Absender = CutSSID(KS[ch]^.Call) THEN CanDel := TRUE; {Absender}
    IF Ver.Rubrik = CutSSID(KS[ch]^.Call) THEN CanDel := TRUE;   {Empfnger}
    IF KS[ch]^.Lev > 10 THEN CanDel := TRUE;   {SysOp}

    IF Ver.Flags AND VERWALT_DEL>0 THEN BEGIN
      STR(i+1,S);
      PutData(ch,'Mail '+S+' '+SysText(ch,55)+#13);
    END
    ELSE BEGIN
      IF CanDel THEN BEGIN
        DirInfo[Rub]^.Mails := DirInfo[Rub]^.Mails - 1;
        IF DirInfo[Rub]^.Mails = 0 THEN BEGIN
          FOR k := Rub TO AnzRub-1 DO BEGIN
            DirInfo[k]^ := DirInfo[k+1]^;
          END;
          DISPOSE(DirInfo[AnzRub]);
          DirInfo[AnzRub] := NIL;
          AnzRub := AnzRub - 1;
        END;
        anz := anz + 1;
        {Gelscht-Flag auf TRUE setzen. (Flags: Siehe BOXVARS.PAS)}
        Ver.Flags := Ver.Flags OR VERWALT_DEL;
        SEEK(VerFile,FILEPOS(VerFile)-1);
        WRITE(VerFile,Ver);
        DelSFFileEntry(Ver.BID);
        DelCheckFile(Ver.BID);
      END
      ELSE BEGIN
        STR(i+1,S);
        PutData(ch,SysText(ch,42)+' '+S+' '+SysText(ch,63)+#13);
      END;
    END;

    i := i + 1;
  END;

  STR(anz,S);
  IF anz = 1 THEN PutData(ch,SysText(ch,53)+#13)
             ELSE PutData(ch,S+' '+SysText(ch,54)+#13);
  CLOSE(VerFile);
  PutData(ch,#13);

END;



PROCEDURE Box_QUIT(ch: BYTE);
BEGIN
  SendMacroFile(ch,BoxPath+'msg'+path_sep+'qtext.'+klein(KS[ch]^.BoxData^.spk));
  IF KS[ch]^.BoxData^.oldStatus = -1 THEN
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ
  ELSE BEGIN
    PutData(ch,#13+'*** reconnected to '+MyCall+#13#13);
    KS[ch]^.status := KS[ch]^.BoxData^.oldStatus;
  END;
  SetQuit(ch);
END;



PROCEDURE Box_BYE(ch: BYTE; ShutDown: BOOLEAN);
BEGIN
  IF NOT ShutDown THEN
    SendMacroFile(ch,BoxPath+'msg'+PATH_SEP+'byetext.'+klein(KS[ch]^.BoxData^.spk));
   IF KS[ch]^.BoxData=NIL THEN exit;
  IF KS[ch]^.BoxData^.oldStatus = -1 THEN
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ
  ELSE BEGIN
    PutData(ch,#13+'*** reconnected to '+MyCall+#13#13);
    KS[ch]^.status := KS[ch]^.BoxData^.oldStatus;
  END;
END;


PROCEDURE SendForwardLine(ch: BYTE; VAR LEN: LONGINT; FileName: STRING);
VAR S,Help: STRING;
    f: FILE;
    Hlp: ARRAY[1..255] OF CHAR;
    i: BYTE;
BEGIN

  ASSIGN(f,FileName);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult=0 THEN BEGIN
    SEEK(f,257);
    BLOCKREAD(f,Hlp,255);
    CLOSE(f);
    S := '';
    FOR i := 1 TO 255 DO BEGIN
      S[i] := Hlp[i];
    END;
    S[0] := #255;
    S := LTRIM(RTRIM(S));
    IF LENGTH(S)=0 THEN Exit;

    WHILE LENGTH(S)>0 DO BEGIN
      Help := COPY(S,1,70);
      IF LENGTH(Help)=70 THEN WHILE S[LENGTH(Help)]<>#32 DO DELETE(Help,LENGTH(Help),1);
      IF LENGTH(Help)=0 THEN Help := COPY(S,1,70);
      S := COPY(S,LENGTH(Help)+1,255);
      Help := 'Forw: '+Help;
      PutData(ch,Help+#13);
      LEN := LEN + LENGTH(Help);
    END;
  END;
END;




PROCEDURE Kopf_CMD(ch: BYTE; S: STRING);
VAR Rubrik: STRING[8];
    Hlp,Last: STRING;
    anzhead,anz,i,k,Start,Stop: WORD;
    Fertig,OK,Kompr,JustKompr,IsZahl: BOOLEAN;
    VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
    LEN: LONGINT;
    f: Text;
    Alter: BYTE;
    Lock: BYTE;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';


  GetSetInfos(Gross(CutSSID(KS[ch]^.Call)),Alter);
  Kompr := Alter AND SET_R_Kurz>0;
  IF POS('+',S)>0 THEN BEGIN
    Kompr := FALSE;
    DELETE(S,POS('+',S),1);
    S := LTRIM(RTRIM(S));
  END;
  IF Kompr THEN Alter := Alter AND $FF-SET_R_Vollst;

  JustKompr := Kompr;


  IF LENGTH(S) = 0 THEN BEGIN
    PutData(ch,'Syntax:'+#13+'KOPF [<Rubrik>] <Nr>[-<Nr>]'+#13#13);
    Exit;
  END
  ELSE BEGIN
    IF POS(' ',S) > 0 THEN BEGIN        {Leerzeichen vorhanden -> es kommt
                                         noch was (Zahlen)}
      Rubrik := COPY(S,1,POS(' ',S)-1);
      S := COPY(S,POS(' ',S)+1,255);

      {Leerzeichen aus dem String 'raus}
      FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

      IF POS('-',S) > 0 THEN BEGIN
        VAL(COPY(S,1,POS('-',S)-1),Start,i);
        IF i <> 0 THEN Start := 1;
        VAL(COPY(S,POS('-',S)+1,255),Stop,i);
        IF i <> 0 THEN Stop := 65535;
      END
      ELSE BEGIN
        VAL(S,Start,i);
        Stop := Start;
      END;
    END
    ELSE BEGIN
      IsZahl := TRUE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        IF NOT (S[i] IN ['0'..'9','-']) THEN IsZahl := FALSE;
      END;

      IF IsZahl THEN BEGIN
        Rubrik := KS[ch]^.BoxData^.Rubrik;
        {Leerzeichen aus dem String 'raus}
        FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

        IF POS('-',S) > 0 THEN BEGIN
          VAL(COPY(S,1,POS('-',S)-1),Start,i);
          IF i <> 0 THEN Start := 1;
          VAL(COPY(S,POS('-',S)+1,255),Stop,i);
          IF i <> 0 THEN Stop := 65535;
        END
        ELSE BEGIN
          VAL(S,Start,i);
          Stop := Start;
        END;
      END
      ELSE BEGIN
        PutData(ch,'Syntax:'+#13+'KOPF [<Rubrik>] <Nr>[-<Nr>]'+#13#13);
        Exit;
      END;
    END;
  END;

  Rubrik := Gross(Rubrik);

  Lock := GetReadLockInfo(Rubrik);

  IF (Lock=2) AND NOT (KS[ch]^.Lev>10) AND (Gross(Rubrik)<>CutSSID(KS[ch]^.Call))THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Rubrik+'.'+#13#13);
    Exit;
  END;

  IF (LENGTH(Rubrik)=1) AND NOT (KS[ch]^.Lev>10) THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Rubrik+'.'+#13#13);
    Exit;
  END;


  KS[ch]^.BoxData^.Rubrik := Rubrik;

  ASSIGN(VerFile,BoxPath+'index'+PATH_SEP+klein(Rubrik)+'.idx');
  {$I-}
  RESET(VerFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    Exit;
  END;
  IF FILESIZE(VerFile) = 0 THEN BEGIN
    PutData(ch,SysText(ch,37)+' '+Gross(Rubrik)+#13#13);
    CLOSE(VerFile);
    Exit;
  END;

  i := Start - 1;
  anz := 0;
  WHILE i < Stop DO BEGIN
    SEEK(VerFile,i);
    IF EOF(VerFile) THEN BEGIN
      IF anz=0 THEN BEGIN
        STR(i+1,S);
        PutData(ch,SysText(ch,42)+' '+S+' '+SysText(ch,43)+#13);
      END;
      PutData(ch,#13);
      CLOSE(VerFile);
      Exit;
    END;
    READ(VerFile,Ver);

    OK := FALSE;
    IF KS[ch]^.Lev>10 THEN OK := TRUE;
    IF Lock=0 THEN OK := TRUE;
    IF Gross(Rubrik)=CutSSID(KS[ch]^.Call) THEN OK := TRUE;
    IF (Lock=1) AND (Ver.Flags AND VERWALT_READ>0) THEN OK := TRUE;
    IF Ver.Flags AND VERWALT_DEL>0 THEN OK := FALSE;
    IF OK THEN BEGIN
      LEN := 0;
      IF CutSSID(KS[ch]^.Call)=Rubrik THEN Ver.Flags := Ver.Flags OR VERWALT_READ;
      SEEK(VerFile,FILEPOS(VerFile)-1);
      WRITE(VerFile,Ver);

      {File-Start-Markierung ausgeben}
      PutData(ch,#13+'{TOF}'+#13);

      {Header bauen}
      S := Ver.Absender+' > '+Ver.Rubrik+'   ';
      IF Alter AND SET_Datum>0 THEN S := S + Pack2STRDate(Ver.RX_Datum)+' ';
      IF Alter AND SET_Uhrzeit>0 THEN S := S + Pack2STRTime(Ver.RX_Datum)+' ';
      IF Alter AND SET_Bytes>0 THEN BEGIN
        STR(Ver.Groesse,Hlp);
        S := S + Hlp+' Bytes'
      END;
      IF Alter AND SET_LifeTime>0 THEN BEGIN
        S := S + '  #';
        STR(Ver.LifeTime,Hlp);
        S := S + Hlp;
      END;
      S := S + '  @'+Ver.MBX;

      LEN := LENGTH(S);                   {Gre der gesendeten Daten}
      PutData(ch,S+#13);
      S := 'BID : '+Ver.BID;
      LEN := LEN + LENGTH(S);
      PutData(ch,S + #13);              {BID-Zeile senden}

      IF Alter AND SET_Read>0 THEN BEGIN
        SendReadLine(ch, LEN, BoxPath+Ver.FileName);
      END;
      SendForwardLine(ch, LEN, BoxPath+Ver.FileName);

      S := 'Subj: '+Ver.Titel;
      LEN := LEN + LENGTH(S);
      PutData(ch,S + #13);              {Subject-Zeile}

      {Eigentliches TextFile ffnen}
      ASSIGN(f,BoxPath+Ver.FileName);
      {$I-}
      RESET(f);
      {$I+}
      IF IOResult <> 0 THEN BEGIN
        PutData(ch,#13+SysText(ch,44)+#13#13);
      END
      ELSE BEGIN

        {Header abschneiden}
        S := '';
        WHILE NOT EOF(f) AND (S <> 'NNNN') DO READLN(f,S);

        anzhead := 0;
        Hlp := 'Path: !';
        Last := '';
        Fertig := FALSE;
        WHILE NOT EOF(f) AND NOT Fertig DO BEGIN
          READLN(f,S);
          IF (S[1]='R') AND (S[2]=':') AND Kompr THEN BEGIN
            Last := COPY(S,3,255);
            anzhead := anzhead + 1;
            S := COPY(S,17,255);
            IF POS(' ',S) > 0 THEN S := COPY(S,1,POS(' ',S)-1);
            IF POS(':',S) > 0 THEN S := COPY(S,POS(':',S)+1,255);
            IF POS('.',S) > 0 THEN S := COPY(S,1,POS('.',S)-1);
            IF POS('@',S) > 0 THEN S := COPY(S,POS('@',S)+1,255);
            Hlp := Hlp + S+'!';

            IF anzhead = 10 THEN BEGIN
              anzhead := 0;
              LEN := LEN + LENGTH(Hlp);
              PutData(ch,Hlp+#13);
              Hlp := '      !';
            END;
          END
          ELSE BEGIN
            IF Kompr THEN BEGIN
              Kompr := FALSE;
              IF anzhead > 0 THEN BEGIN
                LEN := LEN + LENGTH(Hlp);
                PutData(ch,Hlp+#13);
              END;
              IF Alter AND SET_Sender>0 THEN BEGIN
                Hlp := 'Sent: '+Last;
                LEN := LEN + LENGTH(Hlp);
                PutData(ch,Hlp+#13);
              END;
            END;
            LEN := LEN + LENGTH(S);
            IF S='' THEN BEGIN
              Fertig := TRUE;
              LEN := LEN + 4;
              PutData(ch,'....'+#13);
            END
            ELSE PutData(ch,S+#13);
          END;
        END;
        CLOSE(f);
        PutData(ch,#13);
        LEN := LEN;
        STR(LEN,Hlp);
        PutData(ch,'{EOF|'+Hlp+'}'+#13#13);
        anz := anz + 1;
      END;
    END
    ELSE BEGIN
      IF Ver.Flags AND VERWALT_DEL>0 THEN BEGIN
        STR(i+1,S);
        PutData(ch,#13+S+' '+SysText(ch,62)+#13);
      END;
    END;

    i := i + 1;
    Kompr := JustKompr;
  END;

  CLOSE(VerFile);
  PutData(ch,#13);
END;


(*
 * CHECK_CMD
 * Check-Befehl der Mailbox
 * Umbau auf Ausgabe im Hintergrund am 03.03.96 (6vj)
 *)
PROCEDURE CHECK_CMD(ch: BYTE; S: STRING; Weiter: BOOLEAN);
VAR i,k,code,code1,Start,Stop: WORD;
    Neu: BOOLEAN;
    Info,Hlp: STRING;
    CheckFile: FILE OF CheckRec;
    Check: CheckRec;
    OK: BOOLEAN;
    LastQuit: LONGINT;
    AllHold: BOOLEAN;
    SizeSent: WORD;             {Wieviel wurde in dieser Session schon gesendet?}
BEGIN
   ASSIGN(CheckFile,BOXPATH+'check.box');
  {$I-}
  RESET(CheckFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,74)+#13#13);
    Exit;
  END;
  IF FILESIZE(CheckFile) = 0 THEN BEGIN
    CLOSE(CheckFile);
    PutData(ch,#13+SysText(ch,74)+#13#13);
    Exit;
  END;

  IF NOT Weiter THEN BEGIN      {Neuer Check-Befehl}
    {Evtl. RETURN abschneiden}
    IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
    IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

    S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));

    IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                      ELSE S := '';

    IF POS(' ',S)>0 THEN Hlp := COPY(S,1,POS(' ',S)-1)
                    ELSE Hlp := S;

    AllHold := FALSE;
    {Check, ob alle Messages, deren Hold-Flag gesetzt wurde, angezeigt
     werden sollen. Nur im SysOp-Modus}
    IF (Hlp='-H') AND (KS[ch]^.Lev>10) THEN BEGIN
      IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                        ELSE S := '';
      AllHold := TRUE;
    END;

    Neu := TRUE;
    IF POS('<',S) > 0 THEN BEGIN
      Neu := FALSE;
      Info := LTRIM(RTRIM(COPY(S,POS('<',S)+1,255)));
      S := LTRIM(RTRIM(COPY(S,1,POS('<',S)-1)));
    END
    ELSE Info := '';
    Start := 1;
    Stop := 65535;

    IF LENGTH(S) > 0 THEN BEGIN
      IF POS('-',S) > 0 THEN BEGIN
        VAL(LTRIM(RTRIM(COPY(S,1,POS('-',S)-1))),Start,code);
        VAL(LTRIM(RTRIM(COPY(S,POS('-',S)+1,255))),Stop,code1);
        IF (code<>0) OR (code1 <> 0) THEN BEGIN
          Neu := TRUE;
          Start := 1;
          Stop := 65535;
        END
        ELSE BEGIN
          IF Start>Stop THEN BEGIN
            Neu := TRUE;
            Start := 1;
            Stop := 65535;
          END
          ELSE BEGIN
            code := start;
            IF Stop > FILESIZE(CheckFile) THEN Start := 1
                                          ELSE Start := FILESIZE(CheckFile)-Stop+1;
            Stop := FILESIZE(CheckFile)-code+1;
            Neu := FALSE;
          END;
        END;
      END
      ELSE BEGIN
        VAL(S,Stop,code);
        IF code <> 0 THEN BEGIN
          Start := 1;
          Stop := 65535;
          Neu := TRUE;
        END
        ELSE BEGIN
          Neu := FALSE;
          IF Stop > FILESIZE(CheckFile) THEN Start := 1
                                        ELSE Start := FILESIZE(CheckFile)-Stop+1;
          Stop := FILESIZE(CheckFile);
        END;
      END;
    END;


    IF AllHold THEN BEGIN
      Start := 1;
      Stop := 65535;
    END;

    {Eintrag fr die CheckFile-Fortsetzerei machen}
    new(KS[ch]^.BoxData^.CheckAusgabe);
    WITH KS[ch]^.BoxData^ DO BEGIN
      CheckAusgabe^.Start := Start;
      CheckAusgabe^.Stop := Stop;
      CheckAusgabe^.Aktuell := Stop;
      CheckAusgabe^.Flags := 0;
      IF Neu THEN CheckAusgabe^.Flags := CheckAusgabe^.Flags OR CHK_NEU;
      IF AllHold THEN CheckAusgabe^.Flags := CheckAusgabe^.Flags OR CHK_HOLD;
      CheckAusgabe^.Info := Info;
      CheckAusgabe^.Anz := 0;
    END;
  END;

  SizeSent := 0;

  WITH KS[ch]^.BoxData^ DO BEGIN

    {LastQuit-Zeit holen}
    Lastquit := Pack2Unix(GetLastQuit(OK,CutSSID(KS[ch]^.Call)));

    IF FILESIZE(CheckFile) < CheckAusgabe^.Stop THEN CheckAusgabe^.Stop := FILESIZE(CheckFile);
    IF FILESIZE(CheckFile) < CheckAusgabe^.Aktuell THEN CheckAusgabe^.Aktuell := FILESIZE(CheckFile);
    FOR i := CheckAusgabe^.Aktuell DOWNTO CheckAusgabe^.Start DO BEGIN
      SEEK(CheckFile,i-1);
      READ(CheckFile,Check);
         {ungelscht}                      {Hold-Flag nicht gesetzt}
      IF (Check.Flags AND CHECK_DEL=0) THEN BEGIN
        OK := FALSE;                 {eigentlich wollen wir kein File haben}
        IF (CheckAusgabe^.Flags AND CHK_NEU)>0 THEN BEGIN
          {Der User will nur die neuen Mails haben}
          IF LastQuit < Pack2Unix(Check.RX_Zeit) THEN OK := TRUE;
        END
        ELSE OK := TRUE;  {Aber wir wollen nicht nur die neuen Files haben}
        IF (LENGTH(CheckAusgabe^.Info)>0) AND OK THEN BEGIN
          OK := FALSE;
          IF POS(CheckAusgabe^.Info,gross(Check.Titel)) > 0 THEN OK := TRUE;
          IF Check.Von = CheckAusgabe^.Info THEN OK := TRUE;
          IF '@'+Check.mbx = CheckAusgabe^.info THEN OK := TRUE;
        END;

        IF Check.Flags AND CHECK_HOLD>0 THEN
           IF (KS[ch]^.Lev<10) AND (Check.Von<>CutSSID(KS[ch]^.Call)) THEN OK := FALSE;

        IF (Check.Flags AND CHECK_SYSOP>0) AND (KS[ch]^.Lev<10) THEN OK := FALSE;

        IF ((CheckAusgabe^.Flags AND CHK_HOLD)>0) AND (Check.Flags AND CHECK_HOLD=0) THEN OK := FALSE;

        IF OK THEN BEGIN  {Das File wird angezeigt}
          inc(CheckAusgabe^.Anz);
          IF CheckAusgabe^.anz = 1 THEN PutData(ch,#13+SysText(ch,75)+#13#13);
          STR(FILESIZE(CheckFile)-i+1,S);
          FOR k := 0 TO 3 DO IF LENGTH(S) = k THEN S := ' ' + S;
          FOR k := 0 TO 5 DO IF LENGTH(Check.Von) = k THEN Check.Von := Check.Von + ' ';
          IF Check.Flags AND CHECK_HOLD>0 THEN S := S + ' ' + Check.Von + ' H '
                                          ELSE S := S + ' ' + Check.Von + ' > ';
          Hlp := Check.An;
          FOR k := 0 TO 7 DO IF LENGTH(Hlp) = k THEN Hlp := Hlp + '.';
          S := S + Hlp;
          STR(Check.Nr,Hlp);
          FOR k := 0 TO 3 DO IF LENGTH(Hlp) = k THEN Hlp := '.' + Hlp;
          S := S + Hlp + ' ';
          Hlp := DTDateStr(Check.RX_Zeit);
          S := S +COPY(Hlp,1,6)+COPY(Hlp,9,2)+' ';
          FOR k := 0 TO 5 DO IF LENGTH(Check.MBX) = k THEN CHeck.MBX := Check.MBX + ' ';
          S := S + Check.MBX;
          STR(Check.Bytes,Hlp);
          FOR k := 0 TO 5 DO IF LENGTH(Hlp) = k THEN Hlp := ' ' + Hlp;
          S := S + Hlp + ' ';
          STR(Check.LT,Hlp);
          FOR k := 0 TO 2 DO IF LENGTH(Hlp) = k THEN Hlp := ' ' + Hlp;
          S := S + Hlp + ' ' + COPY(Check.Titel,1,25);
          PutData(ch,S+#13);
          SizeSent := LENGTH(S)+1;
          dec(CheckAusgabe^.Aktuell);
          IF SizeSent>=CHK_MAXBLOCK THEN BEGIN
            CLOSE(CheckFile);
            KS[ch]^.status := 80;       {Neuer Status: Check-Ausgabe luft
                                         im Hintergrund}
            Exit;
          END;
        END;
      END;
    END;
    IF CheckAusgabe^.anz=0 THEN PutData(ch,#13+SysText(ch,74)+#13);
    PutData(ch,#13);
    CLOSE(CheckFile);
    dispose(KS[ch]^.BoxData^.CheckAusgabe);
    KS[ch]^.BoxData^.CheckAusgabe := NIL;
    KS[ch]^.status := 50;
  END;
END;

PROCEDURE NEXT_CMD(ch: BYTE; S: STRING);
BEGIN
  STR(KS[ch]^.BoxData^.M_Nr+1,s);
  READ_CMD(ch,'READ '+s);
END;
END.