(***************************************************************************)
(**                            UNIT BOXHOLD.PAS                           **)
(***************************************************************************)
(**  Routinen fr die Hold-Funktion.                                      **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
{Routinen fr die Hold-Funktion.

}
UNIT BOXHOLD;

INTERFACE

USES BOXVARS;

FUNCTION StringMatch(Norm,Wild: STRING): BOOLEAN;
FUNCTION Match(Norm,Wild: STRING): BOOLEAN;
FUNCTION HoldThisMail(RX_By_Forward,WithPassword,Usermail: BOOLEAN; Index: Verwalt_Rec; Typ: CHAR): BOOLEAN;


IMPLEMENTATION


{TRUE, wenn das bergebene Zeichen eine Zahl ist.}
FUNCTION IsZahl(ch: CHAR): BOOLEAN;
BEGIN
  IsZahl := ch IN ['0'..'9'];
END;



{TRUE, wenn das bergebene Zeichen ein Buchstabe ist.}
FUNCTION IsBuchstabe(ch: CHAR): BOOLEAN;
BEGIN
  IsBuchstabe := UpCase(ch) IN ['A'..'Z'];
END;


{Testet 2 Strings, ob die bereinstimmen. Hier ist kein '*' mehr vorhanden.}
FUNCTION StringMatch(Norm,Wild: STRING): BOOLEAN;
VAR i,j: BYTE;
BEGIN
  j:=0;
  StringMatch:=FALSE;
  FOR i := 1 TO Byte(wild[0]) DO
  BEGIN
    inc(j);
    {ein slash fhrt dazu, da das folgende zeichen nicht als wildcard angesehen
     wird}
    IF wild[i]='\' THEN
    BEGIN
      inc(i);
      IF i>byte(wild[0]) THEN exit;
      IF (Norm[j]<>Wild[i])  THEN exit;
    END
    ELSE
    IF NOT (
       (Norm[j]=Wild[i]) OR (Wild[i]='?') OR
       ((wild[i]='#') AND (norm[j]>='0') AND (norm[j]<='9')) OR
       ((wild[i]='@') AND ((byte(norm[j]) AND 223) >= ord('a')) AND ((byte(norm[j]) AND 223) <= ord('z')))) THEN
         exit;
  END;
  IF j=length(norm) THEN
  StringMatch := TRUE;
END;


{Guckt, ob der String Norm mit dem String Wild berein stimmt. In Wild knnen
 Wildcards vorkommen (das machts etwas komplizierter). Ich wrde mich freuen,
 wenn Du die Routine etwas besser und vor allem schneller neu schreibst, wenn
 das mglich ist.}
FUNCTION Match(Norm,Wild: STRING): BOOLEAN;
VAR S: STRING;
    i,len1,len2: BYTE;
    OK: BOOLEAN;
    {L,R:STRING}
BEGIN
  Match := FALSE;
  IF LENGTH(Wild)=0 THEN BEGIN
    IF Norm='' THEN
       Match := TRUE;
    Exit;
  END;
  {IF find(wild,'*',L,R) THEN
  BEGIN
    len1:=0;len2:=0;
    FOR i:=1 to length(L) DO
      IF (l[i]<>'\') THEN inc(len1);
    FOR i:=1 to length(R) DO
      IF (l[i]<>'\') THEN inc(len2);
    IF match(copy(norm,1,len1),L) AND match(copy(norm,len2+1,255,R) THEN
      match:=TRUE
  END;}

  IF POS('*',Wild)>0 THEN BEGIN
    IF Wild='*' THEN BEGIN
      Match := TRUE;
      Exit;
    END;
    IF Wild[1]='*' THEN BEGIN
      {Wildcard ist erstes Zeichen im String}
      Wild := COPY(Wild,2,255);
      IF StringMatch(COPY(Norm,LENGTH(Norm)-LENGTH(Wild)+1,255),Wild) THEN Match := TRUE;
    END
    ELSE
    IF wild[length(wild)]='*' THEN
    BEGIN
      {Wildcard ist letztes Zeichen im String}
      Wild := COPY(Wild,1,LENGTH(Wild)-1);
      IF StringMatch(COPY(Norm,1,LENGTH(Wild)),Wild) THEN Match := TRUE;
    END;
  END
  ELSE
     Match := StringMatch(Norm,Wild)
END;


FUNCTION TypeMatch(Typ,Wild: CHAR): BOOLEAN;
BEGIN
  TypeMatch := TRUE;
  IF (Wild='*') OR
     (WILD='?') OR
     ((Wild='#') AND (typ>='0') AND (typ<='9')) OR
     ((Wild='@') AND ((byte(typ) AND 223)>=ord('a')) AND ((byte(typ) AND 223)<=ord('z'))) THEN Exit;
  IF Typ<>Wild THEN TypeMatch := FALSE;
END;


FUNCTION HoldThisMail(RX_By_Forward,WithPassword,Usermail: BOOLEAN; Index: Verwalt_Rec; Typ: CHAR): BOOLEAN;
VAR tmp: pReject_Box;
    dummy,Hold: BOOLEAN;
BEGIN
  {Variablen initialisieren}
  Hold := FALSE;
  tmp := Reject_Box_Root;

  WHILE (tmp<>NIL) AND NOT Hold DO BEGIN
    dummy := FALSE;
    IF (tmp^.Not_Hold AND 1>0) AND WithPassword THEN dummy := TRUE;
    IF (tmp^.Not_Hold AND 2>0) AND Usermail THEN dummy := TRUE;
    IF NOT dummy THEN BEGIN
      IF (tmp^.Was=2) OR (tmp^.Was=1) THEN BEGIN
        {Hold aller Mails}
        IF Match(Index.Absender,tmp^.Absender) AND
           Match(Index.Rubrik,tmp^.Rubrik) AND
           Match(Index.MBX,tmp^.MBX) AND
           TypeMatch(Typ,tmp^.Typ) THEN Hold := TRUE;
      END
      ELSE BEGIN
        {Local Hold}
        IF NOT RX_By_Forward THEN BEGIN
          IF Match(Index.Absender,tmp^.Absender) AND
             Match(Index.Rubrik,tmp^.Rubrik) AND
             Match(Index.MBX,tmp^.MBX) AND
             TypeMatch(Typ,tmp^.Typ) THEN Hold := TRUE;
        END;
      END;
    END;

    tmp := tmp^.next;
  END;
  HoldThisMail := Hold;

END;


END.

