(***************************************************************************)
(**                             UNIT BOXIMP.PAS                           **)
(***************************************************************************)
(**  Wenn Mails im Verzeichnis BoxPath+'IMPORT' vorhanden sind, werden    **)
(**  diese automatisch in die Mailbox importiert.                         **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXIMP;


INTERFACE

(*
 * ImportFiles
 * Einzite ffentliche Prozedur der Unit. Wenn ImportFiles aufgerufen wird,
 * wird das Verzeichnis BoxPath+'IMPORT' kontrolliert, und alle vorhandenen
 * Files importiert.
 *)
PROCEDURE ImportFiles;


IMPLEMENTATION

USES DOS,IADVAR,BOXVARS,BOXUTIL,TOOLBOX,BOXSF,BOXHOLD,BOXSERV;
{$I-}

{Send-Zeile aufspalten und Infos 'draus nach Ver schreiben
  Rckgabe: TRUE, wenn das File, aus welchem Grund auch immer, nicht
            importiert werden soll.
}
FUNCTION ZerpflueckSendLine(S: STRING; VAR Ver: Verwalt_Rec;VAR Hierach: STRING): BOOLEAN;
VAR Hlp: STRING;
    aword: WORD;
BEGIN
  ZerpflueckSendLine := FALSE;

  {Record VER leer machen}
   WITH Ver DO BEGIN
     Titel := '';
     Absender := '';
     Rubrik := '';
     MBX := '';
     FileName := '';
     Rx_Datum := 0;
     BID := '';
     Groesse := 0;
     Lifetime := 0;
     Flags := 0;
   END;


   {Check, ob User- oder Info-File}
   CASE S[2] OF
     'P': Ver.FileName := 'user'+PATH_SEP;
     'B': Ver.FileName := 'info'+PATH_SEP;
     ' ': Ver.FileName := '';
   END;

   {SB oder SP abschneiden}
   S := COPY(S,POS(' ',S)+1,255);

   IF POS('$',S) > 0 THEN BEGIN
     Hlp := COPY(S,POS('$',S)+1,255);
     Hlp := LTRIM(RTRIM(Hlp));
     IF POS(' ',Hlp) > 0 THEN Hlp := COPY(Hlp,1,POS(' ',hlp)-1);
     Ver.BID := Hlp;
   END;

   IF POS('#',S) > 0 THEN BEGIN
     Hlp := COPY(S,POS('#',S)+1,255);
     Hlp := LTRIM(RTRIM(Hlp));
     IF POS(' ',Hlp) > 0 THEN Hlp := COPY(Hlp,1,POS(' ',hlp)-1);
     VAL(Hlp,Ver.LifeTime,aword);
     IF aword<>0 THEN Ver.LifeTime := 0;
   END;


   IF POS('<',S) > 0 THEN BEGIN
     Hlp := COPY(S,POS('<',S)+1,255);
     Hlp := LTRIM(RTRIM(Hlp));
     IF POS(' ',Hlp) > 0 THEN Hlp := COPY(Hlp,1,POS(' ',hlp)-1);
     Ver.Absender := Hlp;
   END;

   S := LTRIM(RTRIM(COPY(S,1,POS('<',S)-1)));

   {Alle leerzeichen aus S entfernen}
   FOR aword := LENGTH(S) DOWNTO 1 DO IF S[aword] = #32 THEN DELETE(S,aword,1);

   IF POS('@',S) > 0 THEN BEGIN
     Ver.Rubrik := COPY(S,1,POS('@',S)-1);
     S := COPY(S,POS('@',S)+1,255);
     IF POS('.',S) > 0 THEN BEGIN
       S := COPY(S,1,POS('.',S)-1);
       Hierach := COPY(S,POS('.',S),255);
     END
     ELSE Hierach := '';
     Ver.MBX := S;
   END
   ELSE BEGIN
     Ver.MBX := CutSSID(BoxCall);
     Ver.Rubrik := S;
   END;

   IF Ver.Filename='' THEN IF Rufz(Ver.Rubrik) THEN Ver.Filename := 'user'+PATH_SEP
                                               ELSE Ver.Filename := 'info'+PATH_SEP;

   IF Ver.BID = '' THEN Ver.BID := Neu_BID
                   ELSE IF BID_DA(Ver.BID) THEN ZerpflueckSendLine := TRUE;

   IF Ver.LifeTime = 0 THEN BEGIN
     IF Ver.FileName[1] = 'U' THEN Ver.LifeTime := OwnBoxData^.User_LT
                              ELSE StandardLT(Ver.LifeTime,Ver.Rubrik);
   END
   ELSE IF Ver.FileName[1] = 'I' THEN CheckLT(Ver.LifeTime,Ver.Rubrik);
   Ver.Flags := 0;
   {Flags auf 0 setzen. Siehe BOXVARS.PAS}

END;


(*
 * AddDirInfoList
 * Guckt, ob die bergebene Rubrik schon in der DirInfo-Liste vorhanden
 * ist. Wenn ja wird der Mails-Zhler um 1 hochgezhlt. Wenn nicht wird
 * diese Rubrik in der Liste erzeugt, der Mail-Zhler auf 1 gesetzt, das
 * Art-Byte gesetzt und das ganze alphabetisch Sortiert.
 *)
PROCEDURE AddDirInfoList(Rubrik: str8; Art: CHAR);
VAR Found: BOOLEAN;
    b,i: WORD;
BEGIN

  (** Kontrolle, ob Rubrik schon in DirInfo **)
  Found := FALSE;
  i := 1;
  WHILE NOT Found AND (i<=AnzRub) DO BEGIN
    IF DirInfo[i]^.Rubrik=Rubrik THEN BEGIN
      Found := TRUE;
      b := i;
    END;
    inc(i);
  END;

  IF Found THEN BEGIN
    { Rubrik existiert schon im DirInfo-Array }
    { --> Mails um 1 hochzhlen }
    inc(DirInfo[b]^.Mails);
  END
  ELSE BEGIN
    { Rubrik existiert noch nicht im DirInfo-Array }
    { --> Anzahl Rubriken um 1 hochzhlen }
    inc(AnzRub);
    { fr diese neue Rubrik Speicher reservieren }
    new(DirInfo[AnzRub]);
    { die neuen Daten in das Array schreiben }
    DirInfo[AnzRub]^.Rubrik := Rubrik;
    DirInfo[AnzRub]^.Mails := 1;
    DirInfo[AnzRub]^.Art := Art;
    { und das ganze Sortieren }
    SortDirInfo;
  END;
END;



PROCEDURE SaveTitelAndMakeHeader(S: STRING; VAR Ver: Verwalt_Rec; VAR f: Text);
VAR DT: DateTime;
    Hlp,FileName,DatNam: STRING;
    aword: WORD;
    jetzt: LONGINT;
BEGIN
  Ver.Titel := S;
  jetzt:=CurrIXTime;
  ver.rx_datum:=unix2pack(jetzt);
  IF jetzt <> LastTime THEN BEGIN
    AnzPerSec := 0;
    LastTime := jetzt;
  END
  ELSE BEGIN
   inc(anzpersec);
  END;
  DatNam := XHex(jetzt);
  STR(AnzPerSec,FileName);
  DatNam := DatNam + '.' + FileName;

  FileName := BoxPath + Ver.FileName + Ver.Rubrik;

  {$I-}
  MKDir(klein(FileName));   {Verzeichnis erstellen}
  IF IOResult=5 THEN BEGIN END;

  FileName := FileName + PATH_SEP + DatNam;
  Ver.FileName := klein( Ver.FileName + Ver.Rubrik + PATH_SEP + DatNam);

  ASSIGN(f,FileName);
  REWRITE(f);
  IF IORESULT<>0 THEN exit;
  WRITELN(f,StringD(' ',255));
  WRITELN(f,StringD(' ',255));
  WRITELN(f,'SND '+Ver.Absender);
  WRITELN(f,'REC '+Ver.Rubrik);
  WRITELN(f,'SUB '+Ver.titel);
  STR(Ver.LifeTime,Hlp);
  WRITELN(f,'LTM '+Hlp);
  WRITELN(f,'VER '+Ver.MBX);
  WRITELN(f,'BID '+Ver.BID);
  WRITELN(f,'UXT ',currixtime);
  WRITELN(f,'NNNN');
  SFHeaderText(Ver.RX_Datum,TRUE,Ver.BID,FALSE);

END;


PROCEDURE ImportFiles;
VAR SR,Bignes: SearchRec;
    f,rx: Text;
    S,Hierach: STRING;
    VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
    line: WORD;
    Typ: CHAR;
    SysOp,Hold,DeleteIt: BOOLEAN;
    starttime:LONGINT;
    idxpos:WORD;chkpos:LONGINT;
    KILL:BOOLEAN;


PROCEDURE SaveFile(delimp :BOOLEAN) ;
BEGIN
   IF LINE<3 THEN DeleteIt:=TRUE;
   IF delimp THEN
   BEGIN   
      CLOSE(f);
      inoutres:=0;
      ERASE(f);
      inoutres:=0;
   END;
   IF NOT DeleteIt THEN BEGIN
      CLOSE(rx);
      inoutres:=0;
      FindFirst(BoxPath+Ver.FileName,$3F,Bignes);
      Ver.Groesse := Bignes.Size-SizeHeader(Ver.FileName);
      ASSIGN(VerFile,BoxPath+'index'+PATH_SEP+klein(Ver.Rubrik)+'.idx');
      {$I-}
      RESET(VerFile);
      IF IOResult = 0 THEN SEEK(VerFile,FILESIZE(VerFile))
      ELSE REWRITE(VerFile);
      {$I+}
      IF Ver.Filename[1]='U' THEN Typ := 'P'
      ELSE Typ := 'B';
      IF COPY(Ver.Titel,1,4)='ACK:' THEN Typ := 'A';
      {Evtl. Hold}
      Hold := HoldThisMail(FALSE,FALSE,Ver.Filename[1]='U',Ver,Typ);
      CheckForServer(ver,KILL);
      IF Hold THEN Ver.Flags := Ver.Flags OR VERWALT_HOLD;
      IF LENGTH(Ver.Rubrik)=1 THEN BEGIN
	 SysOp := TRUE;
	 IF (Ver.Rubrik='M') OR (Ver.Rubrik='E') THEN SysOp := FALSE;
      END
      ELSE SysOp := FALSE;
      
      {Mail zum Check-File dazu}
      idxpos:=FILEPOS(VerFile)+1;
      AddCheckFile(Ver,idxpos,Hold,SysOp,chkpos);
      
      WRITE(VerFile,Ver);
      CLOSE(VerFile);
      AddSFListe('',Ver,Typ,TRUE,Hierach,Hold,FALSE);
      AddBIDFile(ver.BID,ver.rubrik,idxpos,chkpos);
      { Neue Mail zum DirInfo-Array dazu }
      CASE Typ OF
	'B' : AddDirInfoList(ver.rubrik,'I');  {Info-Rubrik}
	'P' : AddDirInfoList(ver.rubrik,'U');  {User-Mail}
	'A' : AddDirInfoList(ver.rubrik,'U');  {ACK-Mails sind fr User}
      END;  
   END ELSE
   BEGIN
      {$I-}
      Close(rx);
      IF IOresult=0 THEN;
      Erase(rx);
      IF IOresult=0 THEN;
      {$I+}
   END;
END;

BEGIN
  STARTTIME:=currixtime;
  FindFirst(BoxPath+'import'+PATH_SEP+'*.*',Archive,SR);
  WHILE doserror = 0 DO BEGIN
    IF currixtime-starttime>30 THEN
      exit;
    IF SR.Name[1] <> '.' THEN BEGIN
      ASSIGN(f,BoxPath+'import'+PATH_SEP+SR.Name);
      RESET(f);
      line := 0;
      DeleteIt := FALSE;
      WHILE NOT EOF(f) AND NOT DeleteIt DO BEGIN
        READLN(f,S);
        line := line + 1;

        Hierach := '';
        CASE line OF
          1 : DeleteIt := ZerpflueckSendLine(S,Ver,Hierach);
          2 : SaveTitelAndMakeHeader(S,Ver,rx);
	ELSE
	   IF gross(s)='/EX' THEN
	      savefile(false)
	   ELSE
	      WRITELN(rx,S);
        END;
      END;
      savefile(true)
    END;
    FindNext(SR);
  END;
END;


END.


