(***************************************************************************)
(**                            UNIT BOXSEND.PAS                           **)
(***************************************************************************)
(**  Alle Routinen fr den Send-Befehl. (incl. Mailbox-Autobin-RX)        **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXSEND;


INTERFACE

PROCEDURE FileEingeben(ch: BYTE; S: STRING);
PROCEDURE AddFileHeader(ch: BYTE);
PROCEDURE Send_Titeleingeb(ch: BYTE; S: STRING);
PROCEDURE Send_CallEingeb(ch: BYTE; S: STRING);
PROCEDURE Send(ch: BYTE; S: STRING);


IMPLEMENTATION

USES IADVAR,BOXUTIL,TOOLBOX,DOS,BOXVARS,
     BOXHUSER,BOXSF,WGTCRC,BOXHOLD,{$IFNDEF LINUX}MEMORY,{$ENDIF}BOXSERV;


PROCEDURE FileEingeben(ch: BYTE; S: STRING);
LABEL Fertig;
TYPE T_Arr255 = ARRAY[1..255] OF CHAR;
VAR Verwalt: Verwalt_Rec;
    VerwaltFile: FILE OF Verwalt_Rec;
    SR: SearchRec;
    aword: WORD;
    DT: DateTime;
    i: WORD;
    OK: BOOLEAN;
    Hlp: STRING;
    Result: WORD;
    Arr255: T_Arr255;
    Size: LONGINT;
    SizeOK: BOOLEAN;
    FileName: STRING;
    FileNameOK,SysOp,Hold,Kill: BOOLEAN;
    Typ: CHAR;
    idxpos:WORD;chkpos:LONGINT;
BEGIN

  IF KS[ch]^.BoxData^.SendData^.BIN THEN BEGIN
    WITH KS[ch]^.BoxData^.SendData^ DO BEGIN

      FOR i := 1 TO LENGTH(S) DO Arr255[i] := S[i];

      BLOCKWRITE(BIN_F,Arr255,LENGTH(S),Result);
      BIN_Akt := BIN_Akt + Result;
      BIN_CRC := BuildStringCRC(S,BIN_CRC);

      IF BIN_Akt=BIN_Len THEN BEGIN
        KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_LINEMODE;
        IF BIN_CRC <> BIN_CRC_Got THEN BEGIN
          CLOSE(BIN_F);
          PutData(ch,#13+'*** Checksum error'+#13#13+BoxPrompt(ch));
          DISPOSE(KS[ch]^.BoxData^.SendData);
          KS[ch]^.BoxData^.status := 0;
          Exit;
        END;
        GOTO Fertig;
      END;
      Exit;
    END;
  END;

  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF (Gross(S)='***END') OR (S=#26) THEN BEGIN
    Fertig:

    {File schlieen}
    IF KS[ch]^.BoxData^.SendData^.BIN THEN CLOSE(KS[ch]^.BoxData^.SendData^.BIN_F)
                                      ELSE CLOSE(KS[ch]^.BoxData^.Senddata^.f);

    WITH KS[ch]^.BoxData^.SendData^ DO BEGIN
      IF (Hierach='') AND (Rufz(Verteiler)) THEN Hierach := Hierachie(Verteiler);
    END;

    {Lifetime kontrollieren bzw. setzen}
    IF KS[ch]^.BoxData^.SendData^.UserMail THEN BEGIN
      IF NOT KS[ch]^.BoxData^.SendData^.LTOK THEN KS[ch]^.BoxData^.SendData^.LT := OwnBoxData^.User_LT;
    END
    ELSE BEGIN
      IF KS[ch]^.BoxData^.SendData^.LTOK THEN CheckLT(KS[ch]^.BoxData^.SendData^.LT,KS[ch]^.BoxData^.SendData^.An)
                                         ELSE StandardLT(KS[ch]^.BoxData^.SendData^.LT,KS[ch]^.BoxData^.SendData^.An);
    END;


    ASSIGN(VerwaltFile,BoxPath+'index'+PATH_SEP+klein(KS[ch]^.BoxData^.SendData^.An_Trans)+'.idx');
    {$I-}
    RESET(Verwaltfile);
    {$I+}
    IF IOResult = 0 THEN SEEK(VerwaltFile,FILESIZE(VerwaltFile))
                    ELSE REWRITE(VerwaltFile);

    {Verwaltungsrecord setzen}
    Verwalt.Titel := KS[ch]^.BoxData^.SendData^.Titel;
    Verwalt.Absender := CutSSID(KS[ch]^.Call);
    Verwalt.Rubrik := KS[ch]^.BoxData^.SendData^.An_Trans;
    Verwalt.MBX := KS[ch]^.BoxData^.SendData^.Verteiler;
     IF KS[ch]^.BoxData^.SendData^.UserMail THEN
	Verwalt.FileName := 'user' + PATH_SEP + klein(KS[ch]^.BoxData^.SendData^.An_Trans) + PATH_SEP +
	KS[ch]^.BoxData^.SendData^.FileName
     ELSE
	Verwalt.FileName := 'info' +PATH_SEP +klein( KS[ch]^.BoxData^.SendData^.An_Trans) + PATH_SEP +
                                                       KS[ch]^.BoxData^.SendData^.FileName;
    Verwalt.RX_Datum:=Unix2Pack(CurrIxTime);
    Verwalt.BID := KS[ch]^.BoxData^.SendData^.BID;
    FindFirst(BoxPath+Verwalt.FileName,$3F,SR);
    Verwalt.Groesse := SR.Size-SizeHeader(Verwalt.FileName);
    Verwalt.Lifetime := KS[ch]^.BoxData^.SendData^.LT;
    {Alle Flags auf FALSE setzen. Flags: siehe BOXVARS.PAS}
    Verwalt.Flags := 0;

    {Evtl. Hold-Flag setzen}
    IF KS[ch]^.BoxData^.SendData^.Usermail THEN Typ := 'P'
                                           ELSE Typ := 'B';
    Hold := HoldThisMail(FALSE,KS[ch]^.BoxData^.PW,KS[ch]^.BoxData^.SendData^.Usermail,Verwalt,Typ);


    {M_FILTER:
     Aufrufen mit Parameter Filename (incl. BoxPath).
     Rckgabe: exitcode 0: Mail OK
                        1: Hold
                        2: Kill}
    Kill := FALSE;
    IF LENGTH(OwnBoxData^.M_FILTER)>0 THEN BEGIN
      {$IFNDEF LINUX} 
      SetMemTop(HeapPtr);
      dos.exec(OwnBoxData^.M_FILTER,BoxPath+Verwalt.Filename);
      SetMemTop(HeapEnd);
       {$ENDIF}
      IF doserror=0 THEN BEGIN
        CASE DosExitCode OF
          1: Hold := TRUE;
          2: Kill := TRUE;
        END;
      END;
    END;

    {Wenn nicht als KILL oder Hold markiert, wird geguckt, ob die Mail
     fr den Server interessant ist.}
    IF NOT Kill AND NOT Hold THEN
        CheckForServer(Verwalt,Kill);


    IF NOT Kill THEN BEGIN
      {File in die S&F-Liste eintragen}
      AddSFListe('XXXXXX',Verwalt,TYP,TRUE,KS[ch]^.BoxData^.SendData^.Hierach,Hold,FALSE);


      {Lifetime kontrollieren bzw. setzen}
      IF NOT KS[ch]^.BoxData^.SendData^.UserMail THEN BEGIN
        IF KS[ch]^.BoxData^.SendData^.LTOK THEN
	   CheckLT(KS[ch]^.BoxData^.SendData^.LT,KS[ch]^.BoxData^.SendData^.An_Trans)
	ELSE StandardLT(KS[ch]^.BoxData^.SendData^.LT,KS[ch]^.BoxData^.SendData^.An_Trans);
      END;


      IF KS[ch]^.BoxData^.SendData^.BIN THEN Verwalt.Titel := '(BIN) '+Verwalt.Titel;

      IF LENGTH(Verwalt.Rubrik)=1 THEN BEGIN
        SysOp := TRUE;
        IF (Verwalt.Rubrik='M') OR (Verwalt.Rubrik='E') THEN SysOp := FALSE;
      END
      ELSE SysOp := FALSE;

      IF Hold THEN
      BEGIN
        Verwalt.Flags := Verwalt.Flags OR VERWALT_HOLD;
        ProfileBox('HOLD (Send from'+cutssid(KS[ch]^.call)+'): $'+verwalt.bid+' '+verwalt.rubrik+'@'+verwalt.mbx+' <'+
                   verwalt.absender,PBOX_HOLD);
      END;
      {Mail zum Check-File dazu}
      idxpos:=FILEPOS(VerwaltFile)+1;
      AddCheckFile(Verwalt,idxpos,Hold,SysOp,chkpos);
      AddBIDFile(verwalt.BID,verwalt.rubrik,idxpos,chkpos);
      WRITE(VerwaltFile,Verwalt);
    END;
    CLOSE(VerwaltFile);

    KS[ch]^.BoxData^.status := 0;       {status: Kommandos eingeben}
    DISPOSE(KS[ch]^.BoxData^.SendData); {Speicher wieder freigeben}
    KS[ch]^.BoxData^.SendData := NIL;

    IF NOT Kill THEN BEGIN
      AddOneSend(Gross(CutSSID(Verwalt.Absender)));
      IF Rufz(Verwalt.Rubrik) THEN BEGIN
        AddOneGet(Gross(Verwalt.Rubrik));
        BenachrichtigeUser(Gross(Verwalt.Rubrik),ch);
      END;

      OK := FALSE;
      FOR i := 1 TO AnzRub DO BEGIN
        IF DirInfo[i]^.Rubrik = Verwalt.Rubrik THEN BEGIN
          OK := TRUE;
          DirInfo[i]^.Mails := DirInfo[i]^.Mails + 1;
        END;
      END;
      IF NOT OK THEN BEGIN
        AnzRub := AnzRub + 1;
        new(DirInfo[AnzRub]);
        DirInfo[AnzRub]^.Rubrik := Verwalt.Rubrik;
        DirInfo[AnzRub]^.Mails := 1;
        DirInfo[AnzRub]^.Art := Verwalt.FileName[1];
        SortDirInfo;
      END;
    END
    ELSE BEGIN
      ASSIGN(KS[ch]^.BoxData^.Senddata^.f,BoxPath+Verwalt.Filename);
      {$I-}
      ERASE(KS[ch]^.BoxData^.Senddata^.f);
      {$I+}
      IF IOResult<>0 THEN BEGIN END;
    END;

    KS[ch]^.BoxData^.Rubrik := Verwalt.Rubrik;

    STR(Verwalt.Groesse,S);
    PutData(ch,#13+SysText(ch,36)+' '+Verwalt.Rubrik+ ' @ ' + Verwalt.MBX+Hierachie(Verwalt.MBX)+#13+'('+S+' Bytes)'+#13);
    PutData(ch,'Routing:'+routingto+#13);
    IF Hold THEN PutData(ch,'File held for SysOp''s review.'+#13);
    PutData(ch,#13+BoxPrompt(ch));

  END
  ELSE BEGIN
    IF COPY(S,1,5)='#BIN#' THEN BEGIN
      WITH KS[ch]^.BoxData^.SendData^ DO BEGIN
        {Variablen initialisieren}
        SizeOK := FALSE;
        FileNameOK := FALSE;

        {#BIN# aus dem String 'rausschneiden}
        S := COPY(S,6,255);

        {Lnge nach Hlp und weiter nach BIN_Len}
        Hlp := COPY(S,1,POS('#',S)-1);
        S := COPY(S,POS('#',S)+1,255);
        VAL(Hlp,BIN_Len,aword);

        {CRC einlesen und nach BIN_CRC_Got speichern}
        Hlp := COPY(S,1,POS('#',S)-1);
        S := COPY(S,POS('#',S)+1,255);
        IF Hlp[1]='|' THEN Hlp := COPY(Hlp,2,255);
        VAL(Hlp,BIN_CRC_Got,aword);
        KS[ch]^.FLAGS := KS[ch]^.FLAGS AND NOT KS_LINEMODE;
        BIN_Akt := 0;
        BIN_CRC := 0;

        CLOSE(f);
        IF UserMail THEN ASSIGN(BIN_F,BoxPath+'user'+PATH_SEP+klein(An) + PATH_SEP + FileName)
                    ELSE ASSIGN(BIN_F,BoxPath+'info'+PATH_SEP+An + PATH_SEP + FileName);
        RESET(BIN_F,1);

        SEEK(BIN_f,FILESIZE(BIN_F));

        S := '#BIN';
        STR(BIN_Len,Hlp);
        S := S + '#'+Hlp;
        STR(BIN_CRC_Got,Hlp);
        FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := '0' + Hlp;
        S := S + '#|'+Hlp;

        aword := 1;
        Arr255[1] := #13;
        FOR i := 1 TO LENGTH(S) DO Arr255[i+1] := S[i];
        aword := aword + LENGTH(S)+1;
        Arr255[aword] := #13;

        BLOCKWRITE(BIN_F,Arr255,aword,Result);

        BIN := TRUE;
        PutData(ch,'#OK#'+#13);
        Exit;
      END;
    END;

    IF S=#24 THEN BEGIN
      {Abbruch}
      CLOSE(KS[ch]^.BoxData^.Senddata^.f);      {Und File schlieen}
      {$I-}
      ERASE(KS[ch]^.BoxData^.Senddata^.f);
      {$I+}
      IF IOResult=0 THEN BEGIN END;
      PutData(ch,#13+'Send abgebrochen.'+#13#13+BoxPrompt(ch));
      KS[ch]^.BoxData^.status := 0;       {status: Kommandos eingeben}
      DISPOSE(KS[ch]^.BoxData^.SendData); {Speicher wieder freigeben}
      KS[ch]^.BoxData^.SendData := NIL;
    END
    ELSE WRITELN(KS[ch]^.BoxData^.SendData^.f,S);
  END;
END;


{Datei ffnen und den Fileheader dazu}
PROCEDURE AddFileHeader(ch: BYTE);
VAR DatNam,FileName: STRING;
    jetzt: LONGINT;
    aword: WORD;
    S,Hlp: STRING;
    Name: STRING;
    tmp: BOOLEAN;
BEGIN
  jetzt := currixtime;
  IF jetzt <> LastTime THEN BEGIN
    AnzPerSec := 0;
    LastTime := jetzt;
  END
  ELSE BEGIN
    AnzPerSec := AnzPerSec + 1;
  END;
  DatNam := klein(XHex(jetzt));
  STR(AnzPerSec,FileName);
  DatNam := DatNam + '.' + FileName;

  FileName := BoxPath;
   IF KS[ch]^.BoxData^.SendData^.UserMail THEN FileName := BoxPath + 'user'+PATH_SEP
                                         ELSE FileName := BoxPath + 'info'+PATH_SEP;

  {Mail transferieren und neuen Rubriken-Namen abspeichern}
  KS[ch]^.BoxData^.SendData^.An_Trans := TransferMail(KS[ch]^.BoxData^.SendData^.An);

  {Rubrik an den Filenamen anhngen}
  FileName := klein(FileName + KS[ch]^.BoxData^.SendData^.An_Trans);

  {$I-}
  MKDIR(FileName);
  {$I+}
  IF IOResult=5 THEN BEGIN END;


  FileName := FileName + PATH_SEP + DatNam;
  {$I-}
  ASSIGN(KS[ch]^.BoxData^.SendData^.f,FileName);
  REWRITE(KS[ch]^.BoxData^.SendData^.f);
  {$I+}
  IF IORESULT<>0 THEN
  BEGIN
    PutData(ch,'IO-Error, BOXSEND.PAS/rewite :'+FileName+#13);
    exit;
  END;
  KS[ch]^.BoxData^.SendData^.FileName := DatNam;
  WRITELN(KS[ch]^.BoxData^.SendData^.f,StringD(' ',255));
  WRITELN(KS[ch]^.BoxData^.SendData^.f,StringD(' ',255));
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'SND '+CutSSID(KS[ch]^.Call));
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'REC '+KS[ch]^.BoxData^.SendData^.An);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'SUB '+KS[ch]^.BoxData^.SendData^.Titel);  STR(KS[ch]^.BoxData^.SendData^.LT,Hlp);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'LTM '+Hlp);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'VER '+KS[ch]^.BoxData^.SendData^.Verteiler);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'BID '+KS[ch]^.BoxData^.SendData^.BID);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'UXT ',currixtime);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'NNNN');
  jetzt:=Unix2Pack(jetzt);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,SFHeaderText(jetzt,TRUE,KS[ch]^.BoxData^.SendData^.BID,FALSE));
  Name := GetName(tmp,ch);


  {In der From: - Zeile im Header wird ab jetzt CALL @ HOMEBBS und in
   Klammern der Name angegeben!}
  S := 'From: '+CutSSID(KS[ch]^.Call) + ' @ ';
  Hlp := GetMyBBS(CutSSID(KS[ch]^.Call));

  IF (Hlp='') OR (Hlp=CutSSID(BoxCall)) THEN BEGIN
    S := S + CutSSID(BoxCall)+OwnBoxData^.Hierach;
  END
  ELSE S := S + Hlp+Hierachie(Hlp);
  IF Name <> '' THEN S := S + '   ('+Name+')';

  WRITELN(KS[ch]^.BoxData^.SendData^.f,S);
  WRITELN(KS[ch]^.BoxData^.SendData^.f,'To  : '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler+
      KS[ch]^.BoxData^.SendData^.Hierach);
  WRITELN(KS[ch]^.BoxData^.SendData^.f);

  KS[ch]^.BoxData^.SendData^.BIN := FALSE;
END;


{Titel wurde eingeben - speichern und weiter}
PROCEDURE Send_Titeleingeb(ch: BYTE; S: STRING);
BEGIN
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  KS[ch]^.BoxData^.SendData^.Titel := S;

  {Eigentliche Mail eingeben}
  KS[ch]^.BoxData^.SendData^.Titel := S;
  KS[ch]^.BoxData^.status := 3;    {Mail eingeben}
  IF Hierachie(KS[ch]^.BoxData^.SendData^.Verteiler)<>'' THEN
       PutData(ch,#13+SysText(ch,34)+' '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler
             +Hierachie(KS[ch]^.BoxData^.SendData^.Verteiler)+#13)
    ELSE
       PutData(ch,#13+SysText(ch,34)+' '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler
             +KS[ch]^.BoxData^.SendData^.Hierach+#13);
  PutData(ch,SysText(ch,35)+#13#13);

  AddFileHeader(ch);

END;


{Rufzeichen wurde eingegeben - hier auswerten}
PROCEDURE Send_CallEingeb(ch: BYTE; S: STRING);
VAR Hlp: STRING;
BEGIN

  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF S='' THEN BEGIN
    PutData(ch,#13+SysText(ch,115)+#13#13+BoxPrompt(ch));
    KS[ch]^.BoxData^.status := 0;
    Exit;
  END;

  IF POS('@',S) > 0 THEN BEGIN
    WHILE S[POS('@',S)-1]=#32 DO DELETE(S,POS('@',S)-1,1);
    WHILE S[POS('@',S)+1]=#32 DO DELETE(S,POS('@',S)+1,1);
    KS[ch]^.BoxData^.SendData^.An := COPY(S,1,POS('@',S)-1);
    Hlp := COPY(S,POS('@',S)+1,255);
    IF POS('.',Hlp)>0 THEN BEGIN
      KS[ch]^.BoxData^.SendData^.Verteiler := COPY(Hlp,1,POS('.',hlp)-1);
      KS[ch]^.BoxData^.SendData^.Hierach := COPY(Hlp,POS('.',hlp),255);
    END
    ELSE BEGIN
      KS[ch]^.BoxData^.SendData^.Verteiler := Hlp;
      KS[ch]^.BoxData^.SendData^.Hierach := '';
      IF Rufz(hlp) THEN
         KS[ch]^.BoxData^.SendData^.Hierach := Hierachie(Hlp);
    END;
  END
  ELSE BEGIN
    KS[ch]^.BoxData^.SendData^.An := S;
    KS[ch]^.BoxData^.SendData^.Verteiler := CutSSID(BoxCall);
  END;

  KS[ch]^.BoxData^.SendData^.An := Gross(KS[ch]^.BoxData^.SendData^.An);
  KS[ch]^.BoxData^.SendData^.Verteiler := Gross(KS[ch]^.BoxData^.SendData^.Verteiler);
  KS[ch]^.BoxData^.SendData^.Hierach := Gross(KS[ch]^.BoxData^.SendData^.Hierach);
  KS[ch]^.BoxData^.SendData^.UserMail := Rufz(KS[ch]^.BoxData^.SendData^.An);

  {Titel eingeben}
  KS[ch]^.BoxData^.status := 2;
  PutData(ch,#13+SysText(ch,33)+#13+'>>> ');

END;


PROCEDURE Send(ch: BYTE; S: STRING);
VAR Hlp,hlp1: STRING;
    code: WORD;
    LT: WORD;
    OK: BOOLEAN;
    Ufile: BOOLEAN;
BEGIN
  NEW(KS[ch]^.BoxData^.SendData);

  {Bulletin-ID setzen}
  KS[ch]^.BoxData^.SendData^.BID := Neu_BID;
  KS[ch]^.BoxData^.SendData^.Hierach := '';
  S := LTRIM(RTRIM(OnlyOneSpace(S)));

  {Evtl. RETURN abschneiden}
  IF S[LENGTH(S)] = #13 THEN S := COPY(S,1,LENGTH(S)-1);

  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';
  UFILE:=FALSE;
  {Soll das File unbedingt als Userfile geforwardet werden?}
  IF (COPY(S,1,1)='-') AND (S<>'') THEN
  BEGIN
    Hlp := Gross(COPY(S,2,255));
    IF POS(' ',Hlp)>0 THEN
    BEGIN
      S := COPY(S,POS(' ',S)+1,255);
      Hlp := COPY(Hlp,1,POS(' ',Hlp)-1);
      IF Hlp='P' THEN UFile := TRUE
                 ELSE UFile := FALSE;
    END
    ELSE
    BEGIN
      S := '';
      IF Hlp='P' THEN UFile := TRUE
                 ELSE UFile := FALSE;
    END;
  END;

  {Kontrolle, ob eine Lifetime mit angegeben wurde}
  Hlp := S;
  KS[ch]^.BoxData^.SendData^.LTOK := FALSE;
  IF S[1]='#' THEN BEGIN
    WHILE S[2]=#32 DO DELETE(S,2,1);    {Leerzeichen 'raus machen}
    IF POS(' ',S)>0 THEN S := COPY(S,2,POS(' ',S)-2)
                    ELSE S := COPY(S,2,255);
    VAL(S,lt,code);
    IF (code=0) AND (LENGTH(S)>0) THEN BEGIN
      KS[ch]^.BoxData^.SendData^.LT := LT;
      IF POS(' ',Hlp)>0 THEN BEGIN
         S := Hlp;
         WHILE S[2]=#32 DO DELETE(S,2,1);    {Leerzeichen 'raus machen}
         S := COPY(S,POS(' ',S)+1,255)
      END
      ELSE S := '';
      KS[ch]^.BoxData^.SendData^.LTOK := TRUE;
    END
    ELSE S := Hlp;
  END;


  IF LENGTH(S) = 0 THEN BEGIN   {Es wurde kein Rufzeichen angegeben}
    KS[ch]^.BoxData^.status := 1;   {Rufzeichen eingeben}
    PutData(ch,#13+SysText(ch,32)+#13+'>>> ');
    Exit;
  END;

  {Kontrolle, ob ein Verteiler angegeben wurde}
  Hlp := S;
  IF POS('@',S) > 0 THEN BEGIN
    WHILE S[POS('@',S)-1]=#32 DO DELETE(S,POS('@',S)-1,1);
    WHILE S[POS('@',S)+1]=#32 DO DELETE(S,POS('@',S)+1,1);
    KS[ch]^.BoxData^.SendData^.An := Gross(COPY(S,1,POS('@',S)-1));
    IF POS(' ',S) > 0 THEN BEGIN
      Hlp := Gross(COPY(S,POS('@',S)+1,255));
      Hlp := COPY(Hlp,1,POS(' ',Hlp)-1);
      IF POS('.',Hlp)>0 THEN BEGIN
        KS[ch]^.BoxData^.SendData^.Verteiler := COPY(Hlp,1,POS('.',hlp)-1);
        KS[ch]^.BoxData^.SendData^.Hierach := COPY(Hlp,POS('.',hlp),255);
      END
      ELSE BEGIN
        KS[ch]^.BoxData^.SendData^.Verteiler := Hlp;
        KS[ch]^.BoxData^.SendData^.Hierach := '';
      END;
      S := COPY(S,POS(' ',S)+1,255);
    END
    ELSE BEGIN
      Hlp := Gross(COPY(S,POS('@',S)+1,255));
      IF POS('.',Hlp)>0 THEN BEGIN
        KS[ch]^.BoxData^.SendData^.Verteiler := COPY(Hlp,1,POS('.',hlp)-1);
        KS[ch]^.BoxData^.SendData^.Hierach := COPY(Hlp,POS('.',hlp),255);
      END
      ELSE BEGIN
        KS[ch]^.BoxData^.SendData^.Verteiler := Hlp;
        KS[ch]^.BoxData^.SendData^.Hierach := '';
        IF Rufz(hlp) THEN
          KS[ch]^.BoxData^.SendData^.Hierach := Hierachie(Hlp);
      END;
      S := '';
    END;
  END
  ELSE BEGIN
    IF POS(' ',S) > 0 THEN BEGIN
      KS[ch]^.BoxData^.SendData^.An := Gross(COPY(S,1,POS(' ',S)-1));
      S := COPY(S,POS(' ',S)+1,255);
    END
    ELSE BEGIN
      KS[ch]^.BoxData^.SendData^.An := Gross(S);
      S := '';
    END;
    IF Rufz(KS[ch]^.BoxData^.SendData^.An) THEN BEGIN
      KS[ch]^.BoxData^.SendData^.Verteiler := GetMYBBS(KS[ch]^.BoxData^.SendData^.An);
      IF KS[ch]^.BoxData^.SendData^.Verteiler = '' THEN KS[ch]^.BoxData^.SendData^.Verteiler := Gross(CutSSID(BoxCall));
    END
    ELSE KS[ch]^.BoxData^.SendData^.Verteiler := Gross(CutSSID(BoxCall));
  END;

  {Is der Empfnger ein Board oder ein User? (Auch kontrollieren, ob der
   Parameter -P angegeben wurde (force Personal Mail)}
  WITH KS[ch]^.BoxData^.SendData^ DO
     IF NOT UFile THEN UserMail := Rufz(An)
                  ELSE UserMail := TRUE;


  IF S = '' THEN BEGIN    {Titel eingeben}
    KS[ch]^.BoxData^.status := 2;
    PutData(ch,#13+SysText(ch,33)+#13+'>>> ');
    Exit;
  END;

  {Das, was jetzt noch von S brig geblieben ist, ist der Titel}
  KS[ch]^.BoxData^.SendData^.Titel := S;
  KS[ch]^.BoxData^.status := 3;    {Mail eingeben}
  IF Hierachie(KS[ch]^.BoxData^.SendData^.Verteiler)<>'' THEN
       PutData(ch,#13+SysText(ch,34)+' '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler
             +Hierachie(KS[ch]^.BoxData^.SendData^.Verteiler)+#13)
    ELSE
       PutData(ch,#13+SysText(ch,34)+' '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler
             +KS[ch]^.BoxData^.SendData^.Hierach+#13);

  PutData(ch,SysText(ch,35)+#13#13);

  AddFileHeader(ch);

END;




END.
