
(**                            UNIT BOXSFFBB.PAS                          **)
(***************************************************************************)
(**  Routinen frs gepackte F6FBB-S&F.                                    **)
(**  Nicht frs Overlay.                                                  **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXSFFBB;


INTERFACE

PROCEDURE FBB_SF(ch: BYTE; S: STRING);


IMPLEMENTATION

USES BOXSF,IADVAR,WGTCRC,BOXUTIL,BOXVARS,TOOLBOX,DOS, (*EXEC,*)
     BOXHUSER,{$IFNDEF LINUX}MEMORY,{$ENDIF}BOXIMP,MYSTRING,BOXHOLD,BOXSERV,CRT,UNPROTO;

TYPE T_PutCharArray = ARRAY[1..256] OF CHAR;


{Berechnet die CCITT-CRC eines kompletten Files - Fr B1}
PROCEDURE CalcFileCCITT_CRC(FileName: STRING; VAR CRC: WORD);
TYPE tArr255 = ARRAY[1..255] OF CHAR;
VAR f: FILE;
    Result: WORD;
    Arr255: tArr255;
BEGIN

  {File ffnen}
  ASSIGN(f,FileName);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult<>0 THEN Exit;

  REPEAT
    BLOCKREAD(f,Arr255,255,Result);
    CRC := BuildBufferCRCF6FBB(Arr255,Result,CRC);
  UNTIL Result < 255;

  CLOSE(f);
END;





{FBB-Forward  -  Liste der angebotenen Mails speichern}
PROCEDURE Get_Proposal(ch: BYTE; S: STRING);
VAR Anz: BYTE;
    code: WORD;
    Hlp: STRING;
BEGIN
  IF (NOT (S[2] IN ['A','B','D'])) OR (S[3]<>' ') THEN
  BEGIN
    PutData(ch,'*** protocol error '+#13);
    KS[ch]^.Flags:=KS[ch]^.Flags OR KS_DISCREQ;
    EXIT;
  END;

  IF NOT KS[ch]^.FBBSFData^.Set2Null THEN BEGIN
    KS[ch]^.FBBSFData^.Set2Null := TRUE;
    KS[ch]^.FBBSFData^.AnzProposal := 0;
  END;
{
  Beispiels-Vorschlagzeile:
Ohne 'D' in der SID:
FB P F6FBB FC1GHV FC1MVP 24657_F6FBB 1345
Mit 'D' in der SID:
FD P DL8HBS DB0EAM DL3AAA 31310ADL8HBS 700 20
Mit Platzhaltern:
FD <Typ> <Absender> <@MBX-Feld> <Rubrik> <BID> <Gre> <LT>

Mit H in der SID kann natrlich bei @MBX eine Hierachie angegeben werden.
}

  WITH KS[ch]^.FBBSFData^ DO BEGIN
    IF Features.D THEN BEGIN
      Hlp := S;
      IF POS(#13,Hlp)>0 THEN DELETE(Hlp,POS(#13,Hlp),1);
      KS[ch]^.FBBSFData^.Chck16 := BuildStringCRC(Hlp,KS[ch]^.FBBSFData^.Chck16)
    END
    ELSE ChckSum := CheckSum(S,ChckSum);

    S := COPY(S,1,POS(#13,S)-1);
    AnzProposal := AnzProposal + 1;
  END; {WITH KS[ch]^.FBBSFData^}
  Anz := KS[ch]^.FBBSFData^.AnzProposal;

  WITH KS[ch]^.FBBSFData^.MailDat[Anz] DO BEGIN
    Typ := S[POS(' ',S)+1];
    S := COPY(S,6,255);
    Sender := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
    Verteiler := COPY(S,1,POS(' ',S)-1);
    IF POS('.',Verteiler) > 0 THEN BEGIN
      Hierach := COPY(Verteiler,POS('.',Verteiler),255);
      Verteiler := COPY(Verteiler,1,POS('.',Verteiler)-1);
    END
    ELSE Hierach := '';
    S := COPY(S,POS(' ',S)+1,255);
    An := COPY(S,1,POS(' ',S)-1);
    AnTransfer := TransferMail(An);
    S := COPY(S,POS(' ',S)+1,255);
    BID := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);

    IF POS(' ',S)>0 THEN BEGIN    {Es ist auch noch eine Lifetime-Angabe
                                   gemacht worden}
      VAL(COPY(S,1,POS(' ',S)-1),Size,code);
      VAL(COPY(S,POS(' ',S)+1,255),LT,code);
      LT_Angegeben := TRUE;
    END
    ELSE BEGIN                    {Keine Grenangbe}
      VAL(S,Size,code);
      IF Typ = 'P' THEN LT := OwnBoxData^.User_LT
                   ELSE StandardLT(LT,An);
      LT_Angegeben := FALSE;
    END;
  END; {WITH KS[ch]^.FBBSFData^.MailDat[Anz]}
END;



{Bei F6FBB-Forward die CRC Testen - 16-Bit-DieBox-CRC oder eine 8-Bit-
 Quersumme}
FUNCTION TestCRC(ch: BYTE; S: STRING): BOOLEAN;
VAR code: WORD;
    TheirCRC,OurCRC: WORD;
    OK: BOOLEAN;
BEGIN
  WHILE POS(#13,S) > 0 DO DELETE(S,POS(#13,S),1);
  S := COPY(S,4,255);

  {D-Flag gefunden - 16-Bit-DieBox-CRC}
  IF KS[ch]^.FBBSFData^.Features.D THEN BEGIN
    OurCRC := KS[ch]^.FBBSFData^.Chck16;
    OK := ConvertHexStringToWord(S,TheirCRC);

    {Test, ob die Wandlung erfolgreich war}
    IF NOT OK THEN BEGIN
      KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
      PutData(ch,'*** Checksum error'+#13);
      TestCRC := FALSE;
      Exit;
    END;

    TheirCRC := (Lo(TheirCRC)*256) + Hi(TheirCRC);
    TestCRC := TRUE;
    IF OurCRC <> TheirCRC THEN BEGIN
      KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
      PutData(ch,'*** Checksum error'+#13);
      TestCRC := FALSE;
    END;

  END
  ELSE BEGIN    {Kein D-Flag -> 8-Bit-Quersumme}
    OurCRC := (NOT KS[ch]^.FBBSFData^.ChckSum)+1;
    OK := ConvertHexStringToWord(S,TheirCRC);
    TestCRC := TRUE;
    IF (OurCRC <> TheirCRC) OR NOT OK THEN BEGIN
      KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
      PutData(ch,'*** Checksum error'+#13);
      TestCRC := FALSE;
    END;
  END;
END;



{FS-Zeile generieren (Antwort auf eine Vorschlag-Paket}
FUNCTION GenerateFS_Line(ch: BYTE; S: STRING): STRING;
VAR FSLine: STRING;
    i,B,B1: BYTE;
    OK:BOOLEAN;
BEGIN
  FSLine := '';
  FOR i := 1 TO KS[ch]^.FBBSFData^.AnzProposal DO
     KS[ch]^.FBBSFData^.MailDat[i].send:='?';
  FOR i := 1 TO KS[ch]^.FBBSFData^.AnzProposal DO BEGIN

    {Wenn keine Thirdparty-Mails erlaubt sind (Mails, die von einer nicht
     eingetragenen S&F-Station geforwardet werden, und nicht von dieser
     Station stammen), wird eine Thirdparty-Mail abgelehnt.}
    IF NOT OwnBoxData^.Third_Party AND (KS[ch]^.FBBSFData^.MailDat[i].Sender<>CutSSID(KS[ch]^.Call))
                                   AND KS[ch]^.FBBSFData^.BOXSF_Partner THEN BEGIN
      FSLine := FSLine + '-';
      KS[ch]^.FBBSFData^.MailDat[i].Send := '-';
    END
    ELSE BEGIN

      IF (BID_Da(KS[ch]^.FBBSFData^.MailDat[i].BID)) THEN BEGIN
        FSLine := FSLine + '-';
        KS[ch]^.FBBSFData^.MailDat[i].Send := '-';

        {Wenn wir eine Mail die die Gegenstation auch hat, ablehnen,
         mu sie nicht nochmal der Gegenstation angeboten werden. (Redundanz)}
        DelSFFileEntry(KS[ch]^.FBBSFData^.MailDat[i].BID,CutSSID(KS[ch]^.Call));


        {Hier mu spter geguckt werden, ob das File als "angefangen" auf
         der Platte abgespeichert wurde. (mit IF davor)}

      END
      ELSE BEGIN
        OK:=TRUE;
        FOR B:=1 TO 255 DO BEGIN
          IF (KS[b]<>NIL) AND (KS[b]^.FBBSFData<>NIL) AND OK THEN
          BEGIN
            FOR B1:=1 to KS[b]^.FBBSFData^.AnzProposal DO
            BEGIN
              IF OK THEN
              IF (KS[b]^.FBBSFData^.MailDat[B1].BID=KS[ch]^.FBBSFData^.MailDat[i].BID)
                 AND (KS[b]^.FBBSFData^.MailDat[b1].send<>'=')  THEN
              IF (NOT ((b=ch) AND (b1=i))) THEN
              BEGIN
                FSLine := FSLine + '=';
                KS[ch]^.FBBSFData^.MailDat[i].Send := '=';
                OK:=FALSE;
              END;
            END;
          END ELSE
          IF (KS[b]<>NIL) AND (KS[b]^.DBSFData<>NIL) AND (b<>ch) AND OK THEN
          BEGIN
              IF (KS[b]^.DBSFData^.BID=KS[ch]^.FBBSFData^.MailDat[i].BID)  THEN
              BEGIN
                FSLine := FSLine + '=';
                KS[ch]^.FBBSFData^.MailDat[i].Send := '=';
                OK:=FALSE;
              END;
            END;
        END;
        IF OK THEN
        BEGIN
          FSLine := FSLine + '+';
          KS[ch]^.FBBSFData^.MailDat[i].Send := '+';
        END;
      END;
    END;
  END;
  GenerateFS_Line := 'FS '+FSLine;
END;


{Fileheader (ASCII-File) beim Empfangen erstellen}
PROCEDURE MakeFileHeader(Nr,ch: BYTE; Titel: STRING);
VAR DT: DateTime;
    jetzt: LONGINT;
    Endung: STRING[3];
    S: STRING;
    aword: WORD;
BEGIN
  IF POS(#13,Titel) > 0 THEN DELETE(Titel,POS(#13,Titel),1);

  KS[ch]^.FBBSFData^.MailDat[Nr].Titel := Titel;
  WITH KS[ch]^.FBBSFData^.MailDat[Nr] DO BEGIN
    IF Typ = 'P' THEN FileName := 'user'+PATH_SEP
    ELSE FileName := 'info'+PATH_SEP;
    FileName := FileName + klein(AnTransfer);
    {$I-}
     MKDir(klein(boxpath+FileName));
    {$I+}
    IF IOResult=5 THEN BEGIN END;
     FileName := FileName + PATH_SEP;

    jetzt := CurrIxTime;
    RX_Date:=unix2pack(jetzt);
    IF jetzt <> LastTime THEN BEGIN
      AnzPerSec := 0;
      LastTime := jetzt;
    END
    ELSE BEGIN
      AnzPerSec := AnzPerSec + 1;
    END;
    S := XHex(jetzt);
    STR(AnzPerSec,Endung);
    FileName := FileName + S + '.' + Endung;

    ASSIGN(KS[ch]^.FBBSFData^.f,BOXPATH+FileName);
    REWRITE(KS[ch]^.FBBSFData^.f);
    WRITELN(KS[ch]^.FBBSFData^.f,StringD(' ',255));
    WRITELN(KS[ch]^.FBBSFData^.f,StringD(' ',255));
    WRITELN(KS[ch]^.FBBSFData^.f,'SND '+Sender);
    WRITELN(KS[ch]^.FBBSFData^.f,'REC '+AnTransfer);
    WRITELN(KS[ch]^.FBBSFData^.f,'SUB '+Titel);
    STR(LT,S);
    WRITELN(KS[ch]^.FBBSFData^.f,'LTM '+S);
    WRITELN(KS[ch]^.FBBSFData^.f,'VER '+Verteiler);
    WRITELN(KS[ch]^.FBBSFData^.f,'BID '+BID);
    WRITELN(KS[ch]^.FBBSFData^.f,'UXT ',CurrIxTime);
    WRITELN(KS[ch]^.FBBSFData^.f,'NNNN');
    IF (An<>'M') AND (An<>'E') AND (Typ<>'A') THEN
        WRITELN(KS[ch]^.FBBSFData^.f,SFHeaderText(RX_Date,FALSE,BID,KS[ch]^.FBBSFData^.PW_Gesichert));
  END;
  KS[ch]^.FBBSFData^.RXFrom := CutSSID(BoxCall);
  KS[ch]^.FBBSFData^.SFPartner := '';
END;



{Welches File wird als nchstes Empfangen (bzw. soll als nchstes empfangen
 werden}
FUNCTION NaechstEmpfMail(ch: BYTE): BYTE;
VAR Naechst: BYTE;
    OK: BOOLEAN;
BEGIN
  OK := FALSE;
  Naechst := KS[ch]^.FBBSFData^.Akt + 1;
  WHILE (NOT OK) AND (naechst <= 5) DO
  BEGIN
    IF (KS[ch]^.FBBSFData^.MailDat[Naechst].Send = '+') OR (Naechst > KS[ch]^.FBBSFData^.AnzProposal) THEN BEGIN
      OK := TRUE;
    END;
    IF NOT OK THEN Naechst := Naechst + 1;
  END;
  NaechstEmpfMail := Naechst;
END;


PROCEDURE SaveVerwaltEintrag(ch: BYTE);
VAR VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
    DT: DateTime;
    aword: WORD;
    Kill,SysOp,OK,Hold: BOOLEAN;
    f: File;
    chkpos:LONGINT;
    idxpos:WORD;
BEGIN
  WITH KS[ch]^.FBBSFData^.MailDat[KS[ch]^.FBBSFData^.Akt] DO BEGIN
    ASSIGN(VerFile,BOXPATH+'index'+PATH_SEP+klein(AnTransfer)+'.idx');
    {$I-}
    RESET(VerFile);
    {$I+}
    IF IOResult = 0 THEN SEEK(VerFile,FILESIZE(VerFile))
                    ELSE REWRITE(VerFile);
    Ver.Titel := Titel;
    Ver.Absender := Sender;
    Ver.Rubrik := An;
    Ver.MBX := Verteiler;
    Ver.FileName := FileName;
    GetDate(DT.Year,DT.Month,DT.Day,aword);
    GetTime(DT.Hour,DT.Min,DT.Sec,aword);
    PackTime(DT,Ver.Rx_Datum);
    Ver.BID := BID;
    Ver.Groesse := Size;
    Ver.Lifetime := LT;
    {Flags auf 0 setzen. Siehe BOXVARS.PAS}
    Ver.Flags := 0;

    {Evtl. Hold}
    Hold := HoldThisMail(TRUE,FALSE,Ver.Filename[1]='U',Ver,Typ);



    {M_FILTER:
     Aufrufen mit Parameter Filename (incl. BoxPath).
     Rckgabe: exitcode 0: Mail OK
                        1: Hold
                        2: Kill}
    Kill := FALSE;
    IF LENGTH(OwnBoxData^.M_FILTER)>0 THEN BEGIN
{$IFNDEF LINUX}
       SetMemTop(HeapPtr);
      dos.exec(OwnBoxData^.M_FILTER,BoxPath+Ver.Filename);
      SetMemTop(HeapEnd);
       {$ENDIF}
      IF doserror=0 THEN BEGIN
        CASE DosExitCode OF
          1: Hold := TRUE;
          2: Kill := TRUE;
        END;
      END;
    END;

    IF KS[ch]^.FBBSFData^.SChmeissWech THEN KILL:=TRUE;
    {Wenn nicht als KILL oder Hold markiert, wird geguckt, ob die Mail
     fr den Server interessant ist.}
    IF NOT Kill AND NOT Hold THEN
        CheckForServer(Ver,Kill);



    IF NOT Kill THEN BEGIN

      {File in die S&F-Liste eintragen}
      WITH KS[ch]^.FBBSFData^.MailDat[KS[ch]^.FBBSFData^.Akt] DO
            AddSFListe(CutSSID(KS[ch]^.Call),Ver,Typ,LT_Angegeben,Hierach,Hold,FALSE);

      Ver.Rubrik := AnTransfer;

      IF LENGTH(Ver.Rubrik)=1 THEN BEGIN
        SysOp := TRUE;
        IF (Ver.Rubrik='M') OR (Ver.Rubrik='E') THEN SysOp := FALSE;
      END
      ELSE SysOp := FALSE;
      IF hold then
      BEGIN
        ver.flags:=ver.flags OR VERWALT_HOLD;
        ProfileBox('HOLD (S&F from'+cutssid(KS[ch]^.call)+'): $'+ver.bid+' '+
                    ver.rubrik+'@'+ver.mbx+' <'+ver.absender,PBOX_HOLD);
      END;
      idxpos:=FILEPOS(VerFile)+1;
      {Mail zum Check-File dazu}
      AddCheckFile(Ver,idxpos,Hold,SysOp,chkpos);
      AddBIDFile(BID,ver.rubrik,idxpos,chkpos);
      WRITE(VerFile,Ver);
      CLOSE(VerFile);
      AddOneSend(Gross(CutSSID(Ver.Absender)));
      IF Rufz(Ver.Rubrik) THEN BEGIN
        AddOneGet(Gross(CutSSID(Ver.Rubrik)));
        BenachrichtigeUser(Gross(CutSSID(Ver.Rubrik)),ch);
      END;


      OK := FALSE;
      FOR i := 1 TO AnzRub DO BEGIN
        IF DirInfo[i]^.Rubrik = Ver.Rubrik THEN BEGIN
          OK := TRUE;
          DirInfo[i]^.Mails := DirInfo[i]^.Mails + 1;
        END;
      END;
      IF NOT OK THEN BEGIN
        AnzRub := AnzRub + 1;
        new(DirInfo[AnzRub]);
        DirInfo[AnzRub]^.Rubrik := Ver.Rubrik;
        DirInfo[AnzRub]^.Mails := 1;
        DirInfo[AnzRub]^.Art := Ver.FileName[1];
        SortDirInfo;
      END;
    END
    ELSE BEGIN
      ASSIGN(f,BoxPath+Ver.FileName);
      {$I-}
      ERASE(f);
      {$I+}
      IF IOResult=0 THEN BEGIN END;
    END;

  END;
END;


{Eigenes Proposal (Mail-Angebot) verschicken}
PROCEDURE SendProposal(ch: BYTE);
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
    Anz: BYTE;
    S,Hlp: STRING;
    Zahl1,Zahl2: BYTE;
    Size,SizeAll: LONGINT;
    OK: BOOLEAN;SR:SearchRec;
BEGIN
  {$I-}
  ASSIGN(SFFile,BOXPATH+'sfliste');
  RESET(SFFile);
  IF IORESULT <> 0 THEN
  BEGIN
    ProfileBox('I/O Error accessing SFLISTE',PBOX_IOERROR);
    KS[ch]^.FLAGS:=KS[ch]^.FLAGS OR KS_DiscReq;
  END;
  {$I+}
  anz := 0;
  KS[ch]^.FBBSFData^.ChckSum := 0;
  KS[ch]^.FBBSFData^.Chck16 := 0;
  SizeAll := 0;
  REPEAT
    IF NOT EOF(SFFile) THEN BEGIN
      READ(SFFile,SF);

      WITH KS[ch]^.FBBSFData^ DO BEGIN
        OK := TRUE;
        IF SF.SF_Partner <> CutSSID(KS[ch]^.Call) THEN OK := FALSE;
        IF SF.Flags AND SFLISTE_DEL>0 THEN OK := FALSE;
        IF SF.Flags AND SFLISTE_HOLD>0 THEN OK := FALSE;
        IF (SF.Art = 'B') AND (ForwWhat = 'U') THEN OK := FALSE;
        IF ForwWhat = 'X' THEN OK := FALSE;
        IF (SF.Groesse > ForwSize) AND (ForwSize <> $FFFF) THEN OK := FALSE;
        FINDFIRST(boxpath+SF.Filename,anyfile,sr);
        IF (DOSERROR<>0) and (SF.An<>'M') AND (SF.An<>'E') THEN OK:=FALSE;      END;

      IF OK THEN BEGIN
        Inc(anz);
        Inc(KS[ch]^.FBBSFData^.AnzProposal);
        WITH KS[ch]^.FBBSFData^.MailDat[Anz] DO BEGIN
          Typ := SF.Art;
          Size := SF.Groesse;
          IF (UpCase(Typ)='E') OR (UpCase(Typ)='M') THEN BEGIN
            Typ := 'B';
            Size := 0;
          END;

          {Wenn ACK-Messages nicht untersttzt werden, werden sie
           als private Mail weiter geforwardet.}
          IF NOT KS[ch]^.FBBSFData^.Features.A AND (UpCase(Typ)='A') THEN Typ := 'P';

          IF KS[ch]^.FBBSFData^.Features.A AND (COPY(SF.Titel,1,4)='ACK:') THEN Typ := 'A';

          Sender := SF.Von;
          Verteiler := SF.Via;
          An := SF.An;
          BID := SF.BID;
          SizeAll := SizeAll + Size;
          Send := #0;
          LT := SF.LT;
          Del := FALSE;
          FileName := SF.FileName;
          Hierach := SF.Hierachie;
          Titel := SF.Titel;
          STR(Size,Hlp);
          IF NOT KS[ch]^.FBBSFData^.Features.D THEN BEGIN
            {Kein D in der SID (kein S&F nach DL8HBS) -> #13 in der CRC-Berechnung}
            S := 'FA '+Typ+' '+Sender+' '+COPY(Verteiler,1,6);
            IF KS[ch]^.FBBSFData^.Features.H THEN S := S + Hierach;
            S := S +' '+COPY(An,1,6)+' '+BID+' '+Hlp + #13;
            KS[ch]^.FBBSFData^.ChckSum := CheckSum(S,KS[ch]^.FBBSFData^.ChckSum);
          END
	  ELSE BEGIN
	   IF KS[CH]^.FBBSFData^.Features.B THEN 
              S := 'FD '+Typ+' '+Sender+' '+Verteiler
	   ELSE  S := 'FB '+Typ+' '+Sender+' '+Verteiler;
            IF KS[ch]^.FBBSFData^.Features.H THEN S := S + Hierach;
            S := S +' '+An+' '+BID+' '+Hlp;
            IF NOT Rufz(An) AND (SF.Flags AND SFLISTE_LTMIT>0) THEN BEGIN
              {Kein Rufzeichen und mitgegebene Lifetime (Beim RX dieses
               Files) -> LT mitgeben}
              STR(LT,Hlp);
              S := S + ' ' + Hlp;
            END;
            {D-S&F nach DL8HBS - Berechnung der CRC ohne CR}
            KS[ch]^.FBBSFData^.Chck16 := BuildStringCRC(S,KS[ch]^.FBBSFData^.Chck16);
            S := S + #13
          END;
          PutData(ch,S);
        END;
      END;
    END;
  UNTIL EOF(SFFile) OR (Anz >= 5) OR (SizeAll>10000);
  IF KS[ch]^.FBBSFData^.Features.D THEN BEGIN
    {Vorsicht - ist eine ATARI-CRC! Hi- und Lo-Byte sind vertauscht!}
    S := XHex(Lo(KS[ch]^.FBBSFData^.Chck16));
    IF LENGTH(S)=1 THEN S := '0' + S;
    PutData(ch,'F> '+S);
    S := XHex(Hi(KS[ch]^.FBBSFData^.Chck16));
    IF LENGTH(S)=1 THEN S := '0' + S;
    PutData(ch,S+#13);
  END
  ELSE PutData(ch,'F> '+ XHex((NOT KS[ch]^.FBBSFData^.ChckSum)+1)+#13);
  CLOSE(SFFile);
END;



{Alle angeforderten Mails abschicken (Ungepackt)}
PROCEDURE SendFBBMails(ch: BYTE; S: STRING);
VAR i: BYTE;
    STRG: STRING;
BEGIN
  IF POS(#13,S) > 0 THEN DELETE(S,POS(#13,S),1);
  S := COPY(S,POS(' ',S)+1,255);
  IF LENGTH(S) <> KS[ch]^.FBBSFData^.AnzProposal THEN BEGIN
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;

  FOR i := 1 TO LENGTH(S) DO BEGIN
    KS[ch]^.FBBSFData^.MailDat[i].Send := S[i];
    IF S[i] = '+' THEN BEGIN

      IF NOT (UpCase(KS[ch]^.FBBSFData^.MailDat[i].Typ)='M') AND NOT (UpCase(KS[ch]^.FBBSFData^.MailDat[i].Typ)='E')
       AND (KS[ch]^.FBBSFData^.MailDat[i].An<>'E') AND (KS[ch]^.FBBSFData^.MailDat[i].An<>'M') THEN BEGIN
        {Keine M- oder E-Mail - Body+SF-Header senden}


        ASSIGN(KS[ch]^.FBBSFData^.f,BoxPath+KS[ch]^.FBBSFData^.MailDat[i].FileName);
        {$I-}
        RESET(KS[ch]^.FBBSFData^.f);
        {$I+}
        IF IOResult <> 0 THEN BEGIN
          PutData(ch,'Failure opening Datafile while S&F'+#13#13#26);
        END
        ELSE BEGIN
          REPEAT
            READLN(KS[ch]^.FBBSFData^.f,STRG);
          UNTIL (STRG='NNNN') OR EOF(KS[ch]^.FBBSFData^.f);

          PutData(ch,KS[ch]^.FBBSFData^.MailDat[i].Titel+#13);
          WHILE NOT EOF(KS[ch]^.FBBSFData^.f) DO BEGIN
            READLN(KS[ch]^.FBBSFData^.f,STRG);
            PutData(ch,STRG+#13);
          END;
          PutData(ch,#26#13);
          CLOSE(KS[ch]^.FBBSFData^.f);
        END;
      END          {M/E-Mails}
      ELSE BEGIN   {M/E-Mails: Titel senden}
        PutData(ch,KS[ch]^.FBBSFData^.MailDat[i].Titel+#13);
        PutData(ch,#26#13);
      END;
    END;
  END;
  KS[ch]^.FBBSFData^.status := 0;
  KS[ch]^.FBBSFData^.ChckSum := 0;
  KS[ch]^.FBBSFData^.Chck16 := 0;
  KS[ch]^.FBBSFData^.Set2Null := FALSE;
END;


{ResumeCRC und Lnge als ersten Block senden}
PROCEDURE SendResumeCRCBlock(ch: BYTE;MessageNr: BYTE);
VAR Result: WORD;
    STRG: STRING[6];
    ResumeCRC: WORD;
    FileSize: LONGINT;
    f: File;
BEGIN
  WITH KS[ch]^.FBBSFData^ DO BEGIN

    {Resume-CRC des gepackten Files berechnen}
    IF Features.D THEN ResumeCRC := BuildBufferCRCF6FBB(MailDat[MessageNr].Titel[1],Byte(MailDat[MessageNr].Titel[0]),0)
                  ELSE ResumeCRC := 0;
    STR(ch,STRG);
    CalcFileCCITT_CRC(BoxPath+'temp'+PATH_SEP+'sftmp2.'+STRG,ResumeCRC);
  END;

  ASSIGN(f,BoxPath+'temp'+PATH_SEP+'sftmp2.'+STRG);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult=0 THEN BEGIN
    BLOCKREAD(f,FileSize,4,Result);
    IF Result<4 THEN FileSize := 0;
    CLOSE(f);
  END
  ELSE FileSize := 0;

  WITH KS[ch]^.FBBSFData^ DO BEGIN

    STRG[0] := #8;        {Lngen-Byte des Strings}
    STRG[1] := #2;        {Block-Identifier: Daten}
    STRG[2] := #6;        {Lngen-Byte des Datenblocks}
    MOVE(ResumeCRC,STRG[3],2);
    MOVE(FileSize,STRG[5],4);
    ChckSum := CheckSum(COPY(STRG,3,6),ChckSum);
    Chck16 := BuildBufferCRC(STRG[3],4,Chck16);
    PutData(ch,STRG);
  END;
END;



{Alle angeforderten Mails packen und abschicken}
PROCEDURE SendPackedFBBMails(ch: BYTE; S: STRING);
TYPE YappArray = ARRAY[1..250] OF CHAR; {Ich mach nur bis zu 250 bytes
                                         groe Stckchen}
VAR i,k: BYTE;
    STRG,Hlp: STRING;
    f: Text;
    fil: FILE;
    Result: WORD;
    Data: YappArray;
    ResumeCRC: WORD;
BEGIN
  IF POS(#13,S) > 0 THEN DELETE(S,POS(#13,S),1);
  S := COPY(S,POS(' ',S)+1,255);
  IF LENGTH(S) <> KS[ch]^.FBBSFData^.AnzProposal THEN BEGIN
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;

  FOR i := 1 TO LENGTH(S) DO BEGIN
    KS[ch]^.FBBSFData^.MailDat[i].Send := S[i];
    IF S[i] = '+' THEN BEGIN

      IF NOT (UpCase(KS[ch]^.FBBSFData^.MailDat[i].Typ)='M') AND NOT (UpCase(KS[ch]^.FBBSFData^.MailDat[i].Typ)='E') AND
          (KS[ch]^.FBBSFData^.MailDat[i].An<>'M') AND (KS[ch]^.FBBSFData^.MailDat[i].An<>'E') THEN BEGIN
        {Keine M- oder E-Mail - Body+SF-Header senden}

        ASSIGN(KS[ch]^.FBBSFData^.f,BoxPath+KS[ch]^.FBBSFData^.MailDat[i].FileName);
        {$I-}
        RESET(KS[ch]^.FBBSFData^.f);
        {$I+}
        IF IOResult <> 0 THEN BEGIN
          PutData(ch,'Failure opening Datafile while S&F'+#13#13#26);
        END
        ELSE BEGIN
          REPEAT
            READLN(KS[ch]^.FBBSFData^.f,STRG);
          UNTIL (STRG='NNNN') OR EOF(KS[ch]^.FBBSFData^.f);

          {Temporres File ffnen}
          STR(ch,STRG);
          ASSIGN(f,BoxPath+'temp'+PATH_SEP+'sftmp.'+STRG);
          REWRITE(f);

          WHILE NOT EOF(KS[ch]^.FBBSFData^.f) DO BEGIN
{            BLOCKREAD(KS[ch]^.FBBSFData^.f,YappArray,255,Result);}
            READLN(KS[ch]^.FBBSFData^.f,STRG);
            WRITELN(f,STRG);
          END;
          CLOSE(KS[ch]^.FBBSFData^.f);
          CLOSE(f);  {File schlieen}


          {File packen und als SFTMP2.ch abspeichern, wobei ch=aktueller kanal}
          STR(ch,STRG);
          IF KS[ch]^.FBBSFData^.Features.D THEN BEGIN
{$IFNDEF LINUX}
	     SetMemTop(HeapPtr);
            dos.Exec(BOXPATH+'DP_LZH.EXE',BoxPath+'TEMP\SFTMP.'+STRG+' '+BoxPath+'TEMP\SFTMP2.'+STRG+' P');
	     SetMemTop(HeapEnd);
	     {$ELSE} 
	     dos.exec(boxpath+'dp_lzh','e '+boxpath+'temp/sftmp.'+strg+' '+boxpath+'temp/sftmp2.'+strg);
	     
	     {$ENDIF}     
            (*
            IF doserror>0 THEN BEGIN
              do_exec(BOXPATH+'DP_LZH.EXE',BoxPath+'TEMP\SFTMP.'+STRG+' '+BoxPath+'TEMP\SFTMP2.'+STRG+' P',$07,0,FALSE);
            END;
            *)
          END
	  ELSE BEGIN
	     {$IFNDEF LINUX}
            SetMemTop(HeapPtr);
            dos.exec(BOXPATH+'FBB_LZH.EXE',BoxPath+'TEMP\SFTMP.'+STRG+' '+BoxPath+'TEMP\SFTMP2.'+STRG+' P');
            SetMemTop(HeapEnd);
	     {$ELSE} 
	     dos.exec(boxpath+'fbb_lzh','e '+boxpath+'temp/sftmp.'+strg+' '+boxpath+'temp/sftmp2.'+strg);
	     {$ENDIF}
            (*
            IF doserror>0 THEN BEGIN
              do_exec(BOXPATH+'FBB_LZH.EXE',BoxPath+'TEMP\SFTMP.'+STRG+' '+BoxPath+'TEMP\SFTMP2.'+STRG+' P',$07,0,FALSE);
            END;
            *)
          END;

          KS[ch]^.FBBSFData^.ChckSum := 0;    {Checksumme fr FBB-S&F auf 0}

          WITH KS[ch]^.FBBSFData^ DO BEGIN
            {Titel schicken}
            PutData(ch,#1+Chr(LENGTH(MailDat[i].Titel)+8)+MailDat[i].Titel);
            {DP-CRC setzen (beinhaltet auch den Titel, FBB-CRC nicht}
            KS[ch]^.FBBSFData^.Chck16 := BuildStringCRC(KS[ch]^.FBBSFData^.MailDat[i].Titel,0);
            IF Features.D THEN BEGIN
              {Beim B1-Mode: 16-Bit-CCITT-CRC (mit 0 vorgeladen) ber den Titel}
              ResumeCRC := BuildBufferCRCF6FBB(MailDat[i].Titel[1],Byte(MailDat[i].Titel[0]),0);
            END
            ELSE ResumeCRC := 0;        {Bei F6FBB geht die CCITT-CRC nicht
                                         ber den Titel}

            {Offset}
            STR(MailDat[i].StartOffset,Hlp);
            FOR k := 0 TO 5 DO IF LENGTH(Hlp)=k THEN Hlp := ' ' + Hlp;
            STRG := #0+Hlp+#0;
            {Und wieder CRC}
            Chck16 := BuildStringCRC(STRG,Chck16);
            PutData(ch,STRG);


            {Nur eigentliches File senden, wenns keine M- oder E-Mail ist!}
            IF (KS[ch]^.FBBSFData^.MailDat[i].An<>'M') AND (KS[ch]^.FBBSFData^.MailDat[i].An<>'E') THEN BEGIN

              {Bei B1 in der SID -> Resume-CRC senden}
              IF (Features.B) AND (Features.B_Lev=1) AND (MailDat[i].StartOffset>0) THEN SendResumeCRCBlock(ch,i);

              {CRC berechnen}
              STR(ch,STRG);
              CalcFileCCITT_CRC(BoxPath+'temp'+PATH_SEP+'SFTMP2.'+STRG,ResumeCRC);

              {Temporres File (gepacktes File) ffnen}
              ASSIGN(Fil,BoxPath+'temp'+PATH_SEP+'sftmp2.'+STRG);
              RESET(Fil,1);

              SEEK(Fil,MailDat[i].StartOffset);

              {Wenn B1 und der Startoffset 0 (ganzes File), steht die CRC
               direkt Anfang des Files im ersten Paket}
              IF (Features.B) AND (Features.B_Lev=1) AND (MailDat[i].StartOffset=0) THEN BEGIN
                {Ersten Block einlesen. nur 248 Zeichen, da die CRC mit 2
                 Zeichen noch davor kommt}
                BLOCKREAD(Fil,Data,248,Result);
                {Checksummen berechnen}
                Chck16 := BuildStringCRC(COPY(Data,1,Result),Chck16);
                ChckSum := CheckSum(COPY(Data,1,Result),ChckSum);
                {Block mit Blockkennzeichner ausgeben (CRC davor)}
                STRG := #2+Chr(Result+2)+Chr(Hi(ResumeCRC))+Chr(Lo(ResumeCRC))+COPY(Data,1,Result);
                PutData(ch,STRG);
              END;

              IF (Result=248) OR NOT ((Features.B) AND (Features.B_Lev=1)) THEN BEGIN
                REPEAT
                  {Nchsten Block einlesen}
                  BLOCKREAD(Fil,Data,250,Result);
                  {Checksummen berechnen}
                  Chck16 := BuildStringCRC(COPY(Data,1,Result),Chck16);
                  ChckSum := CheckSum(COPY(Data,1,Result),ChckSum);
                  {Block mit Blockkennzeichner ausgeben}
                  PutData(ch,#2+Chr(Result)+COPY(Data,1,Result));
                UNTIL Result < 250;
              END;
              CLOSE(Fil);

            END; {WITH KS[ch]^.FBBSFData^}
          END;   {M/E-Mails}
        END;     {File korrekt geffnet}
      END        {Extendet M/E-Mails}
      ELSE BEGIN {Extendet M/E-Mails: Titel senden}
        PutData(ch,#1+Chr(LENGTH(KS[ch]^.FBBSFData^.MailDat[i].Titel)+8)+KS[ch]^.FBBSFData^.MailDat[i].Titel);
        KS[ch]^.FBBSFData^.Chck16 := BuildStringCRC(KS[ch]^.FBBSFData^.MailDat[i].Titel,0);
        KS[ch]^.FBBSFData^.ChckSum := 0;

        {Offset}
        STRG := #0'     0'#0;
        KS[ch]^.FBBSFData^.Chck16 := BuildStringCRC(STRG,KS[ch]^.FBBSFData^.Chck16);
        PutData(ch,STRG);
      END;

      WITH KS[ch]^.FBBSFData^ DO BEGIN
        {Blockende-Kennzeichner mit CRC ausgeben}
        IF (Features.D) AND NOT ((Features.B) AND (Features.B_Lev>0)) THEN BEGIN
          PutData(ch,#4+Chr(Lo(Chck16))+Chr(Hi(Chck16)));
        END
        ELSE BEGIN
          PutData(ch,#4+Chr((NOT KS[ch]^.FBBSFData^.ChckSum)+1));
        END;
      END;

    END;
  END;
  KS[ch]^.FBBSFData^.status := 0;
  KS[ch]^.FBBSFData^.ChckSum := 0;
  KS[ch]^.FBBSFData^.Chck16 := 0;
  KS[ch]^.FBBSFData^.Set2Null := FALSE;
END;



{Lscht die Usermails an Call mit der angegebenen BID}
PROCEDURE DelUserMail(Call: str6; BID: Str12);
VAR F_Idx: FILE OF Verwalt_Rec;
    Idx: Verwalt_Rec;
    Found: BOOLEAN;
    k,Rub: WORD; bidh:TBidHashRec;
BEGIN
  ASSIGN(F_Idx,BoxPath+'index'+PATH_SEP+klein(Call+'.IDX'));
  {$I-}
  RESET(F_Idx);
  {$I+}
  IF IOResult=0 THEN BEGIN
     IF (BidHash^.GetData(BID,@bidh)) AND (bidh.idx_file_pos>0) THEN
     BEGIN
        dec(bidh.idx_file_pos);
        SEEK(F_Idx,bidh.idx_file_pos);
        READ(F_idx,idx);
        Idx.Flags := Idx.Flags OR VERWALT_DEL;
        SEEK(F_Idx,bidh.idx_file_pos);
        WRITE(F_Idx,Idx);
    END;
    CLOSE(F_Idx);
  END;


  Found := FALSE;
  FOR k := 1 TO AnzRub DO BEGIN
    IF Call = DirInfo[k]^.Rubrik THEN BEGIN
      Found := TRUE;
      Rub := k;
    END;
  END;
  IF Found THEN BEGIN   {Wenn die Rubrik vorhanden ist}
    IF DirInfo[Rub]^.Mails>0 THEN DirInfo[Rub]^.Mails := DirInfo[Rub]^.Mails - 1;
    IF DirInfo[Rub]^.Mails = 0 THEN BEGIN
      FOR k := Rub TO AnzRub-1 DO BEGIN
        DirInfo[k]^ := DirInfo[k+1]^;
      END;
      DISPOSE(DirInfo[AnzRub]);
      DirInfo[AnzRub] := NIL;
      AnzRub := AnzRub - 1;
    END;
  END;

END;



PROCEDURE DelSFFile_FBB(ch: BYTE; PLUS: BOOLEAN);
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
    i,k: WORD;
    OK: BOOLEAN;
BEGIN
  IF KS[ch]^.FBBSFData^.AnzProposal = 0 THEN Exit;

  ASSIGN(SFFile,BOXPATH+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult <> 0 THEN Exit;

  FOR i := 1 TO KS[ch]^.FBBSFData^.AnzProposal DO BEGIN
    IF (PLUS AND (KS[ch]^.FBBSFData^.MailDat[i].Send = '+')) OR (KS[ch]^.FBBSFData^.MailDat[i].Send = '-') THEN BEGIN

      IF Rufz(KS[ch]^.FBBSFData^.MailDat[i].An) THEN
              DelUserMail(KS[ch]^.FBBSFData^.MailDat[i].An,KS[ch]^.FBBSFData^.MailDat[i].BID);

      IF KS[ch]^.FBBSFData^.MailDat[i].Send = '+' THEN
              AddForwardMarker(CutSSID(KS[ch]^.Call),BoxPath+KS[ch]^.FBBSFData^.MailDat[i].FileName);

      k := 0;
      REPEAT
        SEEK(SFFile,k);
        IF NOT EOF(SFFile) THEN BEGIN
          READ(SFFile,SF);
          IF (SF.BID = KS[ch]^.FBBSFData^.MailDat[i].BID) AND (CutSSID(KS[ch]^.Call)=SF.SF_Partner) THEN BEGIN
            SEEK(SFFile,FILEPOS(SFFile)-1);
            SF.Flags := SF.Flags OR SFLISTE_DEL;
            WRITE(SFFile,SF);
          END;
        END;
        inc(k);
      UNTIL EOF(SFFile);
    END;
  END;

  CLOSE(SFFile);
END;



PROCEDURE Str2PutArray(S: STRING;VAR PutArray: T_PutCharArray);
VAR i: WORD;
BEGIN
  FOR i := 1 TO LENGTH(S) DO BEGIN
    PutArray[i] := S[i];
  END;
END;



PROCEDURE LookForSFHeader_AND_ACK(FileName: STRING;ch: BYTE;Titel: STRING;Absender: str6;BID:str12;
                                  Typ: CHAR; Verteiler: str8);
VAR S: STRING;
    F,f2: text;
    ACK,Auswert,kill: BOOLEAN;
    RXFrom,SFPart: STRING[6];
    Last: STRING;
    BBS: str6;
    DT: DateTime;
    lint: LONGINT;
    aword: WORD;
BEGIN
  IF Typ='A' THEN Exit;

  ASSIGN(f,FileName);
  {$I-}
  RESET(f);
  {$I-}
  IF IOResult <> 0 THEN Exit;

  Auswert := TRUE;
  ACK := FALSE;
  SFPart := '';
  RXFrom := CutSSID(BoxCall);

  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    IF Auswert THEN BEGIN
      CheckForAutorouter(ch,S,Auswert,SFPart,RXFrom,kill);
      IF kill THEN KS[ch]^.FBBSFData^.SChmeissWech:=TRUE;
      IF Auswert THEN Last := S;
    END;
    IF (S='/ACK') AND NOT ACK AND (Verteiler=CutSSID(BoxCall))THEN BEGIN
      {Ack-Mail senden}
      ACK := TRUE;

      BBS := GetMYBBS(Absender);
      IF BBS='' THEN BEGIN
        Last := COPY(Last,POS('@',Last)+1,255);
        IF Last[1]=':' THEN DELETE(Last,1,1);
        IF POS('.',Last)>0 THEN Last := COPY(Last,1,POS('.',S)-1);{Hierachie
            kann abgeschnitten werden, da die Mail ja per s&f gekommen ist
            und somit der pfad bekannt sein mu (autorouter)}
        IF POS(' ',Last)>0 THEN Last := COPY(Last,1,POS(' ',S)-1);
        BBS := Last;
      END;

      ASSIGN(f2,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
      REWRITE(f2);
      WRITELN(f2,'SP '+Absender+' @ '+BBS+' < ' + CutSSID(BoxCall));
      WRITELN(f2,'ACK:'+Titel);
      WRITELN(f2);
      WRITELN(f2,'Your message BID '+BID+' arrived this BBS at this time:');
      GetTime(DT.Hour,DT.Min,DT.Sec,aword);
      GetDate(DT.Year,DT.Month,DT.Day,aword);
      PackTime(DT,lint);

      WRITELN(f2,Pack2STRDate(lint)+'  '+Pack2STRTime(lint));
      WRITELN(f2);
      WRITELN(f2);
      CLOSE(f2);
    END;
  END;
  CLOSE(f);
END;



PROCEDURE PackedMailWrite(ch: BYTE);
VAR _Akt,Akt: BYTE;
    Hlp: STRING;
    S: STRING[80];
    f: Text;
    f2,f3: FILE;
    Tmp: ARRAY[1..250] OF CHAR;
    Result: WORD;
    CCITT_CRC, CCITT_CRC_Got: WORD;
    i: BYTE;
BEGIN
  Akt := KS[ch]^.FBBSFData^.Akt;
  {CRC ok -> File entpacken}
  S := KS[ch]^.FBBSFData^.MailDat[Akt].Titel;
  MakeFileHeader(Akt,ch,KS[ch]^.FBBSFData^.MailDat[Akt].Titel);
  CLOSE(KS[ch]^.FBBSFData^.f);
  IF KS[ch]^.FBBSFData^.MailDat[Akt].Size > 0 THEN BEGIN
    {Kein M/E-File}
    STR(ch,Hlp);


    {So - Hier ist die nderung von B zu B1 (CRC am Anfang der Mail)
     CRC aus dem File lsen und die ersten 2 Bytes des Files lschen.}
    WITH KS[ch]^.FBBSFData^ DO BEGIN
      IF Features.B AND (Features.B_Lev=1) THEN BEGIN
        ASSIGN(f2,BoxPath+'temp'+PATH_SEP+'sftmp.'+Hlp);
        {$I-}
        RESET(f2,1);
        {$I+}
        IF IOResult=0 THEN BEGIN
          BLOCKREAD(f2,CCITT_CRC_Got,2,Result);
          IF Result=2 THEN BEGIN
            {2 Bytes konnten gelesen werden -> die ersten beiden Bytes in der
             Mail lschen}
            _Akt := 2;
            REPEAT
              SEEK(f2,_Akt);
              BLOCKREAD(f2,Tmp,250,Result);
              SEEK(f2,_Akt-2);
              BLOCKWRITE(f2,Tmp,Result);
              _Akt := _Akt + Result;
            UNTIL Result<250;
            TRUNCATE(f2);
          END;
          CLOSE(f2);
        END;

        {So, die CRC wurde aus dem File 'raus gezogen. Jetzt die eigene
         CRC berechnen (Titel + File)}
        IF Features.D THEN CCITT_CRC := BuildBufferCRCF6FBB(S[1],Byte(S[0]),0)
                      ELSE CCITT_CRC := 0;
        STR(ch,Hlp);
        CalcFileCCITT_CRC(BoxPath+'temp'+PATH_SEP+'sftmp.'+Hlp,CCITT_CRC);


        IF CCITT_CRC <> CCITT_CRC_Got THEN BEGIN
          PutData(ch,'*** Checksum error'+#13);
          KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
          Exit;
        END;
      END;
    END;



    {File lschen}
    ASSIGN(f,BoxPath+'temp'+PATH_SEP+'sftmp2.'+Hlp);
    {$I-}
    ERASE(f);
    {$I+}
    IF IOResult = 0 THEN BEGIN END;

    IF KS[ch]^.FBBSFData^.Features.D THEN BEGIN
       {$IFNDEF LINUX}
      SetMemTop(HeapPtr);
      Dos.Exec(BOXPATH+'DP_LZH.EXE',BoxPath+'temp'+PATH_SEP+'SFTMP.'+Hlp+' '+BoxPath+'TEMP\SFTMP2.'+Hlp+' E');
      SetMemTop(HeapEnd);
	     {$ELSE} 
	     dos.exec(boxpath+'dp_lzh','d '+boxpath+'temp/sftmp.'+hlp+' '+boxpath+'temp/sftmp2.'+hlp);
       
{$ENDIF}
       (*
      IF doserror<>0 THEN
        do_exec(BOXPATH+'DP_LZH.EXE',BoxPath+'TEMP\SFTMP.'+Hlp+' '+BoxPath+'TEMP\SFTMP2.'+Hlp+' E',$07,$FFFF,FALSE);
      *)
    END
    ELSE BEGIN
       {$IFNDEF LINUX}
      SetMemTop(HeapPtr);
      Dos.Exec(BOXPATH+'FBB_LZH.EXE',BoxPath+'TEMP\SFTMP.'+Hlp+' '+BoxPath+'TEMP\SFTMP2.'+Hlp+' E');
      SetMemTop(HeapEnd);
       	     {$ELSE} 
	     dos.exec(boxpath+'fbb_lzh','d '+boxpath+'temp/sftmp.'+hlp+' '+boxpath+'temp/sftmp2.'+hlp);

       {$ENDIF}
      (*
      IF doserror<>0 THEN
        do_exec(BOXPATH+'FBB_LZH.EXE',BoxPath+'TEMP\SFTMP.'+Hlp+' '+BoxPath+'TEMP\SFTMP2.'+Hlp+' E',$07,$FFFF,FALSE);
      *)
    END;

    {S&F-Header durchwhlen}
    WITH KS[ch]^.FBBSFData^.MailDat[Akt] DO
       LookForSFHeader_AND_ACK(BoxPath+'temp'+PATH_SEP+'sftmp2.'+Hlp,ch,Titel,Sender,BID,Typ,Verteiler);


    {Header und Mailbody zusammenfgen (Deshalb mit BLOCKREAD/WRITE,
     weil auch bin-mails vorkommen knnen, die mit READLN/WRITELN
     zerhackt wrden}
    STR(ch,Hlp);
    ASSIGN(f2,BoxPath+'temp'+PATH_SEP+'sftmp2.'+Hlp);
    RESET(f2,1);
    ASSIGN(f3,BoxPath+KS[ch]^.FBBSFData^.MailDat[Akt].FileName);
    RESET(f3,1);

    {Ans Ende der Mail springen}
    (*
    REPEAT
      BLOCKREAD(f3,Tmp,250,Result);
    UNTIL Result<250;
    *)
    SEEK(F3,FileSize(f3));
    REPEAT
      BLOCKREAD(f2,Tmp,250,Result);
      BLOCKWRITE(f3,Tmp,Result);
    UNTIL Result<250;
    CLOSE(f2);
    CLOSE(f3);

  END;
  {Variablen frs nchste File auf 0 setzen}
  KS[ch]^.FBBSFData^.Temp := '';
  KS[ch]^.FBBSFData^.Chck16 := 0;
  KS[ch]^.FBBSFData^.ChckSum := 0;


  SaveVerwaltEintrag(ch);  {Eintrag der Mail ins IDX-File}
  IF KS[ch]^.FBBSFData^.TPKMode THEN
  BEGIN
    NaechstTPKMail(ch);
    exit;
  END;  
  KS[ch]^.FBBSFData^.Akt := NaechstEmpfMail(ch);
  Akt := KS[ch]^.FBBSFData^.Akt;
  IF KS[ch]^.FBBSFData^.Akt > KS[ch]^.FBBSFData^.AnzProposal THEN BEGIN
    {Alle Mails wurden empfangen - "reverse" forward}
    KS[ch]^.FBBSFData^.ChckSum := 0;
    KS[ch]^.FBBSFData^.Chck16 := 0;
    KS[ch]^.FBBSFData^.status := 10;
    KS[ch]^.FBBSFData^.Akt := 0;
    KS[ch]^.FBBSFData^.AnzProposal := 0;
    KS[ch]^.FBBSFData^.Schmeisswech:= FALSE;
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_LINEMODE;
    FBB_SF(ch,'');
    Exit;
  END;
END;



PROCEDURE SavePackedFile(ch: BYTE; S: STRING);
VAR len,i,k,Rest: WORD;
    Akt: BYTE;
    Hlp: STRING;
    OurCRC,TheirCRC: WORD;
    PutArray: T_PutCharArray;
    f: Text;
    OK: BOOLEAN;
BEGIN
  Akt := KS[ch]^.FBBSFData^.Akt;

  WITH KS[ch]^.FBBSFData^ DO BEGIN

    WHILE (LENGTH(S)>0) AND ((KS[ch]^.FLAGS AND KS_DISCREQ)=0) DO BEGIN

      OK := FALSE;
      IF COPY(Temp,1,1)=#4 THEN BEGIN
        IF Features.D AND (LENGTH(Temp)<3) AND NOT (Features.B AND (Features.B_Lev=1)) THEN OK := TRUE;
        IF Features.D AND (LENGTH(Temp)<2) AND (Features.B AND (Features.B_Lev=1)) THEN OK := TRUE;
        IF NOT Features.D AND (LENGTH(Temp)<2) THEN OK := TRUE;
      END
      ELSE BEGIN
        IF (LENGTH(Temp)<2) OR (LENGTH(Temp)<Ord(Temp[2])+2) THEN OK := TRUE;
      END;

      IF OK THEN BEGIN
        IF COPY(Temp,1,1)=#4 THEN BEGIN
          IF Features.D AND NOT (Features.B AND (Features.B_Lev=1)) THEN Rest := 3-LENGTH(Temp)
                                                                    ELSE Rest := 2-LENGTH(Temp);
        END
        ELSE BEGIN
          IF LENGTH(Temp)>1 THEN Rest := Ord(Temp[2])-LENGTH(Temp)+2
                            ELSE Rest := 2;
        END;
        Temp := Temp + COPY(S,1,Rest);
        S := COPY(S,Rest+1,255);
      END;


      OK := FALSE;
      IF COPY(Temp,1,1)=#4 THEN BEGIN
        IF Features.D AND (LENGTH(Temp)=3) AND NOT (Features.B AND (Features.B_Lev=1)) THEN OK := TRUE;
        IF Features.D AND (LENGTH(Temp)=2) AND (Features.B AND (Features.B_Lev=1)) THEN OK := TRUE;
        IF NOT Features.D AND (LENGTH(Temp)=2) THEN OK := TRUE;
      END
      ELSE BEGIN
        IF LENGTH(Temp)=Ord(Temp[2])+2 THEN OK := TRUE;
      END;

      IF OK THEN BEGIN
        CASE Temp[1] OF
          #1: BEGIN     {Titel empfangen}
                MailDat[Akt].Titel := '';
                ChckSum := 0;

                Temp := COPY(Temp,3,255);
                Chck16 := BuildStringCRC(Temp,0);       {Checksumme}

                MailDat[Akt].Titel := COPY(Temp,1,POS(#0,Temp)-1);
                IF COPY(MailDat[Akt].Titel,1,4)='ACK:' THEN MailDat[Akt].Typ := 'A';

                {Temporres File ffnen}
                STR(ch,Hlp);
                ASSIGN(KS[ch]^.FBBSFData^.Binary,BoxPath+'temp'+PATH_SEP+'sftmp.'+Hlp);
                REWRITE(KS[ch]^.FBBSFData^.Binary,1);
                Temp := '';
              END;

          #2: BEGIN     {Normale Datenblcke}
                Temp := COPY(Temp,3,255);
                Chck16 := BuildStringCRC(Temp,Chck16);
                ChckSum := CheckSum(Temp,ChckSum);

                Str2PutArray(Temp,PutArray);
                BLOCKWRITE(Binary,PutArray,LENGTH(Temp));
                Temp := '';
              END;

          #4: BEGIN     {CRC}
                WITH KS[ch]^.FBBSFData^ DO BEGIN
                  CLOSE(Binary);
                  IF Features.D AND NOT (Features.B AND (Features.B_Lev=1)) THEN BEGIN
                    {DP-CRC - 'D' inner SID}
                    OurCRC := Chck16;

                    TheirCRC := (Ord(Temp[3])*256) + Ord(Temp[2]);
                  END
                  ELSE BEGIN
                    {FBB-CRC - kein 'D' in der SID}
                    OurCRC := (NOT ChckSum)+1;
                    TheirCRC := Ord(Temp[2]);
                  END;
                END;

                IF OurCRC <> TheirCRC THEN BEGIN
                  {CRC-Fehler}
                  KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
                  PutData(ch,'*** Checksum error'+#13);
                  Exit;
                END
                ELSE PackedMailWrite(ch);
              END;
          ELSE BEGIN
            {Kein bekannter Block-Identifier (#1, #2, #4) empfangen ->
             fehlermeldung und disconnect}
            PutData(ch,'*** Invalid block identifier'+#13);
            KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
            Exit;
          END;
        END;
      END;

    END;

  END;
END;



PROCEDURE FS_Auswertung(S: STRING; ch: BYTE);
VAR AktPropo,i: BYTE;
    Tmp: STRING;
    code: WORD;
BEGIN
  {Ich soll Mails schicken.}
  WITH KS[ch]^.FBBSFData^ DO BEGIN
    i := 1;             {Aktuelle Spalte in der FS-Zeile}
    AktPropo  := 1;     {Aktuelles "Feld" in der FS-Zeile}
    WHILE AktPropo <= AnzProposal DO BEGIN
      MailDat[AktPropo].Send := S[3+i];

      {B1 in der SID -> H und R knnen auch in  der Vorschlagszeile
       stehen}
      IF MailDat[AktPropo].Send='H' THEN MailDat[AktPropo].Send := '+';
      IF MailDat[AktPropo].Send='R' THEN MailDat[AktPropo].Send := '-';
      MailDat[AktPropo].StartOffset := 0;

      {Resume - Anstatt '+' oder '-' steht '!<Offset>' in der
       Vorschlag-Zeile}
      IF MailDat[i].Send='!' THEN BEGIN
        MailDat[AktPropo].Send := '+';
        inc(i);
        Tmp[0] := #0;           {Lngen-Byte von Tmp (hier wird der
                                 angeforderte Offset 'reingeschrieben}
        WHILE (S[i]='+') OR (S[i]='-') OR (S[i]='H') OR (S[i]='R') OR (i>LENGTH(S)) DO BEGIN
          inc(byte(Tmp[0]));
          Tmp[Byte(Tmp[0])] := S[i];
          inc(i);
        END;
        VAL(Tmp,MailDat[AktPropo].StartOffset,code);
        IF code>0 THEN MailDat[AktPropo].StartOffset := 0;
      END
      ELSE inc(i);

      inc(AktPropo);
    END;
  END;
END;


{Status-Auswertung beim S&F nach F6FBB}
PROCEDURE FBB_SF(ch: BYTE; S: STRING);
VAR kill:BOOLEAN;
BEGIN
  IF (KS[ch]^.FLAGS AND KS_DISCREQ)=0 THEN
  CASE KS[ch]^.FBBSFData^.status OF
    0: BEGIN
         IF S[1]<>'F' THEN
         BEGIN
           PutData(ch,'*** protocol error '+#13);
           KS[ch]^.Flags:=KS[ch]^.Flags OR KS_DISCREQ;
           EXIT;
         END;
         IF COPY(S,1,1) = 'F' THEN DelSFFile_FBB(ch,TRUE);
         IF COPY(S,1,2) = 'FF' THEN BEGIN
           {Partner hat keine Files mehr vorliegen}
           IF SendFileDa(CutSSID(KS[ch]^.Call),KS[ch]^.FBBSFData^.ForwWhat,KS[ch]^.FBBSFData^.ForwSize) THEN BEGIN
             {Eigene Files senden}
             KS[ch]^.FBBSFData^.status := 10;
             KS[ch]^.FBBSFData^.ChckSum := 0;
             KS[ch]^.FBBSFData^.Chck16 := 0;
             KS[ch]^.FBBSFData^.AnzProposal := 0;
             KS[ch]^.FBBSFData^.Schmeisswech:= FALSE;
             FBB_SF(ch,S);
             Exit;
           END
           ELSE BEGIN
             {Selbst disconnecten}
             PutData(ch,'FQ'+#13);
             Exit;
           END;
         END
         ELSE BEGIN
           IF COPY(S,1,2)='FQ' THEN BEGIN
             {Disconnect-Request}
             KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
             Exit;
           END;

           IF COPY(S,1,2)='F>' THEN BEGIN
             {Ende des Proposals}
             IF POS(' ',S) > 0 THEN IF NOT TestCRC(ch,S) THEN Exit;
             PutData(ch,GenerateFS_Line(ch,S)+#13);
             KS[ch]^.FBBSFData^.status := 1;   {Titel speichern und File ffnen}
             KS[ch]^.FBBSFData^.Akt := 0;      {Aktuell empfangene Mail}
             KS[ch]^.FBBSFData^.Akt := NaechstEmpfMail(ch);
             KS[ch]^.FBBSFData^.DelOK := TRUE; {Delay von 1s beim nchsten Paket}
             KS[ch]^.FBBSFData^.Schmeisswech:= FALSE;
             IF KS[ch]^.FBBSFData^.Akt > KS[ch]^.FBBSFData^.AnzProposal THEN BEGIN
               {Alle Files abgelehnt -> Eigene schicken}
               KS[ch]^.FBBSFData^.status := 10;
               KS[ch]^.FBBSFData^.AnzProposal := 0;
               FBB_SF(ch,'');
               Exit;
             END;
             IF KS[ch]^.FBBSFData^.Features.B THEN BEGIN
               {Einstellungen fr gepacktes S&F}
               KS[ch]^.FBBSFData^.Temp := '';
               KS[ch]^.FLAGS := KS[ch]^.FLAGS AND NOT KS_LINEMODE; {Handle nicht nur nach CR aufrufen}
               KS[ch]^.FBBSFData^.Temp := '';
               KS[ch]^.FBBSFData^.status := 2;
             END
             ELSE BEGIN
               KS[ch]^.FBBSFData^.status := 1;
               KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_LINEMODE;{Handle nur nach CR aufrufen}
             END;
           END
           ELSE Get_Proposal(ch, S); {Proposal-Zeile "entschlsseln"}
         END;
       END;
    1: BEGIN
         {in S steht der Titel der Mail (ungepackt) drin.
          In den File-Header schreiben)}
         MakeFileHeader(KS[ch]^.FBBSFData^.Akt,ch,S);
         KS[ch]^.FBBSFData^.status := 2;
         KS[ch]^.FBBSFData^.AuswertHeader := TRUE;
       END;
    2: BEGIN
         IF NOT KS[ch]^.FBBSFData^.Features.B THEN BEGIN
           {Normaler S&F RX}
           WHILE POS(#13,S) > 0 DO DELETE(S,POS(#13,S),1);
           IF (S[1] = #26) THEN BEGIN
             {File-Ende}
             CLOSE(KS[ch]^.FBBSFData^.f);
             SaveVerwaltEintrag(ch); {File in .IDX-File 'rein}
             KS[ch]^.FBBSFData^.Akt := NaechstEmpfMail(ch);
             IF KS[ch]^.FBBSFData^.Akt > KS[ch]^.FBBSFData^.AnzProposal THEN BEGIN
               {Alle Mails wurden empfangen - "reverse" forward}
               KS[ch]^.FBBSFData^.status := 10;
               KS[ch]^.FBBSFData^.AnzProposal := 0;
               KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_LINEMODE;
               FBB_SF(ch,'');
               Exit;
             END;
             {Es kommt noch eine Mail}
             KS[ch]^.FBBSFData^.status := 1;
           END
           ELSE BEGIN
             WITH KS[ch]^.FBBSFData^ DO BEGIN
               {SF-Header (R: - Zeile) auswerten}
               IF KS[ch]^.FBBSFData^.AuswertHeader THEN CheckForAutorouter(ch,S,AuswertHeader,SFPartner,RXFrom,kill);
               IF KILL THEN KS[ch]^.FBBSFData^.Schmeisswech:= TRUE;
             END;
             {Zeile ins File}
             WRITELN(KS[ch]^.FBBSFData^.f,S);
           END;
         END
         ELSE BEGIN
           {Gepackter S&F RX}
           SavePackedFile(ch,S);
         END;
       END;
   10: BEGIN {Reverse}
         KS[ch]^.FBBSFData^.AnzProposal := 0;
         IF SendFileDa(CutSSID(KS[ch]^.Call),KS[ch]^.FBBSFData^.ForwWhat,KS[ch]^.FBBSFData^.ForwSize) THEN BEGIN
           {Eigenen Proposal schicken, weil Mails zum Senden vorhanden sind}
           SendProposal(ch);
           KS[ch]^.FBBSFData^.status := 11;
         END
         ELSE BEGIN
           {Keine Mails vorhanden - Reverse}
           PutData(ch,'FF'+#13);
           KS[ch]^.FBBSFData^.status := 0;
           KS[ch]^.FBBSFData^.ChckSum := 0;
           KS[ch]^.FBBSFData^.Chck16 := 0;
           KS[ch]^.FBBSFData^.Schmeisswech:= FALSE;
         END;
       END;
   11: BEGIN
         {Auswerten der FS-Zeile}
         IF copy(S,1,2)<>'FS' THEN
         BEGIN
           PutData(ch,'*** protocol error '+#13);
           KS[ch]^.Flags:=KS[ch]^.Flags OR KS_DISCREQ;
           EXIT;
         END;
         FS_Auswertung(S,ch);
         DelSFFile_FBB(ch,FALSE); {FALSE bedeutet, das Mails, die mit '+'
                                   beantwortet wurden, noch nicht gelscht
                                   werden ('H' und '!' (Offset) wird intern
                                   auf '+' gesetzt.}

         {Files schicken - Gepackt oder Ungepackt}
         IF KS[ch]^.FBBSFData^.Features.B THEN SendPackedFBBMails(ch,S)
                                          ELSE SendFBBMails(ch,S);
       END;
       {FS-Zeile auswerten und angeforderte Mails senden}
   20: IF POS('>',S) > abs((length(s)-2)) THEN BEGIN
         {SF-Connect erhalten}
         KS[ch]^.FBBSFData^.status := 10;
         {SID schicken (evtl. Passwort)}
         PutData(ch,SID);
         IF LENGTH(KS[ch]^.FBBSFData^.PwdAnswer)>0 THEN PutData(ch,' '+KS[ch]^.FBBSFData^.PwdAnswer+#13)
                                                   ELSE PutData(ch,#13);
         FBB_SF(ch,'');            {Gucken, ob Mails vorhanden sind}
       END;
  END;
END;


END.{S&F-Routinen fr FBB-Forward}
