(***************************************************************************)
(**                            UNIT BOXSTART.PAS                          **)
(***************************************************************************)
(**  Prozeduren, die nur beim Start und evtl. beim Beenen von MCUT        **)
(**  benutzt werden. Kann deshalb als Overlay deklariert werden.          **)
(**  BoxMain _NICHT_ als Overlay deklarieren!                             **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXSTART;



INTERFACE

{Initialisierung der Mailbox. Nur einmal beim Start oder nach Box_Done
 aufrufen!}
PROCEDURE InitBox;

{Beendet die Mailbox (wirft alle User 'raus, macht den Speicher wieder
 frei etc}
PROCEDURE Box_Done;

PROCEDURE READDirData(ch:BYTE;MELDUNG:BOOLEAN);
PROCEDURE ReadBOXSF(ch:BYTE;meldung:BOOLEAN);
PROCEDURE READServerBOX(ch:BYTE;MELDUNG:BOOLEAN);
PROCEDURE READRejectBOX(ch:BYTE;MELDUNG:BOOLEAN);
PROCEDURE READOnlineHelp(ch: BYTE;MELDUNG: BOOLEAN);
PROCEDURE FreeBOXSF;
PROCEDURE FreeServerBOX;
PROCEDURE FreeRejectBOX;
PROCEDURE FreeDirInfo;


IMPLEMENTATION

USES DOS,BOXVARS,IADVAR,TOOLBOX,BOXUTIL,BOXCMD,CRT,
     BOXHUSER,
     BOXSERV,
     FILEHASH;


{Bei M_FILTER-Programmen ist es, wenn eine .EXE-Datei verwendet wird,
 mglich, eine kurze Nachricht mitzugeben, die beim Start von MCUT
 mitgesendet wird. Sie steht hinter den eigentlichen Daten des Files
 (einfach ans Ende des EXE-Files springen (Lnge steht im EXE-Header)
 und schreiben. Es werden bis zu 60 Zeichen ausgegeben.}
FUNCTION M_FILTER_CopyrightMessage(Filename: STRING): STRING;
VAR f: File;
    tmp: ARRAY[1..60] OF CHAR;
    Len,i: BYTE;
    S: STRING;
    SeekAddr: LONGINT;
    Result: WORD;

{Holt die Gre des Files aus dem Header des EXE-Files}
FUNCTION FileLenFromHeader(FileName: STRING): LONGINT;
VAR g: ARRAY[1..4] OF BYTE;
    HeaderID: ARRAY[1..2] OF BYTE;
    f: FILE;
    Result: WORD;
BEGIN
  ASSIGN(f,FileName);
  RESET(f,1);
  BLOCKREAD(f,HeaderID,2,Result);
  IF (Result<2) OR (Chr(HeaderID[1])<>'M') OR (Chr(HeaderID[2])<>'Z') THEN BEGIN
    FileLenFromHeader := 0;
  END
  ELSE BEGIN
    BLOCKREAD(f,g,4,Result);
    IF Result<4 THEN FileLenFromHeader := 0
    ELSE BEGIN
      IF (g[1]=0) AND (g[2]=0) THEN BEGIN
        FileLenFromHeader := LONGINT(g[4]) * 256 + LONGINT(g[3]);
      END
      ELSE BEGIN
        FileLenFromHeader :=
          ((LONGINT(g[4]) * 256 +
            LONGINT(g[3])) - 1) * 512 +
           (LONGINT(g[2]) * 256 +
            LONGINT(g[1]));
      END;
    END;
  END;

  CLOSE(f);
END;

BEGIN
  {Variablen initialisieren}
  S := '';
  Len := 0;
  SeekAddr := FileLenFromHeader(Filename);

  ASSIGN(f,Filename);
  RESET(f,1);

  {Lnge des Infotextes einlesen}
  SEEK(f,SeekAddr);
  REPEAT
    BLOCKREAD(f,tmp,60,Result);
    Len := Len + Result;
  UNTIL Result<60;
  IF Len>60 THEN Len := 60;

  {Eigentlichen Infotext nach tmp}
  SEEK(f,SeekAddr);
  BLOCKREAD(f,tmp,Len);

  {Und weiter nach S}
  S[0] := Chr(Len);
  FOR i := 1 TO Len DO S[i] := Tmp[i];

  CLOSE(f);
  M_FILTER_CopyrightMessage := S;
END;


PROCEDURE FreeBoxSF;
VAR box_tmp,box_tmp2:pBoxSF;
BEGIN
  box_tmp:=BoxSFRoot;
  WHILE box_tmp<>NIL DO
  BEGIN
    box_tmp2:=box_tmp;
    box_tmp:=box_tmp^.next;
    dispose(box_tmp2);
  END;
  BoxSFRoot:=NIL;
END;


PROCEDURE FreeServerBOX;
VAR tmp,tmp2:pServerListe;
BEGIN
  tmp:=ServListRoot;
  WHILE tmp<>NIL DO
  BEGIN
    tmp2:=tmp;
    tmp:=tmp^.next;
    dispose(tmp2);
  END;
  ServListRoot:=NIL;
END;

PROCEDURE FreeRejectBOX;
VAR tmp,tmp2:pReject_Box;
BEGIN
  tmp:=Reject_Box_Root;
  WHILE tmp<>NIL DO
  BEGIN
    tmp2:=tmp;
    tmp:=tmp^.next;
    dispose(tmp2);
  END;
  Reject_Box_Root:=NIL;
END;

PROCEDURE FreeDirInfo;
VAR w:WORD;
BEGIN
  FOR w:=1 TO AnzRub DO
    dispose(DirInfo[w]);
  Anzrub:=0;
END;



PROCEDURE ReadBOXSF(ch:BYTE;meldung:BOOLEAN);
VAR F:text;
    box_tmp,Box_tmp2: pBoxSF;
    dummy:BYTE;
    s,s1:string;
    code:integer;
    bool:BOOLEAN;
BEGIN

   ASSIGN(f,BoxPath+'box.sf');
  {$I-}
  RESET(f);
  {$I+}
  new(box_tmp);
  IF IOResult<>0 THEN
  BEGIN
    IF MELDUNG THEN
      WRITELN('No BOX.SF found -> no outgoing S&F')
    ELSE
      PutData(ch,'No BOX.SF found -> no outgoing S&F'+#13);
  END
  ELSE BEGIN
    dummy := 0;
    S := '';
    {Bis zu Basic_Definitions gehen springen}
    WHILE NOT EOF(f) AND (S<>':BASIC_DEFINITIONS') DO BEGIN
      READLN(f,S);
      S := Gross(S);
    END;
    WHILE NOT EOF(f) AND (S<>':WHAT_TO_FORWARD') DO BEGIN
      READLN(f,S);
      S := LTRIM(RTRIM(Gross(S)));
      IF (LENGTH(S)>0) AND (S[1]<>'#') AND (S[1]<>':') THEN BEGIN
        box_tmp^.Call := COPY(S,1,6);
        box_tmp^.Times := COPY(S,8,24);
        VAL(COPY(S,33,1),box_tmp^.SID,code);
        box_tmp^.Pfad := COPY(S,37,255);
        IF code<>0 THEN
        BEGIN
          IF MELDUNG THEN
             WRITELN('Fehler beim Eintrag von '+box_tmp^.Call+'!')
          ELSE
             PutData(ch,'Fehler beim Eintrag von '+box_tmp^.Call+'!'+#13);
        END
        ELSE BEGIN
          box_tmp2 := BoxSFRoot;
          IF box_tmp2 = NIL THEN BEGIN
            new(BoxSFRoot);
            box_tmp2 := BoxSFRoot;
          END
          ELSE BEGIN
            box_tmp2 := BoxSFRoot;
            WHILE box_tmp2^.next <> NIL DO box_tmp2 := box_tmp2^.next;
            New(box_tmp2^.Next);
            box_tmp2 := box_tmp2^.Next;
          END;

          box_tmp2^.Next := NIL;
          box_tmp2^.Call := RTRIM(box_tmp^.Call);
          box_tmp2^.Times := box_tmp^.Times;
          Box_tmp2^.SID := box_tmp^.SID;
          box_tmp2^.Pfad := Box_tmp^.Pfad;
        END;
      END;
    END;
    dispose(box_tmp);
    box_tmp := NIL;
    WHILE NOT EOF(f) DO BEGIN
      READLN(f,S);
      IF (LENGTH(S)>0) AND (S[1]<>'#') THEN BEGIN
        IF S[1]=' ' THEN BEGIN  {Gehrt noch zum Eintrag des letzten Calls}
          IF box_tmp<>NIL THEN BEGIN
            S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));
            box_tmp^.Pfad := box_tmp^.Pfad + ' ' + S;
          END;
        END
        ELSE BEGIN              {ein Neues Rufzeichen}
          S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));
          S1 := COPY(S,1,POS(' ',S)-1);
          S := COPY(S,POS(' ',S)+1,255);
          box_tmp := BoxSFRoot;
          bool := FALSE;
          WHILE (box_tmp<>NIL) AND NOT bool DO BEGIN
            IF Box_tmp^.Call=S1 THEN bool := TRUE
                                ELSE Box_tmp := Box_tmp^.next;
          END;
          IF bool THEN BEGIN
            Box_tmp^.WhatToForward := S;
            inc(dummy);
            IF dummy=1 THEN
            BEGIN
              IF MELDUNG THEN
                 WRITE('Found: '+Box_tmp^.Call)
              ELSE
                 PutData(ch,'Found: '+Box_tmp^.Call);
            END ELSE
            BEGIN
              IF MELDUNG  THEN
                 WRITE(','+Box_tmp^.Call)
              ELSE
                 PutData(ch,','+Box_tmp^.Call);
            END;
          END;
        END;
      END;
    END;
    IF dummy=0 THEN
    BEGIN
      IF MELDUNG THEN
        WRITELN('No correct entry found')
      ELSE
        PutData(ch,'No correct entry found'+#13);
    END ELSE
    BEGIN
      IF MELDUNG THEN
        WRITELN ELSE
        PutData(ch,''+#13);
    END;
    CLOSE(f);
  END;
END;

PROCEDURE READServerBOX(ch:BYTE;MELDUNG:BOOLEAN);

  PROCEDURE WRITLN(s:string80);
  BEGIN
    IF MELDUNG THEN WriteLN(s) ELSE
    PutData(ch,s+#13);
  END;
  PROCEDURE WRIT(s:string80);
  BEGIN
    IF MELDUNG THEN Write(s) ELSE
    PutData(ch,s);
  END;

VAR
  f:text;
  Serv_tmp: pServerListe;
  dummy: WORD;
  s,s1:string;
  bool:boolean;
BEGIN
{**************************************************************************}
{************************* Mail- Server ***********************************}
{**************************************************************************}
   WRITLN('Reading server.box...');
   ASSIGN(f,BoxPath+'server.box');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult=0 THEN BEGIN

    dummy := 0;                      {Zeilen-Zhler}
    WHILE NOT EOF(f) DO BEGIN
      READLN(f,S);
      inc(dummy);
      S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));
      IF (LENGTH(S)>0) AND (S[1]<>'#') THEN BEGIN
        IF POS(' ',S)=0 THEN BEGIN
          STR(dummy,S);
          WRITLN('Error in line '+S+'!');
        END
        ELSE BEGIN
          S1 := COPY(S,1,POS(' ',S)-1);   {Dateiname}
          S := COPY(S,POS(' ',S)+1,255);  {Rubrik}

          bool := FALSE;                  {True, wenn das File da ist und
                                           in die Liste eingetragen werden
                                           kann}
          IF NOT FileDa(S1) THEN BEGIN
            S1 := BoxPath+'server'+PATH_SEP+S1;
            IF NOT FileDa(S1) THEN BEGIN
              WHILE POS(PATH_SEP,S1)>0 DO S1 := COPY(S1,POS(PATH_SEP,S1)+1,255);
              WRITLN('Error! File '+S1+' does not exist!');
            END
            ELSE bool := TRUE;
          END
          ELSE bool := TRUE;              {File wurde mit Parameter angegeben}

          {File existiert -> in die Liste eintragen}
          IF bool THEN BEGIN
            Serv_tmp := ServListRoot;
            IF Serv_tmp = NIL THEN BEGIN
              new(ServListRoot);
              Serv_tmp := ServListRoot;
            END
            ELSE BEGIN
              Serv_tmp := ServListRoot;
              WHILE Serv_tmp^.next <> NIL DO Serv_tmp := Serv_tmp^.next;
              New(Serv_tmp^.Next);
              Serv_tmp := Serv_tmp^.Next;
            END;

            Serv_tmp^.Next := NIL;
            Serv_tmp^.Filename := S1;
            Serv_tmp^.Rubrik := S;
            WRITLN('Found: '+S1+' ('+S+')');
          END;
        END;
      END;
    END;
    CLOSE(f);
  END
  ELSE WRITLN('No Server found');
END;

PROCEDURE READRejectBOX(ch:BYTE;MELDUNG:BOOLEAN);
  PROCEDURE WRITLN(s:string80);
  BEGIN
    IF MELDUNG THEN WriteLN(s) ELSE
    PutData(ch,s+#13);
  END;
  PROCEDURE WRIT(s:string80);
  BEGIN
    IF MELDUNG THEN Write(s) ELSE
    PutData(ch,s);
  END;
VAR
  tmp,tmp2: pReject_Box;
  f:text;
  dummy: WORD;
  s,s1:string;
  bool:boolean;

BEGIN
{**************************************************************************}
{************* Einlesen von REJECT.BOX ************************************}
{**************************************************************************}
  new(tmp);
  Reject_Box_Root := NIL;
  WRITLN('Reading REJECT.BOX...');
   ASSIGN(f,BoxPath+'reject.box');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult=0 THEN BEGIN
    dummy := 0;
    WHILE NOT EOF(f) DO BEGIN
      READLN(f,S);
      inc(dummy);
      IF LENGTH(S)>0 THEN IF S[1]<>'#' THEN BEGIN
        S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));
        S1 := COPY(S,1,POS(' ',S)-1);
        S := COPY(S,POS(' ',S)+1,255);
        IF (S1<>'R') AND (S1<>'H') AND (S1<>'L') THEN BEGIN
          STR(dummy,S1);
          WRITLN('Error in Line '+S1);
        END
        ELSE BEGIN
          CASE S1[1] OF
            'R': tmp^.Was := 1;
            'H': tmp^.Was := 2;
            'L': tmp^.Was := 3;
          END;
          S1 := COPY(S,1,POS(' ',S)-1);
          S := COPY(S,POS(' ',S)+1,255);
          IF LENGTH(S1)=0 THEN BEGIN
            STR(dummy,S1);
            WRITLN('Error in Line '+S1);
          END
          ELSE BEGIN
            tmp^.Typ := S1[1];
            S1 := COPY(S,1,POS(' ',S)-1);
            S := COPY(S,POS(' ',S)+1,255);
            IF LENGTH(S1)=0 THEN BEGIN
              STR(dummy,S1);
              WRITLN('Error in Line '+S1);
            END
            ELSE BEGIN
              tmp^.Absender := S1;
              S1 := COPY(S,1,POS(' ',S)-1);
              S := COPY(S,POS(' ',S)+1,255);
              IF LENGTH(S1)=0 THEN BEGIN
                STR(dummy,S1);
                WRITLN('Error in Line '+S1);
              END
              ELSE BEGIN
                tmp^.Rubrik := S1;
                S1 := COPY(S,1,POS(' ',S)-1);
                S := COPY(S,POS(' ',S)+1,255);
                IF LENGTH(S1)=0 THEN BEGIN
                  STR(dummy,S1);
                  WRITLN('Error in Line '+S1);
                END
                ELSE BEGIN
                  tmp^.MBX := S1;
                  IF POS(' ',S)>0 THEN BEGIN
                    {Es ist noch ein 5. Parameter angegeben}
                    S1 := COPY(S,1,POS(' ',S)-1);
                    S := COPY(S,POS(' ',S)+1,255);
                    tmp^.BID := S1;
                    tmp^.Not_Hold := 0;
                    FOR i := 1 TO LENGTH(S) DO BEGIN
                      CASE S[i] OF
                        'P': tmp^.Not_Hold := tmp^.Not_Hold OR 1;
                        'U': tmp^.Not_Hold := tmp^.Not_Hold OR 2;
                      END;
                    END;
                  END
                  ELSE BEGIN
                    {Kein 5. Parameter vorhanden.}
                    tmp^.BID := S;
                    tmp^.Not_Hold := 0;
                  END;

                  {Speichern}
                  tmp2:=Reject_Box_Root;
                  IF tmp2=NIL THEN BEGIN
                    new(Reject_Box_Root);
                    tmp2:=Reject_Box_Root;
                  END
                  ELSE BEGIN
                    tmp2:=Reject_Box_Root;
                    WHILE tmp2^.next<>NIL DO tmp2:=tmp2^.next;
                    New(tmp2^.Next);
                    tmp2:=tmp2^.Next;
                  END;

                  tmp2^.Next := NIL;
                  tmp2^.Typ := tmp^.Typ;
                  tmp2^.Was := tmp^.Was;
                  tmp2^.Absender := tmp^.Absender;
                  tmp2^.Rubrik := tmp^.Rubrik;
                  tmp2^.MBX := tmp^.MBX;
                  tmp2^.BID := tmp^.BID;
                  tmp2^.Not_Hold := tmp^.Not_Hold;

                END;
              END;
            END;
          END;
        END;
      END;
    END;
    CLOSE(f);
  END;
  dispose(tmp);
END;


PROCEDURE READDirData(ch:BYTE;MELDUNG:BOOLEAN);

  PROCEDURE WRITLN(s:string80);
  BEGIN
    IF MELDUNG THEN WriteLN(s) ELSE
    PutData(ch,s+#13);
  END;

  PROCEDURE WRIT(s:string80);
  BEGIN
    IF MELDUNG THEN Write(s) ELSE
    PutData(ch,s);
  END;
VAR
  dummy: WORD;
  s,s1:string;
  SR: SearchRec;
  IdxFile: FILE OF Verwalt_Rec;
  Idx: Verwalt_Rec;
  bool:boolean;
BEGIN
  {Standard-Anzahl der Rubriken fr den Dir-Befehl}
  AnzRub := 0;

  WRITLN('Reading DIR-Data...');
  FindFirst(BoxPath+'index'+PATH_SEP+'*.idx',$3F,SR);
  WHILE DosError=0 DO BEGIN
    ASSIGN(IdxFile,BoxPath+'index'+PATH_SEP+SR.Name);
    {$I-}
    RESET(IdxFile);
    {$I+}
    IF IOResult=0 THEN BEGIN
      AnzRub := AnzRub + 1;
      NEW(DirInfo[AnzRub]);
      DirInfo[AnzRub]^.Rubrik := gross(COPY(SR.Name,1,POS('.',SR.Name)-1));
      DirInfo[AnzRub]^.Mails := 0;
      WHILE NOT EOF(IdxFile) DO BEGIN
        READ(IdxFile,Idx);
           {ungelscht}
        IF Idx.Flags AND VERWALT_DEL=0 THEN inc(DirInfo[AnzRub]^.Mails);
      END;
      IF Rufz(DirInfo[AnzRub]^.Rubrik) THEN DirInfo[AnzRub]^.Art := 'U'
                                       ELSE DirInfo[AnzRub]^.Art := 'I';

      IF DirInfo[AnzRub]^.Mails = 0 THEN BEGIN
        DISPOSE(DirInfo[AnzRub]);
        AnzRub := AnzRub - 1;
      END;
      CLOSE(IdxFile);
    END;
    FindNext(SR);
  END;
  SortDirInfo;
END;


(*
 *  PROCEDURE READOnlineHelp
 * Informationen ber die Online-Hilfe
 *)
PROCEDURE READOnlineHelp(ch: BYTE;MELDUNG: BOOLEAN);
VAR tmp: pOnlineHelp;
    f: Text;
    S: STRING;
    Anz,i: BYTE;
    Befehl: STRING[20];
    Filename: STRING[8];
    Level: BYTE;
    code: WORD;
    count: BYTE;
BEGIN

  IF MELDUNG THEN WRITE('Reading Mailbox Online-Help... ')
             ELSE PutData(ch,'Reading Mailbox Online-Help... ');

   ASSIGN(f,BoxPath+'help'+PATH_SEP+'liste.hlp');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    OnlineHelp := NIL;
    Exit;
  END;
  OnlIneHelp:=NIL;tmp:=NIL;
  count := 0;
  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    S := LTRIM(RTRIM(OnlyOneSpace(S)));
    IF COPY(S,1,1)<>'#' THEN BEGIN
      anz := 0;
      FOR i := 1 TO LENGTH(S) DO IF S[i]=#32 THEN inc(anz);
      IF anz=2 THEN BEGIN
        Befehl := COPY(S,1,POS(' ',S)-1);
        S := COPY(S,POS(' ',S)+1,255);
        Filename := COPY(S,1,POS(' ',S)-1);
        S := COPY(S,POS(' ',S)+1,255);
        VAL(S,Level,code);
        IF code=0 THEN BEGIN
          {Speicher fr das Listenfeld reservieren}
          tmp:=OnlineHelp;
          IF tmp=NIL THEN BEGIN
            new(OnlineHelp);
            tmp:=OnlineHelp;
          END
          ELSE BEGIN
            tmp:=OnlineHelp;
            WHILE tmp^.next<>NIL DO tmp:=tmp^.next;
            New(tmp^.Next);
            tmp:=tmp^.Next;
          END;

          tmp^.Next := NIL;
          tmp^.Command := Befehl;
          tmp^.Filename := Filename;
          tmp^.Level := Level;
          inc(Count);
        END;
      END;
    END;
  END;
  CLOSE(f);
  STR(Count,S);

  IF MELDUNG THEN WRITELN(S+' items found')
             ELSE PutData(ch,S+' items found'#13);
END;


FUNCTION LoadBoxCommands:BOOLEAN;
VAR parafile:text;
    Acmd:pcmd;
    dummy:STRING;
BEGIN
  LoadBoxCommands:=TRUE;
  Assign(paraFile,boxpath+'bcmd');
  {$I-}
  WriteLn('Reading BCMD..');
  Reset(paraFile);
  IF IOResult>0 THEN
  BEGIN
    LoadBoxCommands:=FALSE;
    exit;
  END;
  new(boxcmds);
  acmd:=boxcmds;
  WHILE NOT eof(parafile) DO
  BEGIN
    Readln(parafile,dummy);
    IF (dummy<>'') AND (dummy[1]<>'#') THEN
    BEGIN
       acmd^.cmd:=Gross(copy(dummy,1,pos(' ',dummy)-1));
       dummy:=copy(dummy,pos(' ',dummy)+1,255);
       val(copy(dummy,1,pos(' ',dummy)-1),acmd^.nr,err);
       dummy:=copy(dummy,pos(' ',dummy)+1,255);
       val(copy(dummy,1,pos(' ',dummy)-1),acmd^.lev,err);
       dummy:=copy(dummy,pos(' ',dummy)+1,255);
       val(dummy,acmd^.slev,err);
       acmd^.next:=NIL;
       IF NOT(eof(parafile)) THEN
       BEGIN
        New(acmd^.next);
        acmd:=acmd^.next;
       END;
    END;
  END;
  close(parafile);

END;



{Mailbox-Konfigurationsfile einlesen}
PROCEDURE InitBox;
VAR f: Text;
    S,S1: STRING;
    code: WORD;
    UserFile: FILE OF R_UserFile;
    User: R_UserFile;
    Naechst,bool: BOOLEAN;
    BinF: File;
    ch: BYTE;
    Result: WORD;
    dummy: WORD;
    SR:SEARCHREC;
BEGIN
  Box_is_running:=FALSE;
  IF (boxcall='') OR NOT rufz(boxcall)
  THEN BEGIN
    WriteLn('Invalid Boxcall, cannot boot BBS');
    exit;
  END;
  FINDFIRST(BoxPath+'.',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(copy(Boxpath,1,length(boxpath)-1));
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+' does not exist.');
      WRITELN('cant boot BBS');
      exit;
    END;
  END;
  LastTime := 0;
  AnzPerSec := 0;

  {Standardwerte (OwnBoxData) setzen}
  new(OwnBoxData);
  WITH OwnBoxData^ DO BEGIN
    SF_Call := BoxCall;
    Hierach := '';
    SFInfo := '';
    SF_Proto := FALSE;
    User_LT := 100;
    BBS_Connect := TRUE;
    Header_Eintrag := TRUE;
    Beacon := FALSE;
    M_E_LT := 10;
    M_E_MBX := CutSSID(BoxCall);
    M_E_Use := TRUE;
    DB0_MYBBS := TRUE;
    SF_Mit_jedem := TRUE;
    M_FILTER := '';
    Third_Party := FALSE;
    SYSTEM_MSG_TO := 'Y';
  END;


{$IFDEF LINUX}
   (* solange DPLZH noch nich portiert ist ....*)
   SID:='[LMCT-'+Version+'-ABDFHM$]';
{$ELSE}   
  {SID der Mailbox setzen}
  SID := '[MCT-'+Version+'-AB';
{$IFDEF B1}
  SID := SID + '1';
{$ENDIF}
  SID := SID + 'DFHM$]';
{$ENDIF}

   ASSIGN(f,BoxPath+'box.cfg');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    WRITELN('BOX.CFG existiert nicht (im BOX-Directory)');
    WRITELN;
    dispose(ownboxdata);
    exit;
  END;

  IF NOT LoadBoxCommands THEN
  BEGIN
    WRITELN('BCMD.MCT existiert nicht (im BOX-Directory)');
    WRITELN;
    dispose(ownboxdata);
    exit;
  END;

   BidHash:=new(PFhash,init(boxpath+'bidhash.mct'));
  IF HashError>0 THEN
  BEGIN
    WriteLn('BID-Hashing-Datei fehlt -> neu erstellt , unbedingt GARBAGE ausfhren!');
     BidHash:=new(PFhash,create(boxpath+'bidhash.mct',19997,sizeof(Tbidhashrec)));
    IF HashError>0 THEN BEGIN
      WriteLn('Cant create BIDHASH.MCT ! (check FILES= and BoxPath and free harddisk space.');
      Dispose(ownboxdata);
      {$I-}
      assign(f,boxpath+'bidhash.mct');
      erase(f);
      exit;
    END;
  END;
  InitUserFile;


  WRITELN('Reading BOX.CFG...');
  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    Naechst := TRUE;
    IF S[1] <> '#' THEN BEGIN
      S1 := Gross(COPY(S,1,POS(' ',S)-1));

      {Call, das zum Aufbauen von S&F-Verbindungen benutzt wird}
      IF (S1 = 'SF_CALL') AND Naechst THEN BEGIN
        OwnBoxData^.SF_Call := LTRIM(RTRIM(COPY(S,POS('=',S)+1,255)));
        Naechst := FALSE;
      END;

      {Info in eckigen klammern im eigenen S&F-Header}
      IF (S1 = 'SF_INFO') AND Naechst THEN BEGIN
        OwnBoxData^.SFInfo := LTRIM(RTRIM(COPY(S,POS('=',S)+1,255)));
        Naechst := FALSE;
      END;

      {Eigene Hierachie}
      IF (S1 = 'SF_HIERACH') AND Naechst THEN BEGIN
        OwnBoxData^.Hierach := LTRIM(RTRIM(COPY(S,POS('=',S)+1,255)));
        Naechst := FALSE;
      END;


      IF (S1 = 'SF_WITH_ALL_STN') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.SF_Mit_Jedem := TRUE
                                ELSE OwnBoxData^.SF_Mit_Jedem := FALSE;
        Naechst := FALSE;
      END;


      IF (S1 = 'MAILBEACON') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.Beacon := TRUE
                                ELSE OwnBoxData^.Beacon := FALSE;
        Naechst := FALSE;
      END;


      IF (S1 = 'SF_PROTO') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.SF_Proto := TRUE
                                ELSE OwnBoxData^.SF_Proto := FALSE;
        Naechst := FALSE;
      END;


      IF (S1 = 'HEADER_EINTR') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.Header_Eintrag := TRUE
                                ELSE OwnBoxData^.Header_Eintrag := FALSE;
        Naechst := FALSE;
      END;


      IF (S1 = 'USER_LT') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        VAL(S1,OwnBoxData^.User_LT,code);
        IF code <> 0 THEN OwnBoxData^.User_LT := 100;
        Naechst := FALSE;
      END;

      IF (S1='DB0_MYBBS') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.DB0_MYBBS := TRUE
                                ELSE OwnBoxData^.DB0_MYBBS := FALSE;
        Naechst := FALSE;
      END;


      IF (S1 = 'BBS_CONNECT') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.BBS_Connect := TRUE
                                ELSE OwnBoxData^.BBS_Connect := FALSE;
        Naechst := FALSE;
      END;


      {Konfigurationen fr M und E-Mails (MYBBS-Infos und Fernerase)}
      IF (S1 = 'M/E_LT') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        VAL(S1,OwnBoxData^.M_E_LT,code);
        IF code <> 0 THEN OwnBoxData^.M_E_LT := 10;
        Naechst := FALSE;
      END;

      IF (S1 = 'M/E_MBX') AND Naechst THEN BEGIN
        OwnBoxData^.M_E_MBX := LTRIM(RTRIM(COPY(S,POS('=',S)+1,255)));
        Naechst := FALSE;
      END;

      IF (S1 = 'SYSMSG_TO') AND Naechst THEN BEGIN
        OwnBoxData^.System_MSG_to := LTRIM(RTRIM(COPY(S,POS('=',S)+1,255)));
        Naechst := FALSE;
      END;


      IF (S1 = 'M/E_SEND') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.M_E_Use := TRUE
                                ELSE OwnBoxData^.M_E_Use := FALSE;
        Naechst := FALSE;
      END;

      IF (S1='SF_AB_KBYTES') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        VAL(S1,OwnBoxData^.SF_Ab_kBytes,code);
        IF code=0 THEN OwnBoxData^.SF_Ab_kBytes := 0;
        Naechst := FALSE;
      END;

      IF (S1='THIRD_PARTY') AND Naechst THEN BEGIN
        S1 := Gross(LTRIM(RTRIM(COPY(S,POS('=',S)+1,255))));
        IF (S1='J') OR (S1='Y') THEN OwnBoxData^.Third_Party := TRUE
                                ELSE OwnBoxData^.Third_Party := FALSE;
        Naechst := TRUE;
      END;

    END;
  END;
  CLOSE(f);



  {Test, ob wichtige BOX-Verzeichnisse vorhanden sind}
  WRITELN('Checking BOX-directories...');

  FINDFIRST(BoxPath+'import',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'import');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'import'+PATH_SEP+' does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;
  END;

  FINDFIRST(BoxPath+'index',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'index');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'INDEX\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;
  END;

  FINDFIRST(BoxPath+'info',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'info');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'INFO\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;
  END;

  FINDFIRST(BoxPath+'msg',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'msg');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'MSG\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;

  END;

  FINDFIRST(BoxPath+'proto',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'proto');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'PROTO\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;

  END;

  FINDFIRST(BoxPath+'temp',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'temp');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'TEMP\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;
  END;

  FINDFIRST(BoxPath+'user',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'user');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'USER\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;
  END;

  FINDFIRST(BoxPath+'server',Directory,SR);
  IF DosError<>0 THEN BEGIN
    MkDir(Boxpath+'server');
    IF IORESULT<>0 THEN
    BEGIN
      WRITELN('The directory '+BoxPath+'SERVER\ does not exist.');
      WRITELN('cant boot BBS');
      dispose(ownboxdata);
      dispose(userhash,done);
      dispose(bidhash,done);
      exit;
    END;

  END;

  ReadDirData(0,TRUE);

  {Mailbox-Sprachfiles berprfen}
  WRITE('Checking mailbox language-files... ');
  dummy := 0;

  FindFirst(BoxPath+'msg'+PATH_SEP+'messages.*',$3F-Directory-VolumeID,SR);
  WHILE doserror=0 DO BEGIN
    IF POS('.',SR.Name)>0 THEN BEGIN

      inc(dummy);
      IF dummy=1 THEN WRITE('(')
                 ELSE WRITE(',');

      WRITE(COPY(SR.Name,POS('.',SR.Name)+1,255));

      ASSIGN(BinF,BoxPath+'msg'+PATH_SEP+SR.Name);
      {$I-}
      RESET(BinF,1);
      {$I+}
      IF IOResult=0 THEN BEGIN
        BLOCKREAD(BinF,ch,1,Result);
        IF ch <> LanguageFileVersion THEN BEGIN
          WRITELN;
          WRITELN('Language-File '+SR.Name+' is not recent! There can be errors.'+#7#7);
          WRITELN;
        END;
        CLOSE(BinF);
      END;
    END;
    FindNext(SR);
  END;
  WRITELN(')');


  ReadRejectBox(0,TRUE);

  ReadOnlineHelp(0,TRUE);

  WRITE('Searching for M_FILTER...');
  FindFirst(BoxPath+'M_FILTER.EXE',$20,SR);
  IF doserror=0 THEN BEGIN
    WRITELN(' M_FILTER.EXE found');
    S := M_FILTER_CopyrightMessage(BoxPath+'M_FILTER.EXE');
    IF LENGTH(S)>0 THEN WRITELN('('+S+')');
    OwnBoxData^.M_FILTER := BoxPath+'M_FILTER.EXE';
  END
  ELSE BEGIN
    FindFirst(BoxPath+'M_FILTER.COM',$20,SR);
    IF doserror=0 THEN BEGIN
      WRITELN(' M_FILTER.COM found');
      OwnBoxData^.M_FILTER := BoxPath+'M_FILTER.COM';
    END
    ELSE BEGIN
      WRITELN(' No M_FILTER found');
      OwnBoxData^.M_FILTER := '';
    END;
  END;



  ReadServerBOX(0,TRUE);
  WRITELN('Reading BOX.SF...');
  ReadBOXSF(0,TRUE);
  delay(3000);
  Box_is_running:=TRUE
END;


{Beendet die Mailbox (wirft alle User 'raus, macht den Speicher wieder
 frei etc}
PROCEDURE Box_Done;
VAR i,k: LONGINT;
BEGIN
  IF NOT box_is_running THEN exit;
  box_is_running:=FALSE;
  FOR i := 0 TO 255 DO IF KS[i]<>NIL THEN BEGIN
    IF (KS[i]^.status>=50) AND (KS[i]^.status<=60) THEN BEGIN
      {Es ist ein Box-Connect}
      PutData(i,'*** Mailbox shutdown'+#13);
      Box_BYE(i,TRUE);
    END;
  END;
  {Daten der eigenen Mailbox lschen und Speicher freigeben}
  DISPOSE(OwnBoxData);
  FreeBOXSF;
  FreeServerBOX;
  FreeRejectBOX;
  FreeDirInfo;
  dispose(BidHash,Done);
  dispose(UserHash,Done);
END;



END.