Unit MyString;
{Schnelle String Routinen von DG8NDY fr WinGT}
Interface

{$IFNDEF LINUX}
Type HexArray = Array[0 .. 15] of Char;

Type PCallStr = ^TCallStr;
     TCallStr = String[12];

Type PShortStr  = ^TShortStr;
     TShortStr  = String[15];

Type PMediumStr = ^TMediumStr;
     TMediumStr = String[31];

Type TString    = String[80];

Type PHalfStr   = ^THalfStr;
     THalfStr   = String[127];

Type TFName     = Array[0..79] of Char;


Function  SlashToBackSlash(AStr: String): String;
Function  Equal(Str1, Str2: String): Boolean;
Function  Compare(Str1, Str2: String): Boolean;
Function  DelLeftSpace(AStr: String): String;
Function  DelRightSpace(AStr: String): String;
Function  Gross(AStr: String): String;
Function  Find(AStr: String;AChar: Char; Var L, R: String): Boolean;
Function  FindAndSkipString(AStr: String; VAR Folge: String): String;
Function  FilterNotCRLF(AStr: String): String;
Function  FindString(AStr, Folge: String): String;
Function  FindStringStartPos( AStr, Folge: String): Word;

Function  FilterCRLF(AStr: String): String;
Function  FilterDigiMap(AStr: String): String;
Function  FilterString(AStr: String): String;
Function  FilterLF(AStr: String): String;
Function  FilterString32CR(AStr: String): String;
Function  FilterString32(AStr: String): String;

Function  ChangeAZ(VAR AStr: String): String;

Function  FoundString: Boolean;
Function  Klein(K_str: String): String;
Function  Links(AStr: String; AAnzahl: Word): String;
Function  Rechts(AStr: String; AAnzahl: Word): String;
Function  Split(AStr: String; Count: Byte): String;
Procedure NDelete(VAR AStr: String; Start, Laenge: Word);
Function  ConvertByteToString(Zahl: Byte): String;
Function  ConvertByteToHexString(Zahl: Byte): String;
Function  ConvertHexStringToWord(AStr: String; Var AWord: Word): Boolean;
Function  SplitStringCR(VAR AStr: String): String;
Procedure CopyStringToArray(VAR AStr: String; Var Feld: TFName);
Function  JoinStr(VAR Str1, Str2: String): String;
Function  JoinStrC(Str1, Str2: TShortStr): TMediumStr;
Procedure AddChar(Var AStr: String; AChar: Char);
Function  CheckAndModifyCall(Var ACall: String): Boolean;
Function  CheckCall(ACall: String): Boolean;

Procedure ReplaceComAnd(Var AStr: String);

Procedure MyFillChar(Var Source; Size: Word; Sign: Char);

Function  DeleteSSID(ACall: String): String;
Function  StripDRSI(ACall: String): String;
Function  StripHierarchicalAdress(AStr: String): String;
Function  StrToNumber(AStr: String; Var ANr: LongInt): Boolean;

CONST Found1234567: Boolean = False;
      Hex         : HexArray = ('0', '1', '2', '3', '4', '5', '6', '7', '8',
                                '9', 'A', 'B', 'C', 'D', 'E', 'F');
{$ENDIF}
Implementation
{$IFNDEF LINUX}
{$S+}
Function  SlashToBackSlash(AStr: String): String; Assembler;
          ASM
             PUSH   DS
             CLD
             LDS    SI,AStr;
             LES    DI,@Result;
             LODSB
             STOSB
             AND    AL,AL
             JZ     @Ende
             XOR    AH,AH
             MOV    CX,AX
          @Schleife:
             LODSB
             CMP    AL,'/';
             JNE    @W1
             MOV    AL,'\';
          @W1:
             STOSB
             LOOP   @Schleife
          @Ende:
             POP    DS
          End;

Function  Equal(Str1, Str2: String): Boolean; Assembler;
          ASM
             PUSH   DS
             CLD
             LDS    SI,Str1
             LES    DI,Str2
             LODSB                          {AL = Lnge von Str1}
             CMP    AL,es:[di]     {AH = Lnge von Str1}
             JNE    @False

             CMP    AL,00h
             JE     @False

             INC    DI                      {DI um eins erhhen}
             MOV    CL,AL
             XOR    CH,CH

             REPE   CMPSB
             JE     @True

          @False:
             XOR   AX,AX
             JMP   @Ende
          @True:
             MOV   AX,01h
          @Ende:
             POP   DS
          END;


Function Compare(Str1, Str2: String): Boolean; Assembler;
         ASM
            PUSH DS
            CLD                 {Strings aufwrts}
            LES  DI,[Str2]
            MOV  CL,Byte ptr es:[DI] {CL= Lnge}
            AND  CL,CL          {Wenn CL = 0 dann Zeroflag gesetzt}
            JZ   @True
            XOR  CH,CH          {CX = Lnge Str2}
            LDS  SI,[Str1]
            LODSB               {AL = Lnge Str1}
            AND  AL,AL          {AL = 0 -> Zero gesetzt}
            JZ   @False
            CMP  AL,CL          {Str1 < Str2 ???}
            JB   @False
            INC  DI
         @Schleife:
            REPE CMPSB          {Solange vergleichen, bis Unterschied}
            JNZ  @False
         @True:
            MOV  AX,01h
            JMP  @Ende
         @False:
            XOR  AX,AX
         @Ende:
            POP  DS
         End;

Function DelLeftSpace(AStr: String): String; Assembler;
         ASM
            PUSH  DS
            CLD                         {Strings aufwrts}
            LDS   SI,AStr
            LES   DI,@Result
            LODSB
            AND   AL,AL                 {Wenn AL = 0 dann Zero gesetzt}
            JNZ   @W1
            STOSB                       {Nullstring zurck}
            JMP   @Ende
         @W1:
            MOV   CL,AL
            XOR   CH,CH                 {CX = Lnge AStr}
         @Schleife:
            LODSB
            CMP   AL,' '
            JNE    @W2
            LOOP  @Schleife
         @W2:
            XCHG  AH,AL                 {AL nach AH retten und CL -> AL abspeichern}
            MOV   Al,CL
            STOSW                       {Neue Lnge in String speichern}
            JCXZ  @Ende
            SHR   CX,1
            REP   MOVSW
            JNC   @Ende
            MOVSB
         @Ende:
            POP   DS
         END;

Function DelRightSpace(AStr: String): String; Assembler;
         ASM
            PUSH DS
            STD                 {Stringbearbeitung Abwrts}
            LDS  SI,AStr        {DS:SI = Zeiger auf AStr}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            LODSB               {Lnge von AStr in AL}
            INC  SI             {SI wieder auf Anfangswert}
            STOSB               {Lnge vorerst sichern}
            INC  DI             {DI wieder auf Anfangswert}
            XOR  AH,AH          {AX = Lnge}
            ADD  SI,AX          {DS:SI zeigt auf ende vom String}
            XCHG CX,AX          {CX = Lnge}
            JCXZ @ende
         @Schleife:
            LODSB               {Zeichen einladen}
            CMP AL,20h          {Ist Zeichen ein Space???}
            JNE  @Weiter
            LOOP @Schleife

         @Weiter:
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]
            INC  SI             {DS:SI zeigt auf erstes Zeichen}
            MOV  AX,CX         {AL = Lnge}
            STOSB               {Richtige Lnge in Ergebniss speichern}
            JCXZ @ende
              SHR   CX,1
              REP   MOVSW
              JNC   @Ende
              MOVSB
         @ende:
            POP  DS
         end;

Function Gross(AStr: String): String; Assembler;
         Asm
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LES  DI,@Result     {ES:DI = Zeiger auf Gross3}
            LODSB               {AL = Lnge von AStr}
            STOSB               {                   }
            XOR  AH,AH          {AX = Lnge von AStr}
            XCHG AX,CX          {CX = Lnge von AStr}
            XOR  DX,DX          {DX = Zhler fr neue Stringlnge}
            JCXZ @ende          {Wenn CX = 0 dann ende}
          @Schleife:
            LODSB               {AL = Zeichen}
            CMP  AL,''         {AL = ???}
            JNE  @1             {Nein, dann weiter}
            MOV  AL,''
            JMP  @Store
          @1:
            CMP  AL,''         {AL = ???}
            JNE  @2             {Nein, dann weiter}
            MOV  AL,''
            JMP  @Store
          @2:
            CMP  AL,''         {AL = ???}
            JNE  @3             {Nein, dann weiter}
            MOV  AL,''
            jmp  @Store
          @3:
            CMP  AL,''         {AL = ???}
            JNE  @4             {Nein, dann weiter}
            MOV  AL,'S'         {AL = S}
            STOSB               {AL -> Result}
            INC  DX             {String wurde um eins lnger}
            CMP  DX,0FFh        {Schon 255 Zeichen???}
            JE   @ende          {Ja, dann ende}
            JMP  @Store
          @4:
            CMP  AL,'a'         {AL < a???}
            JB   @Store         {Ja, dann weiter}
            CMP  AL,'z'         {AL > z???}
            JA   @Store         {Ja, dann weiter}
            SUB  AL,20h         {Nein, dann ASCII(AL) -32}
          @Store:
            STOSB               {AL -> Result}
            INC  DX             {String wurde um eins lnger}
            CMP  DX,0FFh        {Schon 255 Zeichen???}
            JE   @ende          {Ja, dann ende}
            LOOP @Schleife
          @ende:
            LES  DI,@Result     {ES:DI = Zeiger auf @Result}
            XCHG DX,AX          {AL = DL = Stringlnge des neuen Strings}
            STOSB               {Speichern}
            POP  DS
         end;
Function  Find(AStr: String;AChar: Char; Var L, R: String): Boolean; ASSEMBLER;
          Var Laenge: Word;
          ASM
             PUSH DS
             CLD                        {Stringbearbeitung aufwrts}
             MOV  BL,AChar              {BL = AChar}
             LDS  SI,[AStr]             {DS:SI = Zeiger auf AStr}
             LES  DI,[L]                {ES:DI = Zeiger auf L}
             LODSB                      {AL = Lnge von AStr}
             STOSB                      {Lnge in L speichern}
             XOR  AH,AH                 {AX = Lnge von AStr}
             XCHG CX,AX                 {CX mit AX tauschen}
             MOV  Laenge,CX             {CX in Laenge sichern}

             XOR  DX,DX                 {DX = Flag fr Gefunden}

             JCXZ @Speichern            {Wenn String = '' dann ende}
          @Schleife:
             LODSB                      {Zeichen aus AStr in AL}
             CMP  BL,AL                 {Zeichen = AChar ???}
             JE   @Zeichen_Gefunden     {Ja, dann nach gefunden...}
             STOSB                      {Nein, dann Zeichen in L speichern}
             LOOP @Schleife             {Schleife, bis CX = 0}

             JMP  @Speichern            {Zeichen wurde nicht gefunden}

          @Zeichen_Gefunden:
             MOV  DX,01h

          @Speichern:
             MOV  AX,Laenge             {AX ist Laenge von AStr}
             SUB  AX,CX                 {AX = Laenge von L}
             LES  DI,[L]                {ES:DI = Zeiger auf L}
             STOSB                      {Richtige Lnge in L speichern}
             JCXZ @Weiter
             DEC  CX                    {CX berichtigen}
          @Weiter:
             MOV  AX,CX                 {AX = Restlnge}
             LES  DI,[R]                {ES:DI = Zeiger auf R}
             STOSB                      {Restlnge in R speichern}
             JCXZ @ende
               SHR   CX,1
               REP   MOVSW
               JNC   @Ende
               MOVSB
          @ende:
             POP  DS
             MOV  AX,DX                  {Gefunden = True/False}
          end;
Function FindAndSkipString(AStr: String; VAR Folge: String): String; ASSEMBLER;
         Var M, N: Word;
             OFolge: Word;
             OAStr : Word;
             SKIP: ARRAY[0..255] of Byte;
             Sicher: Byte;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            MOV  AX,SS          {ES = SS}
            MOV  ES,AX
            LEA  DI,[Skip]      {SS:DI = Zeiger auf Skip}
            LDS  SI,[Folge]     {DS:SI = Zeiger auf Folge}

            MOV  AL, Byte ptr ds:[SI]
            MOV  AH,AL
            MOV  CX,80h
            REP  STOSW

            XOR  DX,DX          {DX = 0}
            LDS  SI,[Folge]     {DS:SI = Zeiger auf Folge}
            XOR  BX,BX          {BX = 0}
            MOV  BL,DS:[SI]     {BL = Lnge der Folge}
            ADD  SI,BX          {DS:SI zeigt auf letztes Zeichen der Folge}
            LEA  DI,[Skip]      {SS:DI = Zeiger auf Skip}

         @Schleife:

            MOV  AL,Byte ptr ds:[SI]  {Zeichen aus Folge nach AL}
            DEC  SI
            MOV  BL,AL          {BX = Offset Folge}
            CMP  AH,ss:[DI+BX]
            JNE  @Weiter
            MOV  ss:[DI+BX],DL  {SKIP[] = DL}
         @Weiter:
            INC  DL             {Vorgezogen von @Weiter, da dann DEC und INC}
                                {nach bedingten Sprung wegfllt}
            CMP  DL,AH          {DL = AH}
            JNE  @Schleife      {Schleife falls <>}

            XOR  AX,AX
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            MOV  OAStr,SI       {OAStr = erstes Zeichen}
            MOV  AL,Byte ptr ds:[SI]
            MOV  N,AX           {N:= Length(AStr)}

            LES  DI,[Folge]     {ES:DI = Zeiger auf Folge}
            MOV  OFolge,DI      {OFolge = erstes Zeichen}
            MOV  AL,es:[DI]     {AL = Lnge}

            MOV  M,AX           {LngenInfo in M speichern}

            ADD  SI,AX           {Start bei SI + M}
            ADD  DI,AX           {Start bei DI + M}
         @Schleife2:
            MOV  AL,ds:[SI]     {AL = Zeichen aus AStr}
            MOV  AH,es:[DI]     {AH = Zeichen aus Folge}
            CMP  AH,AL          {Wenn AH <> AL, dann weiter}
            JNE  @Weiter1
               DEC SI           {i:= i-1}
               DEC DI           {j:= j-1}
               JMP @endBedingung
         @Weiter1:
            MOV  CX,M            {CX = Length(Folge)}
            ADD  CX,OFolge       {CX = M + OFolge}
            SUB  CX,DI           {CX = M - J}
            INC  CX              {CX = M - J + 1}
            XOR  BH,BH
            MOV  BL,Byte ptr ds:[SI] { BX = Zeichen AStr[i]}
            LEA  DX,[Skip]       {DX = Offset Skip}
            ADD  BX,DX           {BX = Offset in Skip-Tabelle}
            MOV  DX,ss:[BX]      {DX = Zeichen aus Skip}
            XOR  DH,DH
            CMP  CX,DX
            JA   @Moeg1
               ADD  SI,DX        {I = I + Skip[AStr[I]]}
               MOV  DI,OFolge    {J = M}
               ADD  DI,M
               JMP  @endBedingung
         @Moeg1:
               ADD  SI,CX        {I = I + M - j +1}
               MOV  DI,OFolge    {J = M}
               ADD  DI,M
         @endBedingung:
            CMP  DI,OFolge       {Zeigt DI vor Stringanfang?}
            JE   @ende
            MOV  BX,SI
            SUB  BX,OAStr        {BX = welches Zeichen von AStr}
            CMP  BX,N            {Zeigt BX hinter String???}
            JBE  @Schleife2
         @ende:
            ADD  SI,M            {SI = SI + Length(Folge)}
            MOV  CX,SI           {CX = Aktuelle Stringposition}
            SUB  CX,OAStr        {CX = Aktuell - Anfang = Welches Zeichen}
            CMP  CX,N            {Ist CX > Stringlnge???}
            JA   @NullString     {Ja, dann wurde nichts gefunden}

            INC  SI              {SI = Zeiger auf Zeichen danach (fr Skip)}
            LES  DI,@Result      {ES:DI zeigt auf Ergebniss}
            NEG  CX              {Zweierkomplement von CX}
            ADD  CX,N            {CX = N - CX = Rest-Stringlnge}
            MOV  AL,CL           {Lngeninfo in Stringspeichern}
            STOSB
            JCXZ @1              {Ist CX null?}
            SHR  CX,1
            REP  MOVSW           {Nein, dann Reststring in Ergebniss speichern}
            JNC  @1
            MOVSB
         @1:
            MOV  AX,01h         {Found1234567 = True}
            JMP  @Ganzende

         @NullString:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            MOV  AX,00h         {Found1234567 = False und StringLnge = 0}
            STOSB

         @Ganzende:
            POP  DS
            MOV  FOUND1234567,AL
         end;

Function FindString(AStr, Folge: String): String; ASSEMBLER;
         Var M, N: Word;
             OFolge: Word;
             OAStr : Word;
             SKIP: ARRAY[0..255] of Byte;
             Sicher: Byte;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            MOV  AX,SS          {ES = SS}
            MOV  ES,AX
            LEA  DI,[Skip]      {SS:DI = Zeiger auf Skip}
            LDS  SI,[Folge]     {DS:SI = Zeiger auf Folge}

            MOV  AL, Byte ptr ds:[SI]
            MOV  AH,AL
            MOV  CX,80h
            REP  STOSW

            XOR  DX,DX          {DX = 0}
            LDS  SI,[Folge]     {DS:SI = Zeiger auf Folge}
            XOR  BX,BX          {BX = 0}
            MOV  BL,DS:[SI]     {BL = Lnge der Folge}
            ADD  SI,BX          {DS:SI zeigt auf letztes Zeichen der Folge}
            LEA  DI,[Skip]      {SS:DI = Zeiger auf Skip}

         @Schleife:

            MOV  AL,Byte ptr ds:[SI]  {Zeichen aus Folge nach AL}
            DEC  SI
            MOV  BL,AL          {BX = Offset Folge}
            CMP  AH,ss:[DI+BX]
            JNE  @Weiter
            MOV  ss:[DI+BX],DL  {SKIP[] = DL}
         @Weiter:
            INC  DL             {Vorgezogen von @Weiter, da dann DEC und INC}
                                {nach bedingten Sprung wegfllt}
            CMP  DL,AH          {DL = AH}
            JNE  @Schleife      {Schleife falls <>}

            XOR  AX,AX
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            MOV  OAStr,SI       {OAStr = erstes Zeichen}
            MOV  AL,Byte ptr ds:[SI]
            MOV  N,AX           {N:= Length(AStr)}

            LES  DI,[Folge]     {ES:DI = Zeiger auf Folge}
            MOV  OFolge,DI      {OFolge = erstes Zeichen}
            MOV  AL,es:[DI]     {AL = Lnge}

            MOV  M,AX           {LngenInfo in M speichern}

            ADD  SI,AX           {Start bei SI + M}
            ADD  DI,AX           {Start bei DI + M}
         @Schleife2:
            MOV  AL,ds:[SI]     {AL = Zeichen aus AStr}
            MOV  AH,es:[DI]     {AH = Zeichen aus Folge}
            CMP  AH,AL          {Wenn AH <> AL, dann weiter}
            JNE  @Weiter1
               DEC SI           {i:= i-1}
               DEC DI           {j:= j-1}
               JMP @endBedingung
         @Weiter1:
            MOV  CX,M            {CX = Length(Folge)}
            ADD  CX,OFolge       {CX = M + OFolge}
            SUB  CX,DI           {CX = M - J}
            INC  CX              {CX = M - J + 1}
            XOR  BH,BH
            MOV  BL,Byte ptr ds:[SI] { BX = Zeichen AStr[i]}
            LEA  DX,[Skip]       {DX = Offset Skip}
            ADD  BX,DX           {BX = Offset in Skip-Tabelle}
            MOV  DX,ss:[BX]      {DX = Zeichen aus Skip}
            XOR  DH,DH
            CMP  CX,DX
            JA   @Moeg1
               ADD  SI,DX        {I = I + Skip[AStr[I]]}
               MOV  DI,OFolge    {J = M}
               ADD  DI,M
               JMP  @endBedingung
         @Moeg1:
               ADD  SI,CX        {I = I + M - j +1}
               MOV  DI,OFolge    {J = M}
               ADD  DI,M
         @endBedingung:
            CMP  DI,OFolge       {Zeigt DI vor Stringanfang?}
            JE   @ende
            MOV  BX,SI
            SUB  BX,OAStr        {BX = welches Zeichen von AStr}
            CMP  BX,N            {Zeigt BX hinter String???}
            JBE  @Schleife2
         @ende:
            MOV  CX,SI           {CX = Aktuelle Stringposition}
            SUB  CX,OAStr        {CX = Aktuell - Anfang = Welches Zeichen}
            CMP  CX,N            {Ist CX > Stringlnge???}
            JA   @NullString     {Ja, dann wurde nichts gefunden}

            INC  SI              {SI = Zeiger auf Zeichen danach (fr Skip)}
            LES  DI,@Result      {ES:DI zeigt auf Ergebniss}
            NEG  CX              {Zweierkomplement von CX}
            ADD  CX,N            {CX = N - CX = Rest-Stringlnge}
            MOV  AL,CL           {Lngeninfo in Stringspeichern}
            STOSB
            JCXZ @1              {Ist CX null?}
            SHR  CX,1
            REP  MOVSW           {Nein, dann Reststring in Ergebniss speichern}
            JNC  @1
            MOVSB
         @1:
            MOV  AX,01h         {Found1234567 = True}
            JMP  @Ganzende

         @NullString:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            MOV  AX,00h         {Found1234567 = False und StringLnge = 0}
            STOSB

         @Ganzende:
            POP  DS
            MOV  FOUND1234567,AL
         end;

Function FindStringStartPos(AStr, Folge: String): Word; ASSEMBLER;
         Var M, N: Word;
             OFolge: Word;
             OAStr : Word;
             SKIP: ARRAY[0..255] of Byte;
             Sicher: Byte;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            MOV  AX,SS          {ES = SS}
            MOV  ES,AX
            LEA  DI,[Skip]      {SS:DI = Zeiger auf Skip}
            LDS  SI,[Folge]     {DS:SI = Zeiger auf Folge}

            MOV  AL, Byte ptr ds:[SI]
            MOV  AH,AL
            MOV  CX,80h
            REP  STOSW

            XOR  DX,DX          {DX = 0}
            LDS  SI,[Folge]     {DS:SI = Zeiger auf Folge}
            XOR  BX,BX          {BX = 0}
            MOV  BL,DS:[SI]     {BL = Lnge der Folge}
            ADD  SI,BX          {DS:SI zeigt auf letztes Zeichen der Folge}
            LEA  DI,[Skip]      {SS:DI = Zeiger auf Skip}

         @Schleife:

            MOV  AL,Byte ptr ds:[SI]  {Zeichen aus Folge nach AL}
            DEC  SI
            MOV  BL,AL          {BX = Offset Folge}
            CMP  AH,ss:[DI+BX]
            JNE  @Weiter
            MOV  ss:[DI+BX],DL  {SKIP[] = DL}
         @Weiter:
            INC  DL             {Vorgezogen von @Weiter, da dann DEC und INC}
                                {nach bedingten Sprung wegfllt}
            CMP  DL,AH          {DL = AH}
            JNE  @Schleife      {Schleife falls <>}

            XOR  AX,AX
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            MOV  OAStr,SI       {OAStr = erstes Zeichen}
            MOV  AL,Byte ptr ds:[SI]
            MOV  N,AX           {N:= Length(AStr)}

            LES  DI,[Folge]     {ES:DI = Zeiger auf Folge}
            MOV  OFolge,DI      {OFolge = erstes Zeichen}
            MOV  AL,es:[DI]     {AL = Lnge}

            MOV  M,AX           {LngenInfo in M speichern}

            ADD  SI,AX           {Start bei SI + M}
            ADD  DI,AX           {Start bei DI + M}
         @Schleife2:
            MOV  AL,ds:[SI]     {AL = Zeichen aus AStr}
            MOV  AH,es:[DI]     {AH = Zeichen aus Folge}
            CMP  AH,AL          {Wenn AH <> AL, dann weiter}
            JNE  @Weiter1
               DEC SI           {i:= i-1}
               DEC DI           {j:= j-1}
               JMP @endBedingung
         @Weiter1:
            MOV  CX,M            {CX = Length(Folge)}
            ADD  CX,OFolge       {CX = M + OFolge}
            SUB  CX,DI           {CX = M - J}
            INC  CX              {CX = M - J + 1}
            XOR  BH,BH
            MOV  BL,Byte ptr ds:[SI] { BX = Zeichen AStr[i]}
            LEA  DX,[Skip]       {DX = Offset Skip}
            ADD  BX,DX           {BX = Offset in Skip-Tabelle}
            MOV  DX,ss:[BX]      {DX = Zeichen aus Skip}
            XOR  DH,DH
            CMP  CX,DX
            JA   @Moeg1
               ADD  SI,DX        {I = I + Skip[AStr[I]]}
               MOV  DI,OFolge    {J = M}
               ADD  DI,M
               JMP  @endBedingung
         @Moeg1:
               ADD  SI,CX        {I = I + M - j +1}
               MOV  DI,OFolge    {J = M}
               ADD  DI,M
         @endBedingung:
            CMP  DI,OFolge       {Zeigt DI vor Stringanfang?}
            JE   @ende
            MOV  BX,SI
            SUB  BX,OAStr        {BX = welches Zeichen von AStr}
            CMP  BX,N            {Zeigt BX hinter String???}
            JBE  @Schleife2
         @ende:
            MOV  CX,SI           {CX = Aktuelle Stringposition}
            SUB  CX,OAStr        {CX = Aktuell - Anfang = Welches Zeichen}
            INC  CX
            CMP  CX,N            {Ist CX > Stringlnge???}
            JA   @NullString     {Ja, dann wurde nichts gefunden}
            MOV  AX,CX
            JMP  @GanzEnde

         @NullString:
            MOV  AX,00h         {Found1234567 = False und StringLnge = 0}

         @Ganzende:
            POP  DS
         end;

{Function FindString(AStr, Folge: String): String;
         Var I, J: Integer;
             M, N: Integer;
             Skip: Array[0..255] of Byte;
             Dummy: String;

Procedure InitSkip;
          Var Z: Byte;
          Begin
             FillChar(Skip, SizeOf(Skip), M);
             For Z:= 0 to M-1 do
             Begin
                If Skip[Byte(Folge[M-Z])] = M then
                   Skip[Byte(Folge[M-Z])]:= Z;
             end;
          end;

         Begin
            M:= Length(Folge);
            N:= Length(AStr);
            I:= M;
            J:= M;
            InitSkip;
            Repeat
               If AStr[i] = Folge[j] then
               Begin
                  Dec(i);
                  Dec(j);
               end else
               Begin
                  If M-J+1 > Skip[Byte(AStr[i])]
                     then i:= i + M - j +1
                     else i:= i + Skip[Byte(AStr[i])];
                  j:= M;
               end;
            until (j < 1) or (I > N);
            If i < N then Found1234567:= True
               else Found1234567:= False;
            Delete(AStr, 1, i);
            FindString:= AStr;
         end;}

Function FilterNotCRLF(AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,0Ah         {Zeichen = LF???}
            JE   @Speichern
            CMP  AL,0Dh         {Zeichen = CR???}
            JE   @Speichern
            CMP  AL,20H         {Zeichen >= ' '???}
            JB   @Weiter
         @Speichern:
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function FilterCRLF(AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,0Ah         {Zeichen = LF???}
            JE   @Weiter
            CMP  AL,0Dh         {Zeichen = CR???}
            JE   @Weiter
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function FilterString(AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,07h         {Zeichen = Bell???}
            JE   @Speichern
            CMP  AL,0Dh         {Zeichen = CR???}
            JE   @Speichern
            CMP  AL,20H         {Zeichen >= ' '???}
            JB   @Weiter
         @Speichern:
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function FilterDigiMap(AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,' '         {Zeichen <= Space?}
            JBE  @Weiter;
            CMP  AL,'#'
            JE   @Weiter
            CMP  AL,'&'
            JE   @Weiter
            CMP  AL,'$'
            JE   @Weiter
            CMP  AL,'%'
            JE   @Weiter
         @Speichern:
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function FilterLF(AStr: String): String; Assembler;
         ASM
            PUSH  DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}

            CMP  AL,10          {Zeichen = LF}
            JE   @Weiter
         @Speichern:
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function FilterString32CR(AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,0Dh         {CR ???}
            JNE  @Weiter1
            MOV  AL,20h         {CR durch Space ersetzen}
            JMP  @Speichern1
         @Weiter1:
            CMP  AL,20H         {Zeichen >= ' '???}
            JB   @Weiter2       {Nein, dann weiter}
         @Speichern1:
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter2:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function FilterString32(AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            XCHG CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            MOV  DX,00h         {DX = Lnge neuer String}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            Inc  DI             {ES:DI zeigt auf 1. Zeichen von Ergebniss}
            JCXZ @Speichern2
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,20H         {Zeichen >= ' '???}
            JAE  @Speichern1    {Ja, dann weiter}
            MOV  AL,20H         {Nein, dann durch Space ersetzen}
         @Speichern1:
            STOSB               {Zeichen in neuen String speichern}
            INC  DL             {Lnge anpassen}
         @Weiter2:
            LOOP @Schleife

         @Speichern2:
            LES  DI,@Result     {ES:DI zeigt auf Ergebniss}
            XCHG DL,AL          {AL = Lnge neuer String}
            STOSB               {Lngeninfo abspeichern}
            POP  DS
         end;

Function ChangeAZ(VAR AStr: String): String; Assembler;
         ASM
            PUSH DS
            CLD                 {Stringbearbeitung aufwrts}
            LDS  SI,[AStr]      {DS:SI = Zeiger auf AStr}
            LODSB               {AL = Lnge von AStr}
            MOV  CL,AL          {CL = AL}
            XOR  CH,CH          {CX = Lnge von AStr}
            LES  DI,@Result     {ES:DI = Zeiger auf Ergebniss}
            STOSB               {Lnge abspeichern}
            JCXZ @Ende
         @Schleife:
            LODSB               {Zeichen aus AStr laden}
            CMP  AL,00h         {Zeichen = #0???}
            JNE  @Speichern
            MOV  AL,20h         {Durch Space ersetzen}
         @Speichern:
            STOSB               {Zeichen in neuen String speichern}
         @Weiter:
            LOOP @Schleife

         @Ende:
            POP  DS
         end;

Function FoundString: Boolean;
         Begin
            FoundString := Found1234567;
            Found1234567:= False;
         end;

Function  Klein(K_Str: String): String;
          var dummy_char: char;
              dummy_str: string;
              k_i: integer;
              Laenge: Byte absolute K_Str;
          Begin
            dummy_str:='';
            k_i:=1;
            If laenge <> 0 then
            Begin
               repeat
                 dummy_char:=k_str[k_i];
                 if (dummy_char>='A') and (dummy_char<='Z') then
                    dummy_char:=chr(ord(dummy_char)+32);
                 dummy_str:=dummy_str+dummy_char;
                 inc(k_i);
               until k_i > laenge;
            end;
            klein:=dummy_str;
          end;

Function Links(AStr: String; AAnzahl: Word): String; Assembler;
         ASM
            CLD
            LES   DI,@Result
            MOV   AX,AAnzahl
            CMP   AX,00FFh
            JBE   @W1
            MOV   AX,00FFh
         @W1:
            STOSB               {Neue Lnge speichern}
            MOV   CX,AX
            JCXZ  @GEnde
            PUSH  DS
            LDS   SI,[AStr]
            LODSB               {AL = Lnge von AStr}
            XOR   AH,AH         {AX = ""}
            CMP   AX,00FFh
            JBE   @W2
            MOV   AX,00FFh
         @W2:
            XOR   BX,BX         {BX = 0}
            CMP   AX,CX         {Ist AX >= CX}
            JAE   @W3
            MOV   BX,CX
            SUB   BX,AX         {BX = Rest von Space}
            MOV   CX,AX
         @W3:
            SHR   CX,1
            REP   MOVSW
            JNC   @W4
            MOVSB

         @W4:
            MOV   CX,BX         {Rest mit Space auffllen}
            JCXZ  @Ende
            MOV   AX,2020h
            SHR   CX,1
            REP   STOSW
            JNC   @Ende
            STOSB
         @Ende:
            POP   DS
         @GEnde:
         END;

Function  Split(AStr: String; Count: Byte): String; Assembler;
          ASM
             PUSH  DS
             CLD                {Strings aufwrts}
             MOV   Bl,Count
             XOR   BH,BH        {BX = Umbruch}
             LDS   SI,[AStr]
             LODSB
             XOR   AH,AH        {AX = Lnge}
             MOV   CX,AX        {CX = Lnge}

             CMP   AX,BX        {Lnge > Umbruch???}
             JA    @Umbruch
             MOV   BX,00h
             JMP   @W2

          @Umbruch:
             STD                {String abwrts}
             XCHG  CX,BX
             MOV   DX,CX        {DX Ist Count}
             ADD   SI,CX
          @Schleife1:
             LODSB              {Zeichen in AL}
             CMP   AL,' '
             JE    @W1
             LOOP  @Schleife1
             MOV   CX,DX
             SUB   BX,DX

             JMP   @W2

          @W1:
             SUB   BX,CX
             DEC   BX           {Space wird bersprungen}

          @W2:
             LDS   SI,[AStr]
             INC   SI
             LES   DI,@Result
             CLD
             MOV   AX,CX
             STOSB              {Lnge speichern}
             JCXZ  @MOVE2
               SHR   CX,1
               REP   MOVSW
               JNC   @Move2
               MOVSB

          @MOVE2:
             XCHG  CX,BX
             LES   DI,[AStr]
             MOV   AX,CX
             STOSB              {Lnge speichern}
             JCXZ  @Ende
             CMP   Byte ptr DS:[SI],' '
             JNE   @W3
             INC   SI           {' ' berspringen}
          @W3:
             SHR   CX,1
             REP   MOVSW
             JNC   @Ende
             MOVSB

          @Ende:
             POP   DS
          end;

Procedure NDelete(VAR AStr: String; Start, Laenge: Word); Assembler;
          ASM
             PUSH  DS
             MOV   BX,Start
             CMP   BX,00        {Start mu > sein als 0}
             JE    @Ende
             Dec   BX
             MOV   DX,Laenge    {Lnge mu > sein als 0}
             CMP   DX,00h
             JE    @Ende
             LES   DI,AStr
             LDS   SI,AStr
             CLD
             LODSB
             XOR   AH,AH
             CMP   AX,00
             JE    @Ende        {AStr = ''}
             CMP   BX,AX
             JA    @Ende        {Start > Lnge von AStr}
             MOV   CX,AX
             ADD   DX,BX        {DX = Zeiger auf erstes zu verschieb. Zeichen}
             CMP   DX,AX
             JB    @W1
             MOV   AX,BX
             STOSB
             Jmp   @Ende
          @W1:
             ADD   CX,BX
             SUB   CX,DX
             MOV   AX,CX
             STOSB
             JCXZ  @Ende
             ADD   SI,DX
             ADD   DI,BX

             SHR   CX,1
             REP   MOVSW
             JNC   @Ende
                MOVSB

          @Ende:
             POP   DS
          end;

Function Rechts(AStr: String; AAnzahl: Word): String; Assembler;
         ASM
            CLD                 {String aufwrts}
            LES   DI,@Result
            MOV   AX,AAnzahl
            CMP   AX,00FFh
            JBE   @W1
            MOV   AX,00FFh
         @W1:
            STOSB               {Lnge des neuen Strings speichern}
            MOV   CX,AX         {CX = ""}
            JCXZ  @GEnde

            PUSH  DS
            LDS   SI,[AStr]
            LODSB               {AL = Lnge}
            XOR   AH,AH         {AX = Lnge}

            CMP   CX,AX         {Ist neue Lnge <= alte Lnge}
            JBE   @Weiter
               MOV   BX,AX      {BX ist alte (rest) Lnge}
               SUB   CX,AX      {CX ist Anzahl der einzufgenden Spaces}

               MOV   AX,2020h   {AX = Spaces}
               SHR   CX,1
               REP   STOSW
               JNC   @W2
               STOSB
            @W2:
               MOV CX,BX
               JMP @Kopieren

         @Weiter:
            MOV   BX,AX
            SUB   BX,CX         {BX ist die zu berspringende Lnge}
            ADD   SI,BX         {Zeiger poitionieren}

         @Kopieren:
            SHR   CX,1          {Reststring kopieren}
            REP   MOVSW
            JNC   @Ende
            MOVSB

         @Ende:
            POP   DS
         @GEnde:
         end;

Function ConvertByteToString(Zahl: Byte): String; Assembler;
         ASM
            LES  DI,@Result
            CLD
            MOV  AL,02h
            STOSB
            MOV  AL,Zahl
            CMP  AL,64h
            JB   @W0
            MOV  AL,63h
         @W0:
            XOR  AH,AH
            XOR  DX,DX
            MOV  CX,AX
            MOV  BL,0Ah
            CMP  AL,BL
            JB   @W3
            DIV  BL
            XOR  AH,AH
            JMP  @W4
         @W3:
            XOR  AX,AX
         @W4:
            PUSH AX
            MUL  BL
            SUB  CX,AX
            MOV  AX,CX
            PUSH AX
            ADD DI,01h
            MOV CX,02h
            STD
         @Schleife:
            POP AX
            ADD AL,'0'
            Stosb
            LOOP @Schleife
         @Ende:
         END;

Function  ConvertByteToHexString(Zahl: Byte): String;
          Var Dummy: String[3];
          Begin
             Dummy:= Hex[Zahl SHR 4] + Hex[Zahl MOD 16];
             ConvertByteToHexString:= Dummy;
          end;

Function  JoinStrC(Str1, Str2: TShortStr): TMediumStr; assembler;
          ASM
             PUSH  DS
             CLD
             LDS   SI,[Str1]
             LODSB
             XOR   AH,AH        {AX = Lnge von Str1}
             LES   DI,@Result
             INC   DI           {ES:DI auf erstes Zeichen Ergebniss}
             MOV   CX,AX
             MOV   DX,AX        {DX = Lnge von AStr}
             JCXZ  @W1
             SHR  CX,1
             REP  MOVSW
             JNC  @W1
             MOVSB

          @W1:
             LDS   SI,[Str2]
             LODSB
             XOR   AH,AH        {AX = Lnge von Str2}
             MOV   CX,0FFh
             SUB   CX,DX        {Maximal noch mglich}
             CMP   CX,AX        {Wenn CX < AX, dann nur CX verschieben}
             JBE   @W2
             MOV   CX,AX
          @W2:
             ADD  DX,CX
             JCXZ @Ende
             SHR  CX,1
             REP  MOVSW
             JNC  @Ende
             MOVSB

          @Ende:
             LES   DI,@Result
             MOV   AX,DX
             STOSB
             POP   DS
          end;

Function  JoinStr(VAR Str1, Str2: String): String; Assembler;
          ASM
             PUSH  DS
             CLD
             LDS   SI,[Str1]
             LODSB
             XOR   AH,AH        {AX = Lnge von Str1}
             LES   DI,@Result
             INC   DI           {ES:DI auf erstes Zeichen Ergebniss}
             MOV   CX,AX
             MOV   DX,AX        {DX = Lnge von AStr}
             JCXZ  @W1
             SHR  CX,1
             REP  MOVSW
             JNC  @W1
             MOVSB

          @W1:
             LDS   SI,[Str2]
             LODSB
             XOR   AH,AH        {AX = Lnge von Str2}
             MOV   CX,0FFh
             SUB   CX,DX        {Maximal noch mglich}
             CMP   CX,AX        {Wenn CX < AX, dann nur CX verschieben}
             JBE   @W2
             MOV   CX,AX
          @W2:
             ADD  DX,CX
             JCXZ @Ende
             SHR  CX,1
             REP  MOVSW
             JNC  @Ende
             MOVSB

          @Ende:
             LES   DI,@Result
             MOV   AX,DX
             STOSB
             POP   DS
          end;

Procedure AddChar(Var AStr: String; AChar: Char); Assembler;
          ASM
             LES   DI,[AStr]
             MOV   AL,Byte ptr es:[di]
             CMP   AL,0FFh
             JAE   @Ende
             XOR   AH,AH
             INC   AL
             MOV   Byte ptr es:[di],AL
             ADD   DI,AX
             MOV   AL,AChar
             MOV   Byte ptr es:[DI],AL
          @Ende:
          end;

Function  ConvertHexStringToWord(AStr: String; Var AWord: Word): Boolean;
          Type Zahl = Record
                         Low : Word;
                         High: Word;
                      end;
          Var I,J: Byte;
              Sum: LongInt;
              Fehler: Boolean;
          Begin
             Fehler:= False;
             AStr:= Gross(AStr);
             Sum := 0;
             J:= 1;
             While (J <= Length(AStr)) and not(Fehler) do
             Begin
                I:= 0;
                While (i < 16) and (AStr[j] <> Hex[i]) do Inc(I);
                If I < 16 then Sum:= Sum*16 + i
                   else Fehler:= True;
                Inc(j);
             end;
             If Sum > $FFFF then Fehler:= True
                else AWord:= Zahl(Sum).Low;
             ConvertHexStringToWord:= Not(Fehler);
          end;

Function  SplitStringCR(VAR AStr: String): String;
          Var Dummy: String;
              Len  : Byte;
          Begin
             Len:= Length(AStr);
             Find(AStr, #13, Dummy, AStr);
             If Length(Dummy) <> Len then
                SplitStringCR:= Dummy + #13
             else
                SplitStringCR:= Dummy;
          end;

Procedure CopyStringToArray(VAR AStr: String; Var Feld: TFName); Assembler;
          ASM
             PUSH  DS
             CLD
             LDS   SI,AStr
             LODSB
             XOR   AH,AH
             CMP   AX,80
             JBE   @W1
             MOV   AX,80
          @W1:
             MOV   CX,AX
             JCXZ  @Ende
             LES   DI,Feld
             SHR   CX,1
             REP   MOVSW
             JNC   @Ende
                MOVSB

          @Ende:
             POP   DS
          end;

{$IFDEF CB}

Function CheckAndModifyCall(Var ACall: String): Boolean;
         Var Len : Byte Absolute ACall;

Function Test(AChar: Char): Boolean; Assembler;
         ASM
            CMP  AChar,'0'
            JB   @False
            CMP  AChar,'9'
            JA   @False
            MOV  AX,01h
            JMP  @Ende
         @False:
            XOR  AX,AX
         @Ende:
         end;

         Begin
            CheckAndModifyCall:= False;
            ACall:= DelRightSpace(FilterString32(DeleteSSID(ACall)));
            If (Len <> 6) then EXIT;
            CheckAndModifyCall:= not(Test(ACall[1]) AND Test(ACall[2]) AND Test(ACall[5]) AND Test(ACall[6])) AND
                                     Test(ACall[3]) AND Test(ACall[4]);
         end;

Function CheckCall(ACall: String): Boolean;
         Var Len : Byte Absolute ACall;

Function Test(AChar: Char): Boolean; Assembler;
         ASM
            CMP  AChar,'0'
            JB   @False
            CMP  AChar,'9'
            JA   @False
            MOV  AX,01h
            JMP  @Ende
         @False:
            XOR  AX,AX
         @Ende:
         end;

         Begin
            CheckCall:= False;
            ACall:= DelLeftSpace(DelRightSpace(FilterString32(DeleteSSID(ACall))));
            If (Len <> 6) then EXIT;
            CheckCall:= not(Test(ACall[1]) AND Test(ACall[2]) AND Test(ACall[5]) AND Test(ACall[6])) AND
                            Test(ACall[3]) AND Test(ACall[4]);
         end;


{$ELSE}

Function CheckAndModifyCall(Var ACall: String): Boolean;
         Var Len : Byte Absolute ACall;

Function Test(AChar: Char): Boolean; Assembler;
         ASM
            CMP  AChar,'0'
            JB   @False
            CMP  AChar,'9'
            JA   @False
            MOV  AX,01h
            JMP  @Ende
         @False:
            XOR  AX,AX
         @Ende:
         end;

         Begin
            CheckAndModifyCall:= False;
            ACall:= DelRightSpace(FilterString32(DeleteSSID(ACall)));
            If (Len < 4) then EXIT;
            If not((Test(ACall[1]) AND Test(ACall[2])) OR
                   (Test(ACall[3]) AND Test(ACall[4]))) AND
               (((Len >= 4) AND Test(ACall[3])) OR
                 ((Len = 5) AND Test(ACall[2]))  OR
                 ((Len = 4) AND Test(ACall[2]))) then CheckAndModifyCall:= True;
         end;

Function CheckCall(ACall: String): Boolean;
         Var Len : Byte Absolute ACall;

Function Test(AChar: Char): Boolean; Assembler;
         ASM
            CMP  AChar,'0'
            JB   @False
            CMP  AChar,'9'
            JA   @False
            MOV  AX,01h
            JMP  @Ende
         @False:
            XOR  AX,AX
         @Ende:
         end;

         Begin
            CheckCall:= False;
            ACall:= DelLeftSpace(DelRightSpace(FilterString32(DeleteSSID(ACall))));
            If (Len < 4) then EXIT;
            If not((Test(ACall[1]) AND Test(ACall[2])) OR
                   (Test(ACall[3]) AND Test(ACall[4]))) AND
               (((Len >= 4) AND Test(ACall[3])) OR
                 ((Len = 5) AND Test(ACall[2]))  OR
                 ((Len = 4) AND Test(ACall[2]))) then CheckCall:= True;
         end;
{$ENDIF}

Procedure   ReplaceComAnd(Var AStr: String); Assembler;
            ASM
               PUSH DS
               CLD
               LDS  SI,[AStr]
               LODSB
               XOR  AH,AH
               XCHG CX,AX
               JCXZ @Ende
               LES  DI,[AStr]
            @Schleife:
               LODSB
               CMP  AL,'@'
               JNE  @Weiter
               MOV  DI,SI
               DEC  DI
               MOV  Byte ptr ES:[DI],13
            @Weiter:
               LOOP @Schleife
            @Ende:
               POP  DS
            End;

Procedure MyFillChar(Var Source; Size: Word; Sign: Char); Assembler;
          ASM
            CLD
            LES  DI,SOURCE              {ES:DI zeigt auf Source}
            MOV  CX,Size

            MOV  AL,Sign
            MOV  AH,AL
            SHR  CX,1
            REP  STOSW
            JNC  @Ende
              STOSB

          @Ende:
          End;

Function  DeleteSSID(ACall: String): String; Assembler;
          ASM
             PUSH  DS
             CLD
             LDS   SI,ACall
             LODSB                  {AL = Lnge von ACall}
             XOR   AH,AH
             MOV   CX,AX
             JCXZ  @Ende
             MOV   DX,AX            {Lnge des Strings merken}
             LES   DI,@Result
             INC   DI
          @Schleife:
             LODSB                  {Zeichen laden}
             CMP   AL,'-'
             JE    @Weiter
             STOSB
             LOOP  @Schleife
          @Weiter:
             SUB   DX,CX
             XCHG  AX,DX
          @Ende:
             LES   DI,@Result
             STOSB
             POP   DS
          end;

Function  StripDRSI(ACall: String): String;
          Var L, R: String[32];
          Begin
             If Find(ACall, ':', L, R) Then
                StripDRSI:= R
             else
                StripDRSI:= ACall;
          end;

{--- StripHierachicalAdress entfernt den hierarchischen Anteil einer Adresse ---}

CONST AllowedSigns: Set of Char = ['A'..'Z', '0'..'9'];

Function StripHierarchicalAdress(AStr: String): String;
         Var I  : Byte;
             Len: Byte absolute AStr;
         Begin
            AStr:= Gross(DelLeftSpace(DelRightSpace(AStr)));
            I:= 1;
            While (I <= Len) AND (AStr[i] in AllowedSigns) DO Inc(I);
            Len:= I-1;
            StripHierarchicalAdress:= AStr;
         end;

Function  StrToNumber(AStr: String; Var ANr: LongInt): Boolean;
          Var Error: Integer;
          Begin
             AStr:= DelLeftSpace(DelRightSpace(FilterString32(AStr)));
             Val(AStr, ANr, Error);
             StrToNumber:= Error = 0;
          end;
{$ENDIF}
end.