(****************************************************************************)
(* Remotebefehle des Terminals von MCUT.                                    *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

{$F+,O+}
UNIT MCUTREM;
INTERFACE

PROCEDURE handleNcmd(s: STRING; ch: byte);
PROCEDURE ShowVariables(c:BYTE);
IMPLEMENTATION

USES
{$IFNDEF linux}
memory,
{$ENDIF}
  crt,toolbox,mcutlib,mcutlib2,(*exec,*)termuser,
     {$IFDEF WA8DED}
     tnc,
     {$ENDIF}
     {$IFDEF FLEXNET}
     flxapp,
     {$ENDIF}
     {$IFDEF CONVERS}
     convers,
     {$ENDIF}
     {$IFDEF BOX}
      boxmain,
     {$ENDIF}
     iadvar,
     dos,
     {$IFDEF linux}linux,{$ENDIF}
     screen,mystring,packet;





FUNCTION PARSE(c:BYTE;S:STRING;Syn:STRING40;VAR p1,p2:PATHSTR):BOOLEAN;
VAR adir:PATHSTR;nam:namestr;ext:extstr;
BEGIN
  PARSE:=TRUE;
  S:=LTRIM(S);
  S:=RTRIM(S);
   {$IFNDEF linux}
  S:=GROSS(S);
   {$ENDIF}
  IF s = '' THEN
  BEGIN
    PutData(c,'SYNTAX: '+syn+#13);
    PARSE:=FALSE;
    exit
  END;
  IF FIND(s,' ',p1,p2) THEN
    p2:=LTRIM(p2);
  s:=p1+' ';
  dos.fsplit(s, adir, nam, ext);
  IF ((KS[c]^.FLAGS AND KS_SYSOP)=0) THEN
    p1:=KS[c]^.rempath + nam + ext
  ELSE
    IF ((adir[1]<>PATH_SEP) AND (adir[2]<>':') AND (adir<>'')) OR (adir='')  THEN
      p1:=KS[c]^.rempath + adir + nam + ext;
  p1:=ltrim(rtrim(p1));

END;

PROCEDURE Quit(c: byte);
BEGIN
  CASE KS[c]^.status OF
    7:SendTermMacroFile(c,textpath+'qtext');
    {help(c, 'TERM', 'QRT');}
    12:SendTermMacroFile(c,textpath+'nqtext');
    {help(c, 'NODE', 'QRT');}
  END;
  IF KS[c]^.compress>0 THEN
  BEGIN
    KS[c]^.compress:=0; PutData(c,'//COMP 0'+#13)
  END;  
  KS[c]^.FLAGS := KS[c]^.FLAGS OR KS_DISCREQ;
  SaveTermUser(c);
END;

PROCEDURE Pass(c: byte; s: STRING);
VAR x:longint;st,st2:STRING[10];
BEGIN
  IF (KS[c]^.FLAGS AND KS_SYSOP)<>0 THEN
  BEGIN
    KS[c]^.FLAGS:= KS[c]^.FLAGS AND NOT KS_SYSOP;
    exit;
  END;
  REPEAT
    Randomize;
    KS[c]^.pass:=random(65534);
    str(KS[c]^.PASS, st2);
  UNTIL length(st2) = 5 ;
  str(c, st);
  PutData(c, '(' + st + ') ' + st2 + '>');
  KS[c]^.LastStatus:=KS[c]^.status;
  KS[c]^.status:=8
END;



PROCEDURE RTEXT(c: byte;s: STRING);
var sr:searchrec;s2:STRING;
BEGIN
  IF NOT PARSE(c,s,' READ <file1> [file_to_write]',s,s2) THEN EXIT;
  IF s2 <> '' THEN
    PutData(c,'//W '+s2+#13);
  FindFirst(s,anyfile,sr);
  IF (doserror<>0) OR ((sr.attr AND directory)=directory) THEN
    putData(c,'No such file or it is a directory ;-)'#13)
  ELSE
    putfile(c, s);
END;

PROCEDURE ChangeDir(c: BYTE;S:STRING);
VAR olddir,newdir,l,r:STRING[80];U:tTermUserRec;OK:BOOLEAN;
BEGIN
  {$I-}
  IF S='' THEN
  BEGIN
    PutData(c,KS[c]^.rempath+#13);
    exit;
  END;
  GetDir(0,olddir);
  IF (S[1]<>PATH_SEP) AND (S[2]<>':') THEN
    S:=KS[c]^.RemPath+S;
  ChDir(S);
  IF IORESULT<>0 THEN
  BEGIN
    ChDir(olddir);
    IF IORESULT<>0 THEN ;
    PutData(c,'DOS error.'+#13);
    exit;
  END;
  GetDir(0,newdir);
  IF (newdir[length(newdir)]<>PATH_SEP) THEN
    newdir:=newdir+PATH_SEP;
  OK:=FALSE;
  IF (KS[c]^.FLAGS AND KS_SYSOP)=0 THEN
  BEGIN
    U.Call:=KS[c]^.Call;
    GetTermUser(u);
    r:=gross(u.directory);
    WHILE FIND(r,';',l,r) DO
      IF (copy(newdir,1,length(l))=l) AND (l<>'') THEN
        OK:=TRUE;
    IF (COPY(newdir,1,length(r))=r) AND (r<>'') THEN
      OK:=TRUE;
    IF (COPY(newdir,1,length(rempath))=rempath) AND (rempath<>'') THEN
      OK:=TRUE;
    IF NOT OK THEN
    BEGIN
      PutData(c,'permission denied.'+#13);
      newdir:=KS[c]^.RemPath;
    END;
  END;
  KS[c]^.rempath:=newdir;
  ChDir(olddir);
  {$I+}
END;




PROCEDURE WTEXT(c: Byte;s: STRING);
VAR s2:pathstr;
BEGIN
  IF NOT PARSE(c,s,' WRITE <file1> [file_to_read]',s,s2) THEN EXIT;
  KS[c]^.laststatus:=KS[c]^.status;
  IF FileDa(s) THEN
  BEGIN
    PutData(c,s+' does already exist.'+#13);
    exit;
  END;
  IF KS[c]^.Datei=NIL THEN New(KS[c]^.Datei);
    Assign(KS[c]^.datei^, s);
  {$I-}
  Rewrite(KS[c]^.datei^);
  IF IORESULT = 0 THEN
  BEGIN
    IF s2 <> '' THEN
      PutData(c, '//R '+s2+#13);
    PutData(c, s + ' is now open, send ^Z or ***END to close' + #13);
    KS[c]^.status:=5;
  END
  ELSE
  BEGIN
    PutData(c, 'Cannot open ' + s + #13);
    DISPOSE(KS[c]^.Datei);
    KS[c]^.Datei:=NIL;
  END;
END;

PROCEDURE TNCCommand(c: byte; s: STRING);
BEGIN
END;

PROCEDURE Ring(c: byte);
VAR s:STRING;b:byte;
BEGIN
  str(c, s);
  s:=KS[c]^.Call + ' on channel ' + s + ' is ringing';
  PopUp(s);
  IF (KS[c]^.RING_ANZ>MaxRing) THEN
  BEGIN
    PutData(c,'Sri, too many //RING'+#13);
    exit;
  END;
  IF (klingel) THEN
  BEGIN
    INC(KS[c]^.RING_ANZ);
    IF ringbell = '' THEN
    BEGIN
      FOR b:=1 TO 30 DO
      BEGIN
        IF klingel THEN sound((b MOD 3) * 440);
        Delay(100);
      END;
      Nosound;
    END
    ELSE
      PlayString(RingBell);
  END;
  IF klingel THEN
    s:=CutSSID(mycall) + ' is being called' + #13
  ELSE   s:='sorry, bell is off' + #13;
  PutData(c, s);
END;

PROCEDURE CS(c: byte);
VAR B,b2:byte;y,z:char;st:STRING[3];
BEGIN
  FOR B:=1 TO 255 DO
  IF KS[b]<>NIL THEN
  BEGIN
    z:=char(KS[b]^.port + 48);
    IF NOT (KS[b]^.status IN [0,9]) THEN
    BEGIN
      {$IFDEF fpk}
       str(b, st);
      {$ELSE}
       str(b:3,st);
       {$ENDIF}
      PutData(c, st + ' ');
    END;
    b2:=KS[b]^.status;
    IF b2 IN [13..16,25,8] THEN b2:=KS[b]^.laststatus;
    IF (KS[b]^.FLAGS AND KS_OWNCON)=0 THEN
      CASE b2 OF
        51,60:PutData(c,'(' + KS[b]^.Call + ') <--> S&F '  + #13);
        50,52..59:PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> BOX'#13);
        6:PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> CONVERS'#13);
        7:PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> TERMINAL'#13);
        12:PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> NODE'#13);
        10:
        BEGIN
          y:=char(KS[KS[b]^.crosschan]^.port + 48);
          IF KS[KS[b]^.crosschan]^.CALL = '' THEN
            PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> Link setup ' + y + #13)
          ELSE
            PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> (' +
              KS[KS[b]^.crosschan]^.Call + ') ' + y + #13);
        END;
         100:PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> CONVERS (login)'#13);
         101:PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> CONVERS-Link'#13);
      END;

    IF (KS[b]^.FLAGS AND KS_OWNCON)<>0 THEN
      CASE b2 OF
        51,60:PutData(c,'S&F <--> (' + KS[b]^.Call + ') '  + #13);
        50,52..59:PutData(c, 'BOX ---> (' + KS[b]^.Call + ') '  + #13);
        6:PutData(c, 'CONVERS ---> (' + KS[b]^.Call + ') '  + #13);
        2,7:PutData(c, 'TERMINAL  ---> (' + KS[b]^.Call + ') '  + #13);
        12:PutData(c, 'NODE ---> (' + KS[b]^.Call + ') '  + #13);
        10:
        BEGIN
          y:=char(KS[KS[b]^.crosschan]^.port + 48);
          IF KS[Ks[b]^.crosschan]^.Call = '' THEN
            PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> Link setup ' + y + #13)
          ELSE
            PutData(c, '(' + KS[b]^.Call + ') '  + ' ---> (' +
              KS[KS[b]^.crosschan]^.Call + ') ' + y + #13);
        END;
        100:PutData(c, 'CONVERS (login) ---> (' + KS[b]^.Call + ') '  + #13);
        101:PutData(c, 'CONVERS-Link  ---> (' + KS[b]^.Call + ') '  + #13);
      END;
  END;
END;

PROCEDURE Boot(Kalt: Boolean);
BEGIN
   {$IFNDEF linux}
  INLINE($B8 / $40 / $00
    / $8E / $D8
    / $80 / $7E / $04 / $00
    / $75 / $05
    / $B8 / $34 / $12
    / $EB / $03
    / $B8 / $7F / $7F
    / $A3 / $72 / $00
    / $EA / $00 / $00 / $FF / $FF);
   {$ENDIF}
END;


PROCEDURE reboot(c: byte; s: STRING);
VAR b:byte;
BEGIN
  IF pos('!',s)=0 THEN
    delay(5000) ;
  boot(true);
END;

PROCEDURE SName(c: byte; s: STRING);
VAR b:byte;s1:STRING[20];U:TTermUserRec;
BEGIN
  U.CALL:=cutssid(KS[c]^.Call);
  IF s <> '' THEN
  BEGIN
    IF ((KS[c]^.FLAGS AND KS_sysop)<>0) AND (pos(' ', s) > 0) THEN
    BEGIN
      U.Call:=gross(copy(s, 1, pos(' ', s) - 1));
      GetTermUser(u);
      U.Name:= copy(s, pos(' ', s) + 1, 255);
      SetTermUser(u);
      PutData(c, 'Call: ' + s1 + ' ,Name: ' + copy(s, pos(' ', s) + 1, 255) + #13);
      FOR b:=0 TO 255 DO
        IF KS[b]<>NIL THEN
        IF cutssid(KS[b]^.Call) = s1 THEN KS[b]^.name:=copy(s, pos(' ', s) + 1, 255);
    END 
    ELSE
    BEGIN
      GetTermUser(u);
      U.Name:=s;
      SetTermUser(u);
      KS[c]^.name:=s;
      PutData(C, 'Ok ' + s + ' now I know your name' + #13);
    END;
  END 
  ELSE
  BEGIN
    GetTermUser(u);
    PutData(c, 'Hi ' + u.name + '!' + #13);
  END;
END;




PROCEDURE Run(c: byte; s: STRING);
VAR sr:searchrec;swapfile:FILE;st,st2:STRING;
    excode:word;
BEGIN
  {$I+}
  S:=LTRIM(S);
  IF s[0] = #0 THEN
  BEGIN
    IF KS[c]^.status<50 THEN
      PutFile(c,qrvpath+'texte'+PATH_SEP+'runinfo')
    ELSE
       PutFile(c,boxpath+'msg'+PATH_SEP+'runinfo.dl');
    exit;
  END;
  s:=s + ' ';
  WHILE Pos('|', s) > 0 DO delete(s, Pos('|', s), 1);
  WHILE Pos('>', s) > 0 DO delete(s, Pos('>', s), 1);
  WHILE Pos('<', s) > 0 DO delete(s, Pos('<', s), 1);
  str(c, st);
  SR.Name:=Copy(s, 1, pos(' ', s) - 1) + '.*';
  Findfirst(runpath + sr.name, anyfile, sr);
  IF KS[c]^.status<50 THEN
    st:=' /C ' + RunPath + sr.name + ' ' + Copy(s, Pos(' ', s) + 1, length(s)) + ' >' +
      temppath + 'temp' + st + '.MCT'
  ELSE
    st:=' /C ' + boxpath +'run'+ PATH_SEP+ sr.name + ' ' + Copy(s, Pos(' ', s) + 1, length(s)) + ' >' +
      temppath + 'temp' + st + '.MCT';

  IF ((Pos('.EXE', sr.name) > 0) OR (Pos('.COM', sr.name) > 0) AND (Doserror = 0)) THEN
  BEGIN
    clrscr;
{$IFNDEF Linux}
    SetMemTop(HeapPtr);
    swapvectors;
{$ENDIF}
{$IFDEF linux}
{     exec(sr.name+sr.ext,s);}
{$ELSE}   
    dos.EXEC(GetEnv('COMSPEC'), st);
{$ENDIF}
     {$IFNDEF linux}
     swapvectors;
    SetMemTop(HeapEnd);
{$ENDIF}
    assigncrt(output);rewrite(output);
    RedrawScreen;
    str(c, st);
    putfile(c, temppath + 'temp' + st + '.MCT');
  END
  ELSE PutData(c, 'Program not found' + #13);
  IF KS[c]^.status<50 THEN;
  {$I-}
END;




PROCEDURE DosFileName(VAR filename: STRING);
VAR b:byte;
BEGIN
  FOR b:=1 TO length(filename) DO
  BEGIN
    IF NOT(filename[b] IN ['a'..'z', 'A'..'Z', '0'..'9', '_', #33..#41, #45]) THEN
      filename[b]:='_';
    {$IFNDEF linux}
     IF length(filename) > 11 THEN filename:=copy(filename, 1, 11);
     {$ENDIF}
  END;
   {$IFNDEF linux}
  WHILE pos('_', FILENAME) > 0 DO delete(filename, pos('_', filename), 1);
  IF filename[0] > #8 THEN insert('.', filename, 9);
   {$ENDIF}
END;





PROCEDURE Users(c: byte; Acall: STRING);
VAR U:TTermUserRec;
BEGIN
  U.call:=Acall;
  IF NOT GetTermUser(u) THEN
  BEGIN
    PutData(c,'No information about '+u.call+#13);
    exit;
  END;
  PutData(c,'Informations about '+u.call+':'+#13);
  PutData(c,'Name.............:'+u.name+#13);
  PutData(c,'Digi.............:'+u.einstieg+#13);
  PutData(c,'Network..........:'+u.netzwerk+#13);
  PutData(c,'Password.........:');
  IF (U.BayPassWord<>'') OR (U.FlexPassWord>0) THEN
   PutData(c,' YES '+#13) ELSE PutData(c,' NO'+#13);
  PutData(c,'Directories......:');
  IF (U.CALL=CutSSID(KS[c]^.call)) OR ((KS[c]^.FLAGS AND KS_SYSOP)<>0) THEN
    PutData(c,u.directory+#13)
  ELSE
    IF (U.directory='') THEN PutData(c,' NO'+#13) ELSE PutData(c,' YES'+#13);
END;

FUNCTION cl(B:BYTE):STRING;
BEGIN
  cl:='';
  CASE b OF
     1	: cl:='QUIT';
     11	: cl:='RING';
     3	: cl:='ECHO';
     4	: cl:='RTT';
     5	: cl:='INFO';
     6	: cl:='CSTATUS';
     7	: cl:='USER';
     8	: cl:='HELP';
     9	: cl:='SYSOP';
     10	: cl:='DIR';
     2	: cl:='READ';
     12	: cl:='WRITE';
     13	: cl:='RPRG';
     14	: cl:='WPRG';
     15	: cl:='NAME';
     16	: cl:='MHEARD';
     17	: cl:='RUN';
     18	: cl:='BOX';
     19	: cl:='DOS';
     20	: cl:='NODE';
     21	: cl:='CONNECT';
     22	: cl:='VERSION';
     23	: cl:='TIME';
     24	: cl:='XRUN';
     25	: cl:='REBOOT';
     26	: cl:='TNC';
     27	: cl:='FORCE';
     28	: cl:='CONVERS';
     29	: cl:='BOX';
     30	: cl:='KILL';
     31	: cl:='COMPRESS';
     32	: cl:='CDIR';
    33	: cl:='LHEARD';
  ELSE cl:='';
  END;
END;

FUNCTION HasPermission(CHAN,COMM:BYTE):BOOLEAN;
BEGIN
  HasPermission:=FALSE;
  CASE COMM OF
     1	 : IF (KS[chan]^.REMOTES AND RM1_QUIT)<>0 THEN
         HasPermission:=TRUE;
     11	 : IF (KS[chan]^.REMOTES AND RM1_RING)<>0 THEN
         HasPermission:=TRUE;
     3	 : IF (KS[chan]^.REMOTES AND RM1_ECHO)<>0 THEN
         HasPermission:=TRUE;
     4	 : IF (KS[chan]^.REMOTES AND RM1_RTT)<>0 THEN
         HasPermission:=TRUE;
     5	 : IF (KS[chan]^.REMOTES AND RM1_INFO)<>0 THEN
         HasPermission:=TRUE;
     6	 : IF (KS[chan]^.REMOTES AND RM1_CS)<>0 THEN
         HasPermission:=TRUE;
     7	 : IF (KS[chan]^.REMOTES AND RM1_USER)<>0 THEN
         HasPermission:=TRUE;
     8	 : IF (KS[chan]^.REMOTES AND RM1_HELP)<>0 THEN
         HasPermission:=TRUE;
     9	 : IF (KS[chan]^.REMOTES AND RM1_SYSOP)<>0 THEN
         HasPermission:=TRUE;
     10	 : IF (KS[chan]^.REMOTES AND RM1_DIR)<>0 THEN
         HasPermission:=TRUE;
     2	 : IF (KS[chan]^.REMOTES AND RM1_READ)<>0 THEN
         HasPermission:=TRUE;
     12	 : IF (KS[chan]^.REMOTES AND RM1_WRITE)<>0 THEN
         HasPermission:=TRUE;
     13	 : IF (KS[chan]^.REMOTES AND RM1_RPRG)<>0 THEN
         HasPermission:=TRUE;
     14	 : IF (KS[chan]^.REMOTES AND RM1_WPRG)<>0 THEN
         HasPermission:=TRUE;
     15	 : IF (KS[chan]^.REMOTES AND RM1_NAME)<>0 THEN
         HasPermission:=TRUE;
     {16 : IF (KS[chan]^.REMOTES AND RM1_MH)<>0 THEN
         HasPermission:=TRUE;
}
     17	 : IF (KS[chan]^.REMOTES AND RM1_RUN)<>0 THEN
         HasPermission:=TRUE;
     18	 : IF (KS[chan]^.REMOTES AND RM1_BOX)<>0 THEN
         HasPermission:=TRUE;
     19	 : IF ((KS[chan]^.REMOTES AND RM1_DOS)<>0) AND 
           ((KS[chan]^.FLAGS AND KS_SYSOP)<>0) THEN
         HasPermission:=TRUE;
     20	 : IF (KS[chan]^.REMOTES AND RM1_NODE)<>0 THEN
         HasPermission:=TRUE;
     21	 : IF (KS[chan]^.REMOTES AND RM1_CONNECT)<>0 THEN
         HasPermission:=TRUE;
     22	 : IF (KS[chan]^.REMOTES AND RM1_VERSION)<>0 THEN
         HasPermission:=TRUE;
     23	 : IF (KS[chan]^.REMOTES AND RM1_TIME)<>0 THEN
         HasPermission:=TRUE;
     24	 : IF (KS[chan]^.REMOTES AND RM1_XRUN)<>0 THEN
         HasPermission:=TRUE;
     25	 : IF ((KS[chan]^.REMOTES AND RM1_REBOOT)<>0) AND
            ((KS[chan]^.FLAGS AND KS_SYSOP)<>0) THEN
         HasPermission:=TRUE;
     26	 : IF ((KS[chan]^.REMOTES AND RM1_TNC)<>0) AND
        ((KS[chan]^.FLAGS AND KS_SYSOP)<>0) THEN
         HasPermission:=TRUE;
     27	 : IF ((KS[chan]^.REMOTES AND RM1_FORCE)<>0) AND
            ((KS[chan]^.FLAGS AND KS_SYSOP)<>0) THEN
         HasPermission:=TRUE;
     28	 : IF (KS[chan]^.REMOTES AND RM1_CONVERS)<>0 THEN
         HasPermission:=TRUE;
     29	 : IF (KS[chan]^.REMOTES AND RM1_BOX)<>0 THEN
         HasPermission:=TRUE;
     30	 : IF ((KS[chan]^.REMOTES AND RM1_KILL)<>0) AND 
          ((KS[chan]^.FLAGS AND KS_SYSOP)<>0) THEN
         HasPermission:=TRUE;
     31	 : IF (KS[chan]^.REMOTES AND RM1_COMPRESS)<>0 THEN
         HasPermission:=TRUE;
     32	 : IF (KS[chan]^.REMOTES AND RM1_WRITE)<>0 THEN
         HasPermission:=TRUE;
     16	 : HasPermission:=TRUE;
    33	 : HasPermission:=TRUE;
  END;
  IF (KS[chan]^.FLAGS AND KS_BBS)<>0 THEN 
    IF (comm<>31) AND (comm<>22) THEN
       HasPermission:=FALSE;
END;

FUNCTION Which_RemCommand(VAR S:string):BYTE;
VAR B:BYTE;S2:STRING20;
BEGIN
  Which_RemCommand:=0;
  B:=0;
  S:=LTRIM(S);
  S:=RTRIM(S);
  IF S='' THEN  exit;
  FIND(S,' ',S,ein_s);
  S:=GROSS(S);
  REPEAT
    INC(b);
    S2:=COPY(cl(b),1,LENGTH(s));
    IF S=S2 THEN
    BEGIN
      Which_RemCommand:=B;
      S:=ein_s;
      exit;
    END;
  UNTIL S2[0]=#0;
END;



PROCEDURE Bell(c: byte; s: STRING);
BEGIN
  PutData(c, 'MCUT bellt: WAU WAU!!'#13);
END;

PROCEDURE RemAutoRec(c:BYTE;s:STRING);
VAR s2:STRING[20];
BEGIN
   IF NOT PARSE(c,s,' WPRG <file1> [file_to_read]',s,s2) THEN EXIT;
   KS[c]^.LastStatus:=KS[c]^.Status;
   IF KS[c]^.AutoBinData=NIL THEN
   new(KS[c]^.AutoBinData);
   KS[c]^.AutoBinData^.filename:=s;
   KS[c]^.Status:=13;
   PutData(c,'Waiting for Autobin-Header'+#13);
   IF s2<>'' THEN
     s2:='//rprg '+s2+#13;
END;


PROCEDURE RemAutoSend(c:BYTE;s:STRING);
VAR s2,st1,st2:STRING[20];SR:SEARCHREC;
err:LONGINT;
BEGIN
  IF NOT PARSE(c,s,' RPRG <file1> [file_to_read]',s,s2) THEN EXIT;
  findfirst(s,anyfile,sr);
  err:=doserror;
  IF (err=0) AND (channel<>0) AND ((sr.attr AND $10)=0) THEN
  BEGIN
    IF KS[c]^.AutobinData=NIL Then
    New(KS[c]^.AutoBinData);
    KS[c]^.AutoBinData^.CRC:=makeCRC(s);
    str(KS[c]^.AutoBinData^.CRC,st1);
    str(sr.size,st2);
    IF s2<>'' THEN
      PutData(c,'//WPRG '+s2+#13);
    PutData(c,'#BIN#'+st2+'#|'+st1+'#'+s+#13);
    WITH KS[c]^ DO
    BEGIN
      LastStatus:=Status;
      Status:=15;
      IF find(s,PATH_SEP,L,R) THEN
        KS[c]^.FileName:=R
      ELSE
        KS[c]^.FileName:=s;
      WITH AutoBinData^  DO
      BEGIN
        filename:=s;
        received:=0;
        expected:=sr.size;
      END;
    END;
  END;
  IF err>0 THEN
  BEGIN
    PutData(c,'File does not exist'+#13);
  END;
END;

PROCEDURE sendtime(c:BYTE;s:STRING);
VAR l:LONGINT;
BEGIN
  L:=Unix2Pack(currixtime);
  PutData(c,DTTimeStr(L)+' - '+DTDateStr(l)+#13);
END;

TYPE  str3=string[3];
CONST mon:ARRAY[1..12] OF STR3=
      ('jan','feb','mar','apr','may','jun',
       'jul','aug','sep','oct','nov','dec');

PROCEDURE RemDir(C:BYTE;s:STRING);
VAR name:namestr;ext:extstr;adir:dirstr;diesjahr,w:word;
    sr:searchrec;dt:datetime;s2:STRING[10];col:byte;
    anz:word;size:longint;
BEGIN
  dos.getDate(diesjahr,w,w,w);
  KS[c]^.LastStatus:=KS[c]^.Status;
  IF s[0]=#0 THEN
  BEGIN
    {$IFDEF linux}
     S:='*';
     {$ELSE}
    S:='*.*';
     {$ENDIF}
  END;
  fsplit(s,adir,name,ext);
  IF name='' THEN name:='*';
{$IFNDEF linux}
   IF ext='' THEN ext:='.*';
{$ENDIF}   
  IF (KS[c]^.FLAGS AND KS_SYSOP)=0 THEN
    s:=KS[c]^.rempath+name+ext
    ELSE
    BEGIN
      if (adir='') OR ((adir[1]<>PATH_SEP) AND (adir[2]<>':') AND (adir<>'')) THEN
      BEGIN
        adir:=KS[c]^.rempath+ adir;
        IF adir[length(adir)]<>PATH_SEP THEN
          addchar(adir,PATH_SEP);
      END;
      s:=adir+name+ext;
    END;
  Findfirst(s,anyfile,sr);
  PutData(c,'Directory of '+s+#13);
  col:=1;
  anz:=0;size:=0;
  WHILE DosError=0 DO
  BEGIN
    inc(anz);
    size:=size+sr.size;
    PutData(c,fills(sr.name,14));
    IF (sr.attr AND directory)<>0 THEN
      PutData(c,' <DIR> ')
    ELSE
    BEGIN
      str(round(sr.size/1024),adir);
      PutData(c,fills(' '+adir+'k',7));
    END;
    PutData(c,copy(dtdatestr(sr.time),1,6));
    unpacktime(sr.time,dt);
    IF dt.year=diesjahr THEN
      PutData(c,' '+copy(dttimestr(sr.time),1,5)+'  ')
    ELSE
      PutData(c,copy(dtdatestr(sr.time),7,4)+'    ');
    IF col=2 THEN
    BEGIN
      PutData(c,#13+'');
      col:=1
    END ELSE inc(col);
    Findnext(sr);
  END;
  PutData(c,''#13);
  fsplit(s,adir,name,ext);
  IF anz>0 THEN
  BEGIN
    str(anz,name);
    str(size div 1024,adir);
    PutData(c,name+' Files, '+adir+' KBytes, ');
  END ELSE
  PutData(c,'No File or Directory "'+name+ext+'"'+#13);
  IF (s[2]=':') THEN
  BEGIN
    {$I-}
    size:=diskfree(ord(upcase(s[1]))-64);
    {$I+}
    IF IOresult<>0 THEN size:=0;
  END ELSE
  BEGIN
    {$I-}
    size:=diskfree(0);
    {$I+}
    IF IOresult<>0 THEN size:=0;
  END;
  str(size DIv 1024,adir);
  PutData(c,adir+' KBytes free'+#13);
END;

PROCEDURE remDos(c:BYTE;s:STRING);
VAR a:STRING[3];
BEGIN
{$IFNDEF linux}
  clrscr;

  IF NOT dosswap   THEN
  BEGIN
    SetMemTop(HeapPtr);
    swapvectors;
  END;
  str(c,a);
  IF dosswap THEN
    (*
    do_EXEC(GetEnv('COMSPEC'),'/C '+s+' > '+qrvpath+'temp'+a+'.MCT',USE_FILE,$FFFF,false)
    *)
  ELSE
  BEGIN
    dos.EXEC(GetEnv('COMSPEC'),'/C '+s+' > '+qrvpath+'temp'+a+'.MCT');
    swapvectors;
    SetMemTop(HeapEnd);
  END;
  AssignCrt(output);rewrite(output);
  {$IFDEF TERM}
  ReDrawScreen;
  {$ENDIF}
  putfile(c,qrvpath+'temp'+a+'.MCT');
{$ENDIF}
END;

PROCEDURE ShowVariables(c:BYTE);
VAR B:BYTE; s:STRING10;
    ti:LONGINT;
BEGIN
  PutData(c,'Stream Status Create  RxKBy   TxKBy    RxW    TxW   Call'+#13);
  FOR B:=0 to 255 DO
    IF KS[b]<>NIL THEN
    BEGIN
      {$IFDEF FPK}
      str(b,s);
      while length(s)<5 do s:=' '+s;
      {$ELSE}
      str(b:5,s);
      {$ENDIF}
      PutData(c,s+'  ');
      {$IFDEF FPK}
      str(KS[b]^.Status,s);
      while length(s)<5 do s:=' '+s;
      {$ELSE}
      str(KS[b]^.status:5,s);
      {$ENDIF}
      PutData(c,s+'  ');
      ti:=CurrIxTime-KS[b]^.Create;
      IF ti<100 THEN
      BEGIN
	{$IFDEF FPK}
	str(ti,s);
	while length(s)<3 do s:=' '+s;
	{$ELSE}
	str(ti:3,s);
	{$ENDIF}
        s:=s+'s';
      END ELSE
        IF (Round(ti/60)<100) THEN
        BEGIN
	  {$IFDEF FPK}
	  str(round(ti/60),s);
	  while length(s)<3 do s:=' '+s;
	  {$ELSE}
	  str(round(ti/60):3,s);
	  {$ENDIF}
          s:=s+'m';
        END ELSE
          IF (Round(ti/3600)<100) THEN
          BEGIN
	    {$IFDEF FPK}
	    str(round(ti/3600),s);
	    while length(s)<3 do s:=' '+s;
	    {$ELSE}
	    str(round(ti/3600):3,s);
	    {$ENDIF}
	    s:=s+'h';
          END ELSE
          BEGIN
	    {$IFDEF FPK}
	    str(round(ti/86400),s);
	    while length(s)<3 do s:=' '+s;
	    {$ELSE}
	    str(round(ti/86400):3,s);
	    {$ENDIF}
	    s:=s+'d';
          END;
      PutData(c,s+'   ');
      {$IFDEF FPK}
      str(ROUND(KS[b]^.RxBy/1024),s);
      while length(s)<6 do s:=' '+s;
      {$ELSE}
      str(ROUND(KS[b]^.RxBy/1024):6,s);
      {$ENDIF}		
      PutData(c,s+'  ');
      {$IFDEF FPK}
      str(ROUND(KS[b]^.TxBy/1024),s);
      while length(s)<6 do s:=' '+s;
      {$ELSE}
      str(ROUND(KS[b]^.TxBy/1024):6,s);
      {$ENDIF}		
      PutData(c,s+'  ');
      {$IFDEF FPK}
      str(KS[b]^.RxW,s);
      while length(s)<5 do s:=' '+s;
      {$ELSE}
      str(KS[b]^.RxW:5,s);
      {$ENDIF}		
      PutData(c,s+'  ');
      {$IFDEF FPK}
      str(KS[b]^.TxW,s);
      while length(s)<5 do s:=' '+s;
      {$ELSE}
      str(KS[b]^.TxW:5,s);
      {$ENDIF}
      PutData(c,s+'  ');
      PutData(c,KS[b]^.Call+#13);
    END;
END;




PROCEDURE sendVersion(c:BYTE;s:STRING);
BEGIN
    PutData(c,'MCUT Version '+version);
       {$IFDEF OVR}
         PutData(c,'OVR');
  {$ENDIF}
      PutData(c,''+#13);
      PutData(c,'Copyright 1993-1997 DG4IAD and DG6VJ'+#13);
      PutData(c,'compiled '+compiled+#13);
      PutData(c,'Distributed under the GNU Public Licence'+#13);
      PutData(c,'PR-Interface:');
      IF device=0 THEN
      BEGIN
        {$IFDEF WA8DED}
        PutData(c,'WA8DED (');
        str(tncchan,ein_s);
        PutData(c,ein_s+' channels');
        IF xhost THEN
          PutData(c,'/'+'XHOST');
        PutData(c,')'+#13);
        IF TNC_AN THEN
          putdata(c,'('+sendcmd(0,'v')+')'+#13);
        {$ENDIF}
      END ELSE
      IF device=1 THEN
      BEGIN
        {$IFDEF FLEXNET}
        PutData(c,'PC/FlexNet '+l2_pversion);
        IF flextype=1 THEN PutData(c,' mini'+#13) ELSE
          PutData(c,' digi'+#13);
        {$ENDIF}
      END ELSE
        PutData(c,'unknown'+#13);
      IF Pos('P',Gross(s))>0 THEN ShowVariables(c);
      IF Pos('X',Gross(s))>0 THEN BEGIN
        PutData(c,'this version includes following modules:'+#13);

        PutData(c,'Kernel                (DG4IAD)'+#13);
        {$IFDEF TERM}                        {DG4IAD}
         PutData(c,'Terminal/Console     (DG4IAD)'+#13);
        {$ENDIF}
        {$IFDEF WA8DED}                   
        PutData(c,'TNC/TFPC* Interface   (DG4IAD/DG6VJ)'+#13);
        {$ENDIF}
        {$IFDEF BOX}                         
        PutData(c,'Mailbox               (DG6VJ)'+#13);
        {$ENDIF}
        {$IFDEF CONVERS}                     {DG6VJ}
         PutData(c,'Convers               (DG6VJ)'+#13);
        {$ENDIF}
        {$IFDEF FLEXNET}
         PutData(c,'PC/FlexNet Interface  (DG4IAD/DG9FDL)'+#13);
        {$ENDIF}
        {$IFDEF BCRX}
         PutData(c,'PACSAT-Broadcast RX   (DG4IAD)'+#13);
        {$ENDIF}
        {$IFDEF HELP}
         PutData(c,'Online Help          (DG4MMI)'+#13);
        {$ENDIF}
        str(memavail,s);
        PutData(c,'Coreleft: '+s);
        PutData(c,' , running since: '+DTDateStr(Unix2Pack(starttime))+' '+DTTimeStr(Unix2Pack(starttime))+#13);
        Str(Through_RX,s);
        PutData(c,'avar. throughput (last 10s) : '+s+' Byte/s (RX), ');
        Str(Through_TX,s);
        PutData(c,s+' Byte/s (TX)'+#13);
        str(SysLoad,s);
        PutData(c,'System Load: '+s+' Percent');
        str(last_rnds,s);
        PutData(c,', rps: '+s+#13);
  END;
END;


PROCEDURE MH(c:BYTE;S:STRING);
VAR W:WORD;P:PMHentry;
{s:STRING;}
BEGIN
  FOR W:=0 to 255 DO
  BEGIN
    IF mhliste[w]<>NIL THEN
    BEGIN
     p:=MHLISTE[W];
     WHILE p<>NIL DO
     WITH p^ do
     BEGIN
       str(p^.port,s); putdata(c,s+':');
       PutData(c,p^.src+' '+p^.dest+' ');
       if REJ>0 THEN
       BEGIN 
         str(rej,s);
         Putdata(c,'rej:'+s+' ');
       END;  
       if RR>0 THEN
       BEGIN 
         str(rr,s);
         Putdata(c,'rr:'+s+' ');
       END;  
       if I>0 THEN
       BEGIN 
         str(I,s);
         Putdata(c,'I:'+s+' ');
       END;  
       if text>0 THEN
       BEGIN 
         str(text,s);
         Putdata(c,'text:'+s+' ');
       END;  
       if tcpip>0 THEN
       BEGIN 
         str(tcpip,s);
         Putdata(c,'tcpip:'+s+' ');
       END;  
       if netrom>0 THEN
       BEGIN 
         str(netrom,s);
         Putdata(c,'netrom:'+s+' ');
       END;  
       if flexnet>0 THEN
       BEGIN 
         str(flexnet,s);
         Putdata(c,'flexnet:'+s+' ');
       END;  
       if unknown>0 THEN
       BEGIN 
         str(unknown,s);
         Putdata(c,'unknown:'+s+' ');
       END;  
       
       if pacsat>0 THEN
       BEGIN 
         str(pacsat,s);
         Putdata(c,'pacsat:'+s+' ');
       END;  
       if tkby>0 THEN
       BEGIN 
         str(tkby/1024,s);
         Putdata(c,'tkby:'+s+' ');
       END;  
       PutData(c,DTdateStr(unix2pack(p^.last))+' '+DTTimeStr(unix2pack(p^.last))+#13);
       p:=p^.next;
     END;   
    END;
  END;
END;        
        


PROCEDURE RTT(c:BYTE;s:STRING);
VAR l:LONGINT;err:INTEGER;
BEGIN
  IF s[0]=#0 THEN
  BEGIN
    str(Currixtime,s);
    PutData(c,'//e //RT '+s+#13);
  END ELSE
  BEGIN
    val(s,l,err);
    IF err>0 THEN exit;
    str(round(currixtime-l),s);
    PutData(c,'RTT '+mycall+' -> '+KS[c]^.Call+' -> '+mycall+': '+s+' Sec'#13);
  END;
END; { RTT }
PROCEDURE kill(c:BYTE;s:STRING);
VAR l:LONGINT;err:INTEGER;
BEGIN
  
END; { kill }

  
PROCEDURE LastHeard(c:BYTE;s:STRING);
var err:integer;c2:BYTE;s1:STRING;
  count,c3:BYTE;
  y,d,m,h,min,sec,wod:byte;
BEGIN
  {$IFDEF BB}
  c3:=0;
  count:=0;
  c2:=bbentrypos;
  while (count<20) AND (c3<100) do
  BEGIN
    inc(c3);
     IF ((S='') AND ( bbarr[c2].call<>'')) OR
       ((S<>'') AND (S=bbarr[c2].call)) THEN
     with bbarr[c2] do
     BEGIN
       inc(count);
       putdata(c,call+' ');
       str(starth,s1);
       decode_ixtime(starttime,y,m,d,h,min,sec);
       putdata(c,makeTimeStr(h,min,sec)+'.'+s1+' - ');
       decode_ixtime(stoptime,y,m,d,h,min,sec);
       str(stoph,s1);
       putdata(c,makeTimeStr(h,min,sec)+'.'+s1);
       str(txd,s1);
       putdata(c,' txd:'+s1+#13); 
     END;
      IF c2=0 then c2:=100 ELSE
      dec(c2);
   END;
  {$ENDIF}
END;

PROCEDURE Force(c:BYTE;var s:STRING);
var bch:BYTE;
BEGIN
    WHILE(s[1]=' ') AND (s[0]>#0) DO s:=copy(s,2,length(s));
    val(copy(s,1,Pos(' ',s)-1),bch,err);
    IF (err>0) THEN
    BEGIN
      PutData(c,'Falsche Kanalnummer'#13);
      GiveP(c);
      exit
    END;
    IF gross(copy(s,pos(' ',s)+1,5))='FORCE' THEN
    BEGIN
      PutData(c,'Cannot force force'+#13);
      GiveP(c);
      exit;
    END;
    handle(bch,copy(s,pos(' ',s)+1,length(s)));
    PutData(c,'Forced'+#13);
  GiveP(c);
END;


PROCEDURE handleNcmd(s: STRING; ch: byte);
VAR hlp,passw:STRING[5];y:longint;w:word;
    b:byte;
    comm:WORD;
BEGIN
  IF KS[ch]=NIL THEN exit;
  IF (KS[ch]^.FLAGS AND KS_INACTIVE)<>0 THEN exit;
  IF (KS[ch]^.FLAGS AND KS_REMOTE)=0 THEN
  BEGIN
    IF (KS[ch]^.FLAGS AND KS_BBS)=0 THEN
    BEGIN
      PutData(ch,'Remote access disabled'+#13);
    END;
    exit;
  END;
  IF S[length(s)] IN [#13,#10] THEN DEC(BYTE(S[0]));
  COMM:=Which_RemCommand(s);
  IF not hasPermission(ch,comm) THEN comm:=0;
  CASE comm OF
    1	 : begin
       quit(ch);
       exit;
      END;
    5	 : 
    BEGIN
      IF KS[ch]^.Status = 7 THEN
        SendTermMacroFile(ch,textpath+'info')
      ELSE
        SendTermMacroFile(ch,textpath+'ninfo');
    END;
    11	 : ring(ch);
    16	 : MH(ch,s);
    2	 : rtext(ch, s);
    {$IFDEF CONVERS}
    28	 : startconv(ch ,s);
    {$ENDIF}
    10	 : remdir(ch, s);
    3	 : BEGIN
        IF (KS[ch]^.FLAGS and KS_BBS)=0 THEN
          IF GROSS(COPY(LTRIM(s),1,1))<>'S' THEN
            PutData(ch, s + #13);
        EXIT;
      END;
    7	 : users(ch, s);
    6	 : cs(ch);
    8	 : SendTermMacroFile(ch,textpath+'HELP');
    9	 : Pass(ch, s);
    30	 : Kill(ch, s);
    26	 : TNCcommand(ch, s);
    12	 : Wtext(ch, s);
    15	 : SName(ch, s);
    27	 : force(ch, s);
    17	 : run(ch, s);
    {$IFDEF BOX}
    18	 : 
      BEGIN
        PutData(ch, '*** link setup' + #13 + '*** connected to ' + boxcall + #13);
        KS[ch]^.Laststatus:=KS[ch]^.status;
        Box_LogIn(ch);
      END;
    {$ENDIF}
    4	 : RTT(ch, s);
  (*  19:remDos(ch, s);    *)
    13	 : remautosend(ch, s);
    14	 : remAutoRec(ch, s);
    23	 : sendTime(ch, s);
    22	 : sendVersion(ch, s);
    (*25 : reboot(ch, s);*)
    31	 : BEGIN
        IF s='' THEN
        BEGIN
          IF KS[ch]^.compress>0 THEN
            KS[ch]^.compress:=0
          ELSE
          BEGIN
            PutData(ch,'//COMP 1'+#13);
            KS[ch]^.Compress:=1;
          END;
        END ELSE
        IF (gross(s)='ON') THEN
        BEGIN
          PutData(ch,'//COMP 1'+#13);
          KS[ch]^.Compress:=1;
        END
        ELSE
        IF S='1' THEN
          KS[ch]^.compress:=2
        ELSE
        IF (gross(s)='OFF') THEN
        BEGIN
          PutData(ch,'//COMP 0'+#13);
          KS[ch]^.compress:=0;
        END
        ELSE
        IF S='0' THEN
           KS[ch]^.compress:=0;
        exit;
       END;
    32	 : changedir(ch,s);
    33	 : LastHeard(ch,s);
    ELSE
      IF (KS[ch]^.FLAGS AND KS_BBS) = 0 THEN
      BEGIN
        PutData(ch, 'invalid command' + #13);
      END;
    END;
 IF (KS[ch]^.Status=7) AND ((KS[ch]^.FLAGS AND KS_BBS)=0) THEN
   GiveP(ch);
END;


END.



























