(****************************************************************************)
(* Status speichern/wiederherstellen.                                       *)
(* Als Overlay deklarieren!                                                 *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(****************************************************************************)


UNIT Restore;

INTERFACE

USES IADVAR;

PROCEDURE WriteState;
PROCEDURE ReadState;


IMPLEMENTATION

USES
   {$IFDEF WA8DED} TNC, {$ENDIF}
   ToolBox,MCUTBuf,TERMUSER;

CONST
   BufFileID:STRING[20]='MCBUF-006'+#26;
   StateFileID:STRING[20]='MCSTATE-002'+#26;

{$I-}

PROCEDURE WriteBuf;
VAR f:FILE;
    S:STRING;
    L:LONGINT;
    B,B2:BYTE;

BEGIN
  IF NOT SaveBuffers THEN EXIT;
   ASSIGN(f,qrvpath+'buf.mct');
  REWRITE(f,1);
  IF IORESULT<>0 THEN
    exit;
  (*
   * FileID
   *)
  BlockWrite(f,BufFileId[0],length(BufFileID)+1);
  (*
   * Zeit
   *)
  L:=currixtime;
  BlockWrite(f,l,4);
  (*
   * Anzahl der Terminals
   *)
  BlockWrite(f,allocchans,1);
  FOR B:=1 TO Allocchans DO
  BEGIN
    BlockWrite(f,b,1);
    BlockWrite(f,mcall[b]^[0],11);
    BlockWrite(f,Vorschreib[b]^,SizeOF(TVorschreib));
    QSOBuf[b]^.Store(f);
  END;
  CLOSE(F);
END;

PROCEDURE ReadBuf;
VAR f:FILE;
    S:STRING;
    L:LONGINT;
    B,B2,anzahl:BYTE;
    W:WORD;
BEGIN
  IF NOT SaveBuffers THEN exit;
   ASSIGN(f,qrvpath+'buf.mct');
  RESET(f,1);
  IF IORESULT<>0 THEN
    exit;
  (*
   * FileID
   *)
  BlockRead(f,S[0],length(BufFileID)+1);
  IF s<>BufFileId THEN
  BEGIN
    CLOSE(f);
    exit;
  END;
  (*
   * Zeit
   *)
  BlockRead(f,l,4);
  (*
   * Anzahl der Terminals
   *)
  BlockRead(f,anzahl,1);
  FOR B:=1 TO Anzahl DO
  IF B<=AllocChans THEN
  BEGIN
    BlockRead(f,b2,1);
    IF b2=b THEN
    BEGIN
      BlockRead(f,s[0],11);
      (* IF MCALL[b]<>NIL THEN MCall[b]^:=s; *)
      BlockRead(f,Vorschreib[b]^,SizeOF(TVorschreib));
      QSOBuf[b]^.Load(f);
      IF BufError<>0 THEN
      BEGIN
        CLOSE(F);Exit;
      END;
    END
  END;
  IF IORESULT<>0 THEN;
  CLOSE(F);
END;


PROCEDURE WriteState;
VAR f:FILE;
    S:STRING;
    L:LONGINT;
    B,B2:BYTE;

BEGIN
  WriteBuf;
  IF device<>0 THEN Exit;
  {$IFDEF WA8DED}
   ASSIGN(f,qrvpath+'state.mct');
  REWRITE(f,1);
  IF IORESULT<>0 THEN
    exit;
  (*
   * FileID
   *)
  BlockWrite(f,StateFileId[0],length(StateFileID)+1);
  (*
   * Zeit
   *)
  L:=currixtime;
  BlockWrite(f,l,4);
  FOR B:=1 TO TNCChan DO
  IF (KS[b]<>NIL) AND (KS[b]^.Loop=0) THEN
  BEGIN
    BlockWrite(f,b,1);
    S:=SendCMD(b,'C');
    BlockWrite(f,s[0],30);
    BlockWrite(f,KS[b]^.Call,12);
    BlockWrite(f,KS[b]^.path,256);
    L:=(KS[b]^.Flags AND (NOT (KS_7PSAVE + KS_CRONTASK)) OR (KS_SHOWDATA+KS_LINEMODE));
    BlockWrite(f,l,4);
    BlockWrite(f,KS[b]^.typ,1);
    BlockWrite(f,KS[b]^.Compress,1);
    BlockWrite(f,KS[b]^.Create,4);
    BlockWrite(f,KS[b]^.Stream,2);
    BlockWrite(f,KS[b]^.Prefix,21);
    BlockWrite(f,KS[b]^.ReceiveRest,256);
  END;
  CLOSE(F);
  {$ENDIF}
END;

PROCEDURE ReadState;
VAR f:FILE;
    S:STRING;
    L:LONGINT;
    B,B2:BYTE;

BEGIN
  ReadBuf;
  IF device<>0 THEN Exit;
  {$IFDEF WA8DED}
   ASSIGN(f,qrvpath+'state.mct');
  RESET(f,1);
  IF IORESULT<>0 THEN
    exit;
  (*
   * FileID
   *)
  BlockRead(f,S[0],length(StateFileID)+1);
  IF S<>StateFileId THEN
  BEGIN
    CLOSE(f);
    exit;
  END;
  (*
   * Zeit
   *)
  BlockRead(f,l,4);
  WHILE NOT EOF(F) DO
  BEGIN
    BlockRead(f,b,1);
    BlockRead(f,s[0],30);
    IF (KS[b]<>NIL) AND (S=SendCMD(b,'C')) THEN
    BEGIN
      BlockRead(f,KS[b]^.Call,12);
      LoadTermUser(b);
      BlockRead(f,KS[b]^.path,256);
      BlockRead(f,KS[b]^.Flags,4);
      BlockRead(f,KS[b]^.typ,1);
      BlockRead(f,KS[b]^.Compress,1);
      BlockRead(f,KS[b]^.Create,4);
      BlockRead(f,KS[b]^.Stream,2);
      BlockRead(f,KS[b]^.Prefix,21);
      BlockRead(f,KS[b]^.ReceiveRest,256);
    END ELSE
      Seek(f,FilePos(f)+12+256+4+1+1+4+2+21+256)
  END;
  CLOSE(F);
  {$ENDIF}
END;


END.