
(****************************************************************************)
(* Primitive Scriptsprache fr MCUT.                                        *)
(* Diese Unit sollte nicht als Overlay deklariert werden                    *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

UNIT SCRIPT;
INTERFACE


PROCEDURE DoneScript(C:BYTE);
PROCEDURE HandleScript(C:BYTE;S:STRING);
PROCEDURE HandleScriptData(C:BYTE;S:STRING);
PROCEDURE WAIT_CMD(C:BYTE;S:STRING);
PROCEDURE SET_CMD(c:BYTE;S:STRING);
PROCEDURE GOTO_CMD(C:BYTE;S:STRING);
PROCEDURE IF_CMD(C:BYTE;S:STRING);
PROCEDURE SLEEP_CMD(C:BYTE;S:STRING);

IMPLEMENTATION

USES MYSTRING,TERM_O,IADVAR,TOOLBOX;


FUNCTION GetVar(c:BYTE;tmp:STRING):STRING;
VAR varp:PVAR;
BEGIN
  GetVar:='';
  varp:=scripts[c]^.vars;
  WHILE varp<>NIL DO
  BEGIN
    IF varp^.ident^=tmp THEN
    BEGIN
      GetVar:=varp^.wert^;
      exit;
    END;
    varp:=varp^.next;
  END;
  varp:=globals;
  WHILE varp<>NIL DO
  BEGIN
    IF varp^.ident^=tmp THEN
    BEGIN
      GetVar:=varp^.wert^;
      exit;
    END;
    varp:=varp^.next;
  END;
END;

PROCEDURE SetVar(c:BYTE;id:STRING;value:STRING);
VAR varp,p:PVAR;
BEGIN
  varp:=scripts[c]^.vars;
  P:=NIL;
  id:=gross(id);
  WHILE varp<>NIL DO
  BEGIN
    IF varp^.ident^=id THEN
    BEGIN
      FreeMem(varp^.wert,length(varp^.wert^)+1);
      IF value='' THEN
      BEGIN
        IF p<>NIL THEN
          p^.next:=varp^.next
        ELSE scripts[c]^.vars:=NIL;
        FreeMem(varp^.ident,length(varp^.ident^)+1);
        Dispose(varp);
        exit;
      END;
      GetMem(varp^.Wert,length(value)+1);
      Varp^.Wert^:=value;
      exit;
    END;
    p:=varp;
    varp:=varp^.next;
  END;
  varp:=globals;
  p:=NIL;
  WHILE varp<>NIL DO
  BEGIN
    IF varp^.ident^=id THEN
    BEGIN
      FreeMem(varp^.wert,length(varp^.wert^)+1);
      IF value='' THEN
      BEGIN
        IF p<>NIL THEN
          p^.next:=varp^.next
        ELSE globals:=NIL;
        FreeMem(varp^.ident,length(varp^.ident^)+1);
        Dispose(varp);
        exit;
      END;
      GetMem(varp^.Wert,length(value)+1);
      Varp^.Wert^:=value;
      exit;
    END;
    p:=varp;
    varp:=varp^.next;
  END;
  IF Value='' THEN exit;
  new(varp);
  varp^.next:=Scripts[c]^.vars;
  Scripts[c]^.vars:=varp;
  GetMem(varp^.ident,length(l)+1);
  Varp^.ident^:=l;
  GetMem(varp^.wert,length(r)+1);
  Varp^.wert^:=r;
END;

PROCEDURE Expand(c:BYTE;VAR S:STRING);
VAR tmp:STRING;A,B,state:BYTE;
BEGIN
  tmp:='';
  state:=0;
  B:=0;
  S:=s+' ';
  WHILE (b<length(s)) DO
  BEGIN
    INC(B);
    IF state=2 THEN
    BEGIN
      if s[b]='"' THEN state:=0;
    END ELSE
    IF state=0 THEN
    BEGIN
      IF S[B]='$' THEN
      BEGIN
        A:=B;
        state:=1;
      END ELSE
      IF S[B]='"' THEN state:=2
    END ELSE
    IF state=1 THEN
    BEGIN
      IF S[b] IN ['a'..'z','A'..'Z','0'..'9','_'] THEN
        tmp:=tmp+upcase(S[B])
      ELSE
      BEGIN
        state:=0;
        Delete(s,a,length(tmp)+1);
        Insert(GetVar(c,tmp),s,a);
        B:=a+length(GetVar(c,tmp))-1;
      END;
    END;
  END;
  DEC(byte(s[0]));
END;


PROCEDURE DoneScript(C:BYTE);
VAR tmp:pvar;b:byte;tmp2:pCallStack;
BEGIN
  With Scripts[c]^ DO
  BEGIN
    FOR b:=1 to size DO
      FreeMem(Programm[b],length(programm[b]^)+1);
    WHILE VARs<>NIL DO
    BEGIN
      tmp:=vars;
      vars:=vars^.next;
      FreeMem(tmp^.ident,length(tmp^.ident^)+1);
      FreeMem(tmp^.wert,length(tmp^.wert^)+1);
      dispose(tmp);
    END;
    WHILE CallStack<>NIL DO
    BEGIN
      tmp2:=CallStack;
      CallStack:=CallStack^.next;
      dispose(tmp2);
    END;
  END;
  DISPOSE(Scripts[c]);
  Scripts[c]:=NIL;
END;

PROCEDURE HandleScript(C:BYTE;S:STRING);
BEGIN
  IF Scripts[c]=NIL THEN exit;
  WITH scripts[c]^ DO
  BEGIN
    CASE status OF
       0:BEGIN
           IF ip>size THEN
           BEGIN
             DoneScript(c);
             exit;
           END;
           s:=Programm[ip]^;
           expand(c,s);
           Interpret_CMD(c,s,1);
           INC(ip);
         END;
       1:BEGIN
           IF currixtime>sleepuntil THEN
             status:=0;
         END;
       2:BEGIN
           IF currixtime>sleepuntil THEN
           BEGIN
              status:=0;
              found:=0;
           END;
         END;
     END;
  END;
END;

PROCEDURE HandleScriptData(C:BYTE;S:STRING);
VAR B:BYTE;
BEGIN
  IF Scripts[c]=NIL THEN exit;
  SetVar(c,'DATA',S);
  WITH scripts[c]^ DO
  BEGIN
    CASE status OF
       2:BEGIN
           FOR B:=1 to anzsuch DO
             IF POS(suchstr[b],s)>0 THEN
             BEGIN
               found:=b;
               status:=0;
               exit;
             END;
         END;
     END;
  END;
END;

PROCEDURE IF_CMD(c:BYTE;S:STRING);
VAR l,r,aktion:STRING;
    parse_state,b:BYTE;
    was_ist_l,was_ist_r:BYTE;
    wert,err:integer;

PROCEDURE ex(VAR S:STRING;VAR was:BYTE);
BEGIN
    IF was=0 THEN
    BEGIN

      Val(s,wert,err);
      IF ERR=0 THEN was:=1
      ELSE
      BEGIN
        s:=rtrim(ltrim(gross(s)));
        was:=1;
        IF s='FOUND' THEN
        BEGIN
          str(scripts[c]^.found,s);
          exit;
        END;
        IF s='CONNECTED' THEN
        BEGIN
          IF KS[c]<>NIL THEN
            s:='1' ELSE s:='0';
          exit;
        END;
        IF s='CALL' THEN
        BEGIN
          IF KS[c]=NIL THEN
            s:=''
          ELSE s:=KS[c]^.Call;
          exit;
        END;
        IF s='STATUS' THEN
        BEGIN
          IF KS[c]=NIL THEN
            s:='0' ELSE str(KS[c]^.status,s);
          exit;
        END;
        was:=0;
      END;
    END;
END;


BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  parse_state:=0;
  l:='';r:='';
  was_ist_l:=0;was_ist_r:=0;
  aktion:='';
  s:=org_str;
  WITH Scripts[c]^ DO
  BEGIN
    FOR B:=1 TO LENGTH(S) DO
    BEGIN
      CASE parse_state OF
        0:BEGIN
            CASE S[b] OF
              '"': BEGIN
                     parse_state:=2;
                     was_ist_l:=1;
                   END;
              'a'..'z','A'..'Z':
                   BEGIN
                     l:=l+S[b];
                   END;
              '=': BEGIN
                     parse_state:=3;
                   END;
               ELSE l:=l+S[b];
             END;
           END;
         1:BEGIN
             IF S[b]='=' THEN
               parse_state:=3;
           END;
         2:BEGIN
             CASE S[b] OF
              '"': BEGIN
                     parse_state:=1;
                     was_ist_l:=1;
                   END;
               ELSE l:=l+S[b]; END;
           END;
         3:BEGIN
             CASE S[b] OF
               '"': BEGIN
                      parse_state:=4;
                      was_ist_r:=1;
                    END;
               'a'..'z','A'..'Z':
                    BEGIN
                      r:=r+S[b];
                    END;
               ' ': BEGIN
                      parse_state:=6;
                    END;
               ELSE r:=r+S[b];
              END;
            END;
         5:BEGIN
             IF S[b]=' ' THEN
               parse_state:=6;
           END;
         4:BEGIN
             CASE S[b] OF
              '"': BEGIN
                     parse_state:=5;
                     was_ist_r:=1;
                   END;
               ELSE l:=l+S[b]; END;
           END;
         6:BEGIN
             aktion:=aktion+s[b];
           END;
      END;
    END;
    IF parse_state<>6 THEN
    BEGIN
      textout(c,'Syntax Error'+#13);
      exit;
    END;
    ex(l,was_ist_l);
    ex(r,was_ist_r);
    IF l=r THEN
    BEGIN
      interpret_cmd(c,aktion,1);
    END;
  END;
END;

PROCEDURE WAIT_CMD(C:BYTE;S:STRING);
VAR B,anz,state:BYTE;tmp,tmp2:STRING;
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  anz:=0;
  tmp:='';state:=0;
  s:=org_str;
  Scripts[c]^.anzsuch:=0;
  state:=0;
  FOR B:=1 TO LENGTH(s) DO
  WITH scripts[c]^ DO
  BEGIN
    CASE state OF
       0:BEGIN
           IF S[b] IN ['0'..'9'] THEN
             tmp:=tmp+s[b] ELSE
           IF s[b]=' ' THEN
           BEGIN
             val(tmp,SleepUntil,err);
             SleepUntil:=CurrIxTime+SleepUntil;
             state:=1;
             tmp:='';
           END ELSE textout(c,'Syntax error'+#13);
         END;
       1:BEGIN
           IF S[b]<>' ' THEN
           BEGIN
             IF S[b]='"' THEN
             BEGIN
               state:=3;
             END ELSE
             BEGIN
               tmp:=tmp+s[b];
               state:=2;
             END;
           END;
         END;
       2:BEGIN
           IF S[b]=' ' THEN
           BEGIN
             if anzsuch<10 THEN
             BEGIN
               inc(anzsuch);
               suchstr[anzsuch]:=tmp;
               tmp:='';
               state:=1;
             END;
           END ELSE tmp:=tmp+s[b];
         END;
       3:BEGIN
           IF S[b]='"' THEN
           BEGIN
             if anzsuch<10 THEN
             BEGIN
               inc(anzsuch);
               suchstr[anzsuch]:=tmp;
               tmp:='';
               state:=1;
             END;
           END ELSE tmp:=tmp+s[b];
         END;
    END;
  END;

  scripts[c]^.status:=2;
END;

PROCEDURE SET_CMD(c:BYTE;S:STRING);
VAR L,R:STRING;varp:pvar;
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  IF NOT FIND(org_str,' ',L,R) THEN
  BEGIN
    TextOut(c,'Syntax Error'+#13);
    exit;
  END;
  l:=Gross(ltrim(rtrim(l)));
  r:=rtrim(r);
  WITH scripts[c]^ DO
  BEGIN
    SetVar(c,l,r);
  END;
END;

PROCEDURE GOTO_CMD(C:BYTE;S:STRING);
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  WITH scripts[c]^ DO
  BEGIN
    VAL(s,ip,err);
    IF err<>0 THEN textout(c,'Syntax Error'+#13);
    dec(ip);
  END;
END;

PROCEDURE SLEEP_CMD(C:BYTE;S:STRING);
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  WITH scripts[c]^ DO
  BEGIN
    VAL(s,sleepuntil,err);
    Sleepuntil:=currixtime+sleepuntil;
    status:=1;
  END;
END;

PROCEDURE SPLIT_CMD(C:BYTE;S:STRING);
VAR L,R:STRING;B:BYTE;id:STRING;
LABEL y;
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  R:=LTRIM(Org_Str);
  B:=1;
  REPEAT
    Str(b,r);
    IF GetVar(c,'S'+r)<>'' THEN
      SetVar(c,'S'+r,'')
    ELSE GOTO y;
    INC(B);
  UNTIL FALSE;
 y:
  B:=1;
  R:=LTRIM(RTRIM(Org_Str));
  WHILE FIND(R,' ',L,R) DO
  BEGIN
    R:=LTRIM(R);
    STR(b,id);
    SetVar(c,'S'+ID,l);
    inc(b);
  END;
  IF r<>'' THEN
  BEGIN
    STR(b,id);
    SetVar(c,'S'+ID,r);
  END;
END;

PROCEDURE GOSUB_CMD(C:BYTE;S:STRING);
VAR g:pCallStack;b:WORD;
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  val(s,b,err);
  IF err<>0 THEN BEGIN
    textout(c,'Syntax Error'+#13);
    exit;
  END;
  new(g);
  with scripts[c]^ do
  begin
    g^.ip:=ip;
    g^.next:=callstack;
    ip:=b
  end;
END;

PROCEDURE RETURN_CMD(C:BYTE;S:STRING);
VAR g:pCallStack;
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  with scripts[c]^ do
  begin
    IF callstack=NIL THEN
    BEGIN
      TextOut(c,'RETURN without GOSUB'+#13);
      exit;
    END;
    g:=callstack;
    callstack:=callstack^.next;
    ip:=g^.ip;
    dispose(g);
  end;
END;

PROCEDURE ON_CMD(C:BYTE;S:STRING);
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;

END;

PROCEDURE READLINE_CMD(C:BYTE;S:STRING);
VAR f:text;filename,line,varname:STRING;a,b:WORD;
BEGIN
  IF Scripts[c]=NIL THEN
  BEGIN
    TextOut(c,'Only in Scripts'+#13);
    exit;
  END;
  IF NOT FIND(s,' ',filename,s) THEN exit;
  IF NOT FIND(ltrim(s),' ',line,varname) THEN exit;
  find(varname,' ',varname,s);
  if varname='' THEN exit;
  val(line,a,err);
  if err<>0 THEN exit;
  ASSIGN(f,filename);
  {$I-}
  RESET(f);
  IF IORESULT<>0 THEN exit;
  FOR B:=1 TO A DO
  BEGIN
    IF EOF(f) THEN
    BEGIN
      close(f);
      exit;
    END;
    ReadLn(f,line);
  END;
  SetVar(c,varname,line);
  close(f);
END;

PROCEDURE APPEND_CMD(C:BYTE;S:STRING);
VAR f:text;filename,line,varname:STRING;a,b:WORD;
BEGIN
  IF NOT FIND(org_str,' ',filename,s) THEN exit;
  assign(f,filename);
  append(f);
  IF IORESULT<>0 THEN exit;
  WriteLn(f,ltrim(s));

  close(f);
END;

PROCEDURE SUBSTR_CMD(C:BYTE;S:STRING);
VAR s1,s2:STRING;a,b:BYTE;
BEGIN
  IF NOT find(s,' ',s1,s2) THEN exit;
  IF NOT find(ltrim(s2),' ',s2,s) THEN exit;
  val(s1,a,err);if err>0 THEN exit;
  val(s2,b,err);if err>0 THEN exit;
  s:=copy(s,a,b);
  setvar(c,'RESULT',s);
END;   

END.
