UNIT UNPROTO;

INTERFACE

  PROCEDURE SaveUI(VAR src,dest:STRING;data:STRING);
  PROCEDURE NaechstTPKMail(ch:byte);
  PROCEDURE UnprotoRedraw;
  PROCEDURE UnprotoHandleKey;
  PROCEDURE UnprotoInit;
  PROCEDURE StartTPKSF;
IMPLEMENTATION

USES IADVAR,TOOLBOX,BOXVARS,VIDEO,MYSTRING,KEYMAKRO,SCREEN,PACKET;

TYPE UnprotoListREC=RECORD
        nr:LONGINT;
        typ:CHAR;
        size:LONGINT;
        Board,Verteiler,Sender:STRING8;  
        datum:STRING6;
        title:STRINg80;
        LT:WORD;
        BID:STRING12;
        IS_HERE,REQ,REPLIED:BOOLEAN;
    END;
        
        
CONST (*HomeBBS:STRING10='';
      Path_to_homebbs:STRING='';*)
      NextNummer:LONGINT=0;
      AllowedToSync:BOOLEAN=TRUE;
      
VAR  (* Das ist ein Filedescriptor fuer das UnprotoListFile des aktuellen
        HomeBBS (es kann nur eines geben ...). Das File wird durch UnprotoInit
        AssignEd, aber nicht geffnet
     *)

     ListFile:FILE OF UnprotoListREC;
     (* Das ist der Bildschimrpuffer *)
     Liste:ARRAY[1..60] OF Unprotolistrec;
     (* Das ist der Offset von Liste[1] in der Datei *)
     PosInFile:LONGINT;
     (* Top ist die erste Zeile auf dem bildschirm *)
     Top,
     (* Loaded gibt an, wieviele Zeilen in den Puffer geladen wurden *)
     loaded:BYTE;
     (* Das ist die groesse des Bildschirmfensters in Zeilen *)
     LinesOnScreen:BYTE;  
     (* Das ist die Zeile im Fenster, die momentan markiert ist *)
     Marked:BYTE;
     
{$I-}
(* Diese Routine laedt ab einem bestimmten offset (p) genau so viele
   eintraege aus dem Unproto-List-File, wie der Bildschirmpuffer Zeilen hat.
*)   
PROCEDURE LoadList(p:LONGINT);
BEGIN
  RESET(ListFile);
  SEEK(ListFile,p);
  Loaded:=0;
  WHILE (NOT EOF(ListFile)) AND (Loaded<LinesOnScreen) DO
  BEGIN
    INC(Loaded);
    READ(ListFile,Liste[Loaded]);
  END;   
  if marked>loaded THEN marked:=loaded;
  PosInFile:=FilePos(ListFile);
  CLOSE(LiStFile);
END;  

(* Diese Routine Initialisiert die Unproto Verwaltung. Beim Start von MCUT
   oder Wechsel des HomeBBS aufrufen! *)
PROCEDURE UnprotoInit;
VAR R:UnprotoListREC;
BEGIN
  Unproto_HomeBBS:='DB0HDB-8';
   Unproto_PATH:=' DG4IAD-10 DB0HDB-10';
  ASSIGN(ListFile,qrvpath+cutssid(klein(unproto_homebbs))+'.uls');
  RESET(ListFile);
  IF IORESULT<>0 THEN 
  BEGIN
    REWRITE(ListFile);
    CLOSE(ListFile);
    exit;
  END;  
  IF FileSize(ListFile)>0 THEN
  BEGIN
    SEEK(ListFile,FileSize(ListFile)-1);
     READ(ListFile,Liste[Loaded]);
   
    NextNummer:=R.NR;
  END;
  Top:=2;
  LinesOnScreen:=_Zeilen-1;
  PosInFile:=0;
  Loaded:=0;
  Marked:=1;
  CLOSE(ListFile);
  LoadList(0);
END;

(* Das ist die obligatorische Redraw-Routine fuer die SCREEN-Unit. Muss
   exportiert werden... *)
   
PROCEDURE UnprotoRedraw;
VAR B:BYTE;F:BYTE;S:STRING;
BEGIN
  FOR B:=Top TO top+LinesOnScreen DO
  BEGIN
    IF (B-top+1)< Loaded THEN
    BEGIN 
       WITH Liste[B-Top+1] DO
       BEGIN
         IF marked=(b-top+1) THEN f:=fDlgAktiv ELSE
           f:=fDlgInAktiv;
         S:=Sender+'>'+Board+' '+Title;
         PrintS(1,b,S+StringD(' ',80-Length(S)),F);
       END; 
    END    
    ELSE PrintS(1,b,StringD(' ',80),fDlgInaktiv);
  END;
END;

TYPE BT=array[1..4] of byte;

(* SaveUI wird von der PACKET-Unit mit dem Unprotoframe, das an FBB (oder DPBOX)
   addressiert ist, aufgerufen.
*)

PROCEDURE SaveUI(VAR src,dest:STRING;data:STRING);

VAR L,R:STRING;

(* Example:
 *  12290 B    265 TEST  @DB0HDB DG4IAD 980104 test
 *)
 PROCEDURE WerteAusFBB;
 VAR B	   : BYTE;status,sum:BYTE;
    sammel : STRING80;calls:STRING8;L1:STRING;
    UR	   : UnprotoListRec;
 BEGIN
   Status:=0;
   sammel:='';
   l1:=l+' ';
   fillchar(UR,SizeOf(UnprotoListRec),0);
   WITH UR DO
   FOR B:= 1 TO LENGTH(L1) DO
   BEGIN
     if status=7 THEN title:=title+l1[b]
     ELSE
     IF (L1[B]<>' ') AND (L1[B]<>'@') THEN
       sammel:=sammel+L1[B]
     ELSE
     BEGIN
       CASE status OF
         0:BEGIN 
             sammel:=LTRIM(sammel);
             Val(sammel,nr,err);
            While (b<Length(L1)) AND (L1[b+1]=' ') DO INC(B); 
             inc(status);
           END;
         1:BEGIN
             sammel:=LTRIM(sammel);
             typ:=sammel[1];
             While (b<Length(L1)) AND (L1[b+1]=' ') DO INC(B); 
             inc(status);
           END;
         2:BEGIN
             val(sammel,size,err);
             {calls:=sammel;}
             While (b<Length(L1)) AND (L1[b+1]=' ') DO INC(B); 
             inc(status);
           END;
         3:BEGIN
             board:=sammel;
             While (b<Length(L1)) AND ((L1[b+1]=' ') OR (L1[B+1]='@')) DO INC(B); 
             inc(status);
           END;
         4:BEGIN
             verteiler:=sammel;
             While (b<Length(L1)) AND (L1[b+1]=' ') DO INC(B); 
             inc(status);
           END;
         5:BEGIN
             sender:=sammel;
             While (b<Length(L1)) AND (L1[b+1]=' ') DO INC(B); 
             inc(status);
           END;   
         6:BEGIN
             datum:=sammel;
             While (b<Length(L1)) AND (L1[b+1]=' ') DO INC(B); 
             inc(status);
           END;
       END;
       sammel:='';
     END;           
   END; 
   IF NextNummer=0 THEN NextNummer:=UR.Nr;
   IF (ur.nr=NextNummer) OR ((ur.nr>NextNummer) AND NOT AllowedToSync) THEN
   BEGIN
     IF (UR.TYP IN ['P','B','A']) THEN
     BEGIN
       Reset(ListFile);Seek(ListFile,FileSize(listfile));
       Write(ListFile,UR);Close(ListFile);
     END ELSE
     CASE UR.TYP OF
       '!': BEGIN
              IF Calls=cutssid(mycall) THEN
                NextNummer:=ur.nr;
            END;
       '/': BEGIN
              IF Calls=cutssid(mycall) THEN
                NextNummer:=ur.nr;
              AllowedToSync:=FALSE;
            END;
       '#': BEGIN NextNummer:=ur.nr END;
     END;        
     IF (ur.nr>NextNummer) AND NOT AllowedToSync THEN
       NextNummer:=ur.nr;     
     INC(NextNummer);
   END ELSE
   BEGIN
     IF AllowedToSync THEN
     BEGIN
       sum:=0;
       FOR B:=1 to 4 DO sum:=sum+bt(NextNummer)[B];
       l:=xhex(NextNummer)+Xhex(sum);
       l:='? '+stringd('0',10-length(l))+l;
       R:=Unproto_HomeBBS+Unproto_path;
       SendUnproto(mycall,R,L);        
     END;
   END;    
 END;

BEGIN
 (*IF src<>Unproto_HomeBBS THEN exit;*)
  IF copy(dest,1,3)='FBB' THEN
  BEGIN
    WHILE find(data,#13,L,data) DO WerteAusFBB;
    IF data<>'' THEN
    BEGIN
      L:=data;WerteAusFBB;
   END; 
 END;  
END;   

PROCEDURE UnprotoHandleKey;
  
  PROCEDURE WriteR;
  BEGIN
    RESET(ListFile);
    SEEK(ListFile,PosInFile+Marked-1);
     Write(ListFile,Liste[Marked]);
    CLOSE(ListFile);
  END;
BEGIN
  CASE XREADKEY OF
   #27:BEGIN
         ConsoleState:=LastConsoleState;
         RedrawScreen;
         exit;
       END;
   #32:BEGIN
         Liste[Marked].REQ:=TRUE;
         WriteR;
         inc(Marked);
         if Marked>LinesOnScreen THEN
         BEGIN
           Inc(posInFile);Dec(Marked);
           LoadList(posinfile);
         END;
       END;     
   #0:CASE XREADKEY OF
      #0:;
      END;
  END;    
END;

(* Diese Routine wird von BOXSFFBB aus aufgerufen. Sie managed den TPK-Forward.
   KS[c]^.FBBSFData^. wird mit der naechsten Mail initialisiert und der
   BBS der F< #msg Befehl geschickt. Den rest uebernehmen die normalen 
   FBB-Forward-Routinen.
*)
   
PROCEDURE NAechstTPKMail(ch:byte);
VAR R:UnprotoListRec;
BEGIN
{$IFDEF BOX}
   IF KS[ch]=NIL THEN exit;
   WITH KS[ch]^ DO
   BEGIN
     IF FBBSFData=NIL then exit;
     WITH FBBSFData^ DO
     BEGIN
       IF NOT TPKMode THEN EXIT;
       Reset(ListFile);
       SEEK(ListFile,TPKListPos);
       IF (IORESult<>0) OR (EOF(ListFile)) THEN
       BEGIN
         CLOSE(ListFile);IF IORESULT=0 THEN;
         KS[ch]^.FLags:=KS[ch]^.Flags OR KS_DISCREQ;
         exit;
       END;
       
       REPEAT
         INC(TPKListPos);
         READ(ListFile,R);
         IF EOF(ListFile) THEN
         BEGIN
           CLOSE(listFile);IF IORESULT=0 THEN;
           KS[ch]^.FLags:=KS[ch]^.Flags OR KS_DISCREQ;
           exit;
         END;
       UNTIL (R.REQ);  
    END;
  END;     
{$ENDIF}  
END;

PROCEDURE StartTPKSF;
BEGIN
   {MakeConnect(OwnBoxData^.SF_Call,HomeBBS+Unproto_PATH,61);}
END;
BEGIN

END.

